#!/usr/bin/python
# -*- coding: utf-8 -*-

import os.path
import os
import sys
import math

cwd=os.getcwd()
srcdir=cwd+'/src'
sys.path.append(srcdir)

from proc_comb import *

if __name__=='__main__':

# Check if all partial results are there
  if (not os.path.isdir('results/tree_level')) or len(os.listdir('results/tree_level'))==0:
    print 'No results for tree-level found in results/tree_level, cannot combine results.'
    sys.exit()
  elif (not os.path.isdir('results/int_sub')) or len(os.listdir('results/int_sub'))==0:
    print 'No results for integrated subtraction terms  found in results/int_sub, cannot combine results.'
    sys.exit()
  elif (not os.path.isdir('results/real_emission')) or len(os.listdir('results/real_emission'))==0:
    print 'No results for real emission terms  found in results/real_emission, cannot combine results.'
    sys.exit()        
  elif (not os.path.isdir('results/virt')) or len(os.listdir('results/virt'))==0:
    print 'No results for virtual corrections  found in results/virt, cannot combine results.'
    sys.exit() 
    

  if os.path.isdir('results/NLO') and len(os.listdir('results/virt'))>0:
    print 'Results found in results/NLO. Overwrite (y/n) ?'
    overwrite=raw_input()
    if overwrite.lower()=='n':
      sys.exit()
    
# Get total cross section
  borndir='results/tree_level'
  born_xsec, born_err = getxsec(borndir)
  realdir='results/real_emission'
  real_xsec, real_err = getxsec(realdir)  
  intdir='results/int_sub'
  int_xsec, int_err = getxsec(intdir)    
  virtdir='results/virt'
  virt_xsec, virt_err = getxsec(virtdir)    
  
  plotfile=open('tree_level/SubProcesses/plotlist.txt','r')
  
  if not os.path.isdir('results/NLO'):
    os.system('mkdir results/NLO')

# Write total xsec:
  xsecfile=open('results/NLO/xsec.dat' ,'w')
  xsecfile.write('TOTAL CROSS SECTION: \n')
  xsecfile.write('-------------------- \n')
  xsecfile.write('\n')
  xsecfile.write('Tree level: '+str(born_xsec)+ ' +- '+str(born_err)+ ' pb \n')
  xsecfile.write('Real emission: '+str(real_xsec)+ ' +- '+str(real_err)+ ' pb \n')  
  xsecfile.write('Integrated subtr.: '+str(int_xsec)+ ' +- '+str(int_err)+ ' pb \n')  
  xsecfile.write('Virtual: '+str(virt_xsec)+ ' +- '+str(virt_err)+ ' pb \n')  
  xsecfile.write('---------------------------------- \n')  
  xsecfile.write('\n')
  xsec_NLO= born_xsec+real_xsec+int_xsec+virt_xsec
  err_NLO=math.sqrt(born_err**2+real_err**2+int_err**2+virt_err**2)
  xsecfile.write('Total cross section @NLO: '+str(xsec_NLO)+' +- '+str(err_NLO)+' pb \n')
  kfactor=xsec_NLO/born_xsec
  xsecfile.write('Global K-factor: '+str(kfactor)+'\n')
  xsecfile.close()
  
  
    
    
#    Loop over all plots
  while True:
    line=plotfile.readline()
    if len(line)==0:
      break
    plot=line.split()[0]
    if not (plot.startswith('number') or plot.startswith('Weights')):
      born_int=getintegral(borndir,plot)
      real_int=getintegral(realdir,plot)
      int_int=getintegral(intdir,plot)
      virt_int=getintegral(virtdir,plot)
      born_factor=born_xsec/born_int
      real_factor=real_xsec/real_int
      int_factor=int_xsec/int_int
      virt_factor=virt_xsec/virt_int

      makebornplot(borndir,born_factor,plot)
      makenloplot(cwd,born_factor,real_factor,int_factor,virt_factor,plot)
      if plot.find('jet1')>0 and plot.find('jet2')<0 and \
         os.path.isfile(realdir+'/'+plot.replace('jet1','jet2')+'all.dat') and len(plot.split(','))>1:
        makenlo_inclusiveplot(cwd,born_factor,real_factor,int_factor,virt_factor,plot)
