      SUBROUTINE INTDIPOLESQED(P,P1,P2,X,Z,ZI,PSWGT,EPS,EPSSQ,FIN,wgt)
C
C Generated by MadGraph II
C RETURNS COEFFICIENTS OF 1/eps^2,1/eps AND FINITE TERMS
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C
C FOR PROCESS : P1_gu_aaug
C WHERE Z IS THE MOMENTUM FRACTION OF THE INITAL EMITTER/SPECTATOR.
C
      IMPLICIT NONE
      include "nexternal.inc"
      include "dipole.inc"
      include "coupl.inc"
C
C ARGUMENTS
C
      REAL*8 P(0:3,NEXTERNAL),P1(0:3,NEXTERNAL),P2(0:3,NEXTERNAL),X(2),Z,PSWGT(3)
      REAL*8 ZI,EPS,EPSSQ,FIN,wgt
C
C GLOBAL
C
      REAL*8 dot,lambda_tr,DFRAG
      LOGICAL PASSCUTSDIP,THETACUT,passcuts
      EXTERNAL dot,lambda_tr,PASSCUTSDIP,THETACUT,DFRAG,passcuts
C
C LOCAL
C
      REAL*8 sij,sik,sjk,zp,e,esq,pdfwgt(3),FINITE(3),finite_tot
      REAL*8 y_ijk,omx_ija,u_i,vtilde_i,zplus
      REAL*8 mass_i,mass_j,mass_k,mass_ij
      REAL*8 msq_i,msq_j,msq_k,msq_ij,sikzone
      REAL*8 musq_i,musq_j,musq_k,musq_ij
      REAL*8 vij,vtildeij,rho_i,rho_k,rho,qsq
      REAL*8 one,two,three,four,qtot(0:3),pi
      REAL*8 gsq,gammaE,ff,fi(9),sab,sabt
      parameter (one=1d0,two=2d0,three=3d0,four=4d0)
      REAL*8 ANS(  8)
      REAL*8 ZERO,presc(0:3,nexternal)
      INTEGER NU
      double precision u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1,u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2,g1,g2
      common /pdfarray/ u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1,u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2,g1,g2
      PARAMETER (ZERO=0D0)
      PARAMETER (gammaE=0.57721566d0)
      PARAMETER (pi=3.1415926d0)
C
C BEGIN CODE
C
      INTDIPOLE=.TRUE.
      eps=0d0
      epssq=0d0
      fin=0d0
      e=0d0
      esq=0d0
      finite_tot=0d0
      DO NU=1,3
         finite(NU)=0d0
      ENDDO
      DO NU=1,  8
         ANS(NU)=0d0
      ENDDO
      IF (PASSCUTSDIP(P,0)) THEN

c      p1(:,:)=p(:,:)
c      p2(:,:)=p(:,:)
c      p1(:,4)=p(:,4)*(zi)
c      p2(:,4)=p(:,4)*(zi)
      presc(:,:)=p(:,:)
      presc(:,4)=p(:,4)*(1d0-zi)

      mass_i=ZERO
      mass_k=ZERO
      finite(2)=0d0
      DO NU=0,3
       qtot(NU)=p(NU,4)+p(NU,3)
      ENDDO
      qsq=dot(qtot,qtot)
      CALL DIPOLEPDF(x(1),x(2),  21, 2,pdfwgt(2))
      IF (PASSCUTS(Presc)) THEN
       CALL SDIPOLQED006(P,ANS(   06))
       CALL EPSFFQED(mass_i,mass_k,qsq,zi,  1,  1, 23, -23,  1,esq,e)
      epssq=epssq-esq*ANS(  6)*pdfwgt(2)
      eps=eps-e*ANS(  6)*pdfwgt(2)
       CALL FINITEFFQED(mass_i,mass_k,qsq,zi,  1,  1, 23,  -23,  5,  1,fi)
       finite(2)=finite(2)-fi(2)*ANS(  06)*pdfwgt(2)
      IF(NCS) THEN
       IF(PHOTONFRAG) THEN
        IF (THETACUT(P,zi)) THEN
          fi(3)=fi(3)+DFRAG(ZI,2)/pdfwgt(2)*g1*u2 + DFRAG(ZI,-2)/pdfwgt(2)*g1*ub2+
     &                DFRAG(ZI,4)/pdfwgt(2)*g1*c2 + DFRAG(ZI,-4)/pdfwgt(2)*g1*cb2+
     &                1d0/16d0*(DFRAG(ZI,1)/pdfwgt(2)*g1*d2 + DFRAG(ZI,-1)/pdfwgt(2)*g1*db2+ 
     &                          DFRAG(ZI,3)/pdfwgt(2)*g1*s2 + DFRAG(ZI,-3)/pdfwgt(2)*g1*sb2+
     &                          DFRAG(ZI,5)/pdfwgt(2)*g1*b2 + DFRAG(ZI,-5)/pdfwgt(2)*g1*bb2)
	ENDIF
       ENDIF
       IF(THETACUT(P,zi)) THEN
        finite(2)=finite(2)-fi(3)*ANS(  06)*pdfwgt(2)
       ENDIF
       IF(THETACUT(P,1d0)) THEN
        finite(2)=finite(2)+fi(3)*ANS(  06)*pdfwgt(2)
       ENDIF
      ENDIF
      call writehist(presc,finite(2)*wgt)
      finite_tot=finite_tot+finite(2)
      ENDIF


      mass_i=ZERO
      mass_k=ZERO
      finite(2)=0d0
      DO NU=0,3
       qtot(NU)=p(NU,4)+p(NU,3)
      ENDDO
      qsq=dot(qtot,qtot)
      CALL DIPOLEPDF(x(1),x(2),  21, 2,pdfwgt(2))
      IF (PASSCUTS(Presc)) THEN
       CALL SDIPOLQED008(P,ANS(   08))
       CALL EPSFFQED(mass_i,mass_k,qsq,zi,  1,  1, 23, -23,  1,esq,e)
      epssq=epssq-esq*ANS(  6)*pdfwgt(2)
      eps=eps-e*ANS(  6)*pdfwgt(2)
       CALL FINITEFFQED(mass_i,mass_k,qsq,zi,  1,  1, 23,  -23,  5,  1,fi)
       finite(2)=finite(2)-fi(2)*ANS(  08)*pdfwgt(2)
      IF(NCS) THEN
       IF(PHOTONFRAG) THEN
        IF (THETACUT(P,zi)) THEN
          fi(3)=fi(3)+DFRAG(ZI,2)/pdfwgt(2)*g1*u2 + DFRAG(ZI,-2)/pdfwgt(2)*g1*ub2+
     &                DFRAG(ZI,4)/pdfwgt(2)*g1*c2 + DFRAG(ZI,-4)/pdfwgt(2)*g1*cb2+
     &                1d0/16d0*(DFRAG(ZI,1)/pdfwgt(2)*g1*d2 + DFRAG(ZI,-1)/pdfwgt(2)*g1*db2+ 
     &                          DFRAG(ZI,3)/pdfwgt(2)*g1*s2 + DFRAG(ZI,-3)/pdfwgt(2)*g1*sb2+
     &                          DFRAG(ZI,5)/pdfwgt(2)*g1*b2 + DFRAG(ZI,-5)/pdfwgt(2)*g1*bb2)
	ENDIF
       ENDIF
       IF(THETACUT(P,zi)) THEN
        finite(2)=finite(2)-fi(3)*ANS(  08)*pdfwgt(2)
       ENDIF
       IF(THETACUT(P,1d0)) THEN
        finite(2)=finite(2)+fi(3)*ANS(  08)*pdfwgt(2)
       ENDIF
      ENDIF
      call writehist(presc,finite(2)*wgt)
      finite_tot=finite_tot+finite(2)
      ENDIF


      ENDIF
      FIN=finite_tot!(FINITE(1)/z+FINITE(2))!*pswgt(1)
c      CALL WRITEHIST(P,FIN)
      INTDIPOLE=.FALSE.
      RETURN
      END

      LOGICAL FUNCTION THETACUT(P,ZI)
      IMPLICIT NONE
C This is a template for a Theta function to include
C correction terms for non-collinear-safe observables.

      include "nexternal.inc"
      include "noncoll.inc"
      REAL*8 P(0:3,nexternal),zi

C This is an empty routine so return TRUE
      if (zi.lt.zcut) then
        THETACUT=.TRUE.
      else
        THETACUT=.FALSE.
      endif

      END


