      logical function zcuts(Porig,P,njet)

      implicit none
      include 'genps.inc'
      include "nexternal.inc"
      include "cuts.inc"
      include "noncoll.inc"
      include 'run.inc'
      include 'jets.inc'


      REAL*8 R2,DOT,ET,RAP,DJ,SumDot,pt,ALPHAS,F_etmax
      logical cut_bw,setclscales, pass_bw, jetcut
      external R2,DOT,ET,RAP,DJ,SumDot,pt,ALPHAS,cut_bw,setclscales,jetcut

      double precision P(0:3, nexternal),tmp,jet1(0:3),jet2(0:3),ptemp(0:3),pjet(0:3),p1(0:3,nexternal)
      double precision Porig(0:3,nexternal), psmall(0:3)
      double precision ptjet(nexternal),xvar,ptmax1,ptmax2,htj,temp,z
      integer njet,i,j, jetspassedpt, jetspassedrap,jetspassedsmin
      integer jetspasseddR,jetspassede,jetspassedhvy,njets,hardj1,hardj2
      logical notgood,debug, foundheavy

      double precision etmin(nincoming+1:nexternal),etamax(nincoming+1:nexternal)
      double precision emin(nincoming+1:nexternal)
      double precision                    r2min(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_min(nexternal,nexternal)
      double precision etmax(nincoming+1:nexternal),etamin(nincoming+1:nexternal)
      double precision emax(nincoming+1:nexternal)
      double precision r2max(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_max(nexternal,nexternal)
      common/to_cuts/  etmin, emin, etamax, r2min, s_min,
     $     etmax, emax, etamin, r2max, s_max

C $B$ TO_SPECISA $B$ !this is a tag for MadWeight
      LOGICAL  IS_A_J(NEXTERNAL),IS_A_L(NEXTERNAL)
      LOGICAL  IS_A_B(NEXTERNAL),IS_A_A(NEXTERNAL),IS_A_ONIUM(NEXTERNAL)
      LOGICAL  IS_A_NU(NEXTERNAL),IS_HEAVY(NEXTERNAL)
      COMMON /TO_SPECISA/IS_A_J,IS_A_A,IS_A_L,IS_A_B,IS_A_NU,IS_HEAVY,
     . IS_A_ONIUM
C $E$ TO_SPECISA $E$ !this is a tag for MadWeight

      double precision ptjmin4(4),ptjmax4(4),htjmin4(2:4),htjmax4(2:4)
      logical jetor
      common/to_jet_cuts/ ptjmin4,ptjmax4,htjmin4,htjmax4,jetor
      integer        lbw(0:nexternal)  !Use of B.W.
      common /to_BW/ lbw

      logical is_jet(nexternal)
      common/jetinfo/is_jet

      double precision pp(0:3,max_particles)
      common /momenta_pp/pp

      debug=.false.
      zcuts=.true.

c  if the hardest jet fails the eta cut, remove it from the list
c      if (abs(rap(p(0,5))).gt. etamax(5)) then
c         njet=njet-1
c         p(:,5)=p(:,6)
c         p(:,6)=0d0
c      endif
c      if (njet.eq.2 .and. abs(rap(p(0,6))).gt.etamax(6)) then
c        njet=njet-1
c        p(:,6)=0d0
c      endif


c  1.possibility: 1 jet:
c   This jet needs to be tagged, therefor it mustn't be within the cone around a photon
      if (njet.eq.1) then
        if ( dsqrt(r2(p(0,3),p(0,5))) .le. Rcut .or.dsqrt(r2(p(0,4),p(0,5))) .le. Rcut ) then
          zcuts=.false.
          return

c   The second parton could be in the cone around a photon
        else
c          if (p(0,5).eq.porig(0,5)) then
c            psmall(:)=porig(:,6)
c          elseif ( p(0,5).eq.porig(0,6)) then
c            psmall(:)=porig(:,5)
c          endif
c    this situation is only relevant if the two partons haven't been combined to one jet
c    but the hardest parton is the jet on its own
c          if ( p(0,5).eq.porig(0,5) .or. p(0,5).eq.porig(0,6)) then
c            do i=3,4
c              if( dsqrt(r2(psmall,p(0,i))) .le. Rcut) then
c                z=pt(psmall)/pt(p(0,i))
c                if (z.lt.zcut) then
c                  pjet(:)=p(:,i)+psmall(:)
c                  p(:,i)=pjet(:)
c                  zcuts=jetcut(p,njet,debug)
c                  return
c                else
c                  zcuts=.false.
c                  return
c                endif
c              endif  
c            enddo
c            if (dsqrt(r2(psmall,p(0,3))) .gt. Rcut .and.dsqrt(r2(psmall,p(0,4))) .gt.Rcut ) then
c              zcuts=jetcut(p,njet,debug)
c              return
c            endif
c          else
c            zcuts=jetcut(p,njet,debug)
c            return          


c   One of the partons (doesn't matter if it belongs to the jet or not) could be
c   within the cone around the photon
         zcuts=jetcut(p,njet,debug)
         if (.not.zcuts) return

          do i=3,4
           do j=5,6
c             print*, i,j, dsqrt(r2(porig(0,i),porig(0,j)))
             if ( dsqrt(r2(porig(0,i),porig(0,j))) .le. Rcut ) then
               if ( iso_type.eq.'z_sep'  ) then
                 pjet(:)=porig(:,i)+porig(:,j)
                 z=pt(porig(0,j))/pt(pjet)
                 if (z.lt.zcut) then
                   !p(:,i)=pjet(:)
                   !if (j.eq.5) then
                   !  p(:,5)=porig(:,6)
                   !elseif (j.eq.6) then
                   !  p(:,5)=porig(:,5)
                   !endif
                   zcuts=jetcut(p,njet,debug)
                   if (.not.zcuts) return
                 else
                   zcuts=.false.
                   return
                 endif
               elseif ( iso_type.eq.'F_sep') then
                 F_etmax=F_eps*pt(p(0,i))*
     &                ((1d0-dcos(dsqrt(r2(p(0,i),porig(0,j)))))/(1d0-dcos(Rcut)))**F_exp
                 if (pt(porig(0,j)) .lt. F_etmax ) then
                   zcuts=jetcut(p,njet,debug)
                   if (.not.zcuts) return
                 else
                   zcuts=.false.
                   return
                 endif
               endif
             endif
           enddo
          enddo

        endif



c  2.possibility: 2 jets:
      elseif (njet.eq.2) then
c   if both jets are in a cone around any of the photons, the event is rejected
        if( ( dsqrt(r2(p(0,3),p(0,5))) .le. Rcut .or. dsqrt(r2(p(0,4),p(0,5))) .le.Rcut ) .and.
     &       ( dsqrt(r2(p(0,3),p(0,6))) .le. Rcut .or. dsqrt(r2(p(0,4),p(0,6))) .le.Rcut ) ) then
          zcuts=.false.
          return
c   if no jet is around a photon, check the normal cuts
        elseif ( (dsqrt(r2(p(0,3),p(0,5))) .gt. Rcut) .and. (dsqrt(r2(p(0,3),p(0,6))) .gt. Rcut) .and.
     &         (dsqrt(r2(p(0,4),p(0,5))) .gt. Rcut) .and. (dsqrt(r2(p(0,4),p(0,6))) .gt. Rcut) ) then
           zcuts=jetcut(p,njet,debug)
c   jet-veto on second jet
c           if( pt(p(0,6)).gt.50d0 .and. abs(rap(p(0,6))).lt.etamax(6)) then
c              zcuts=.false.
c           endif
           if (.not.zcuts) return
c  if one of the jets is in the cone, combine the momenta, check the zcut and the normal cuts
        else
          do i=3,4
           do j=5,6
             if (dsqrt(r2(p(0,i),p(0,j))) .le.Rcut ) then
               if ( iso_type.eq.'z_sep'  ) then
                 pjet(:)=p(:,i)+p(:,j)
                 z= pt(p(0,j))/pt(pjet)
                 if (z .lt. zcut) then
                   !p(:,i)=pjet(:)
                   !if (j.eq.5) then
                   !  p(:,5)=p(:,6)
                   !  p(:,6)=0d0
                   !elseif (j.eq.6) then
                   !  p(:,6)=0d0
                   !endif
                   zcuts=jetcut(p,njet,debug)
                   return
                 else
                  zcuts=.false.
                  return
                 endif
               elseif ( iso_type.eq.'F_sep') then
                 F_etmax=F_eps*pt(p(0,i))*
     &                ((1d0-dcos(dsqrt(r2(p(0,i),porig(0,j)))))/(1d0-dcos(Rcut)))**F_exp
                 if (pt(porig(0,j)) .lt. F_etmax ) then
                   zcuts=jetcut(p,njet,debug)
                   if (.not.zcuts) return
                 else
                   zcuts=.false.
                   return
                 endif
               endif
c    if the jet is within the cone, remove it from the list, otherwise it will be plotted
              if(j.eq.5) then
               njet=njet-1
               p(:,5)=p(:,6)
               p(:,6)=0d0
              elseif (j.eq.6) then
               njet=njet-1
               p(:,6)=0d0
              endif

             else
              zcuts=jetcut(p,njet,debug)
             endif
           enddo
          enddo   


        endif



c  3. possibility: no jet:
      elseif (njet.eq.0) then
        zcuts=.false.
        return
      endif

c  jet-veto
      if(jetveto) then
       if (njet.eq.2) then
         if(pt(p(0,6)).gt.veto_pt) then
           zcuts=.false.
           return
         endif
       elseif(njet.eq.1) then
         if (dsqrt(r2(porig(0,5), porig(0,6))).gt.Rcut) then
           if (pt(porig(0,6)).gt.veto_pt .and. pt(porig(0,5)).gt.veto_pt) then
             zcuts=.false.
             return
           endif
         endif

       endif
      endif
       

      return
      end












      logical function zcuts1(Porig,P,njet)

      implicit none
      include 'genps.inc'
      include "nexternal.inc"
      include "cuts.inc"
      include "noncoll.inc"
      include 'run.inc'
      include 'jets.inc'

      REAL*8 R2,DOT,ET,RAP,DJ,SumDot,pt,ALPHAS
      logical cut_bw,setclscales, pass_bw, jetcut
      external R2,DOT,ET,RAP,DJ,SumDot,pt,ALPHAS,cut_bw,setclscales,jetcut

      double precision P(0:3, nexternal),tmp,jet1(0:3),jet2(0:3),ptemp(0:3),pjet(0:3),p1(0:3,nexternal)
      double precision Porig(0:3,nexternal), psmall(0:3),jetp(4,nexternal)
      double precision ptjet(nexternal),xvar,ptmax1,ptmax2,htj,temp,z
      integer njet,i,j, jetspassedpt, jetspassedrap,jetspassedsmin
      integer jetspasseddR,jetspassede,jetspassedhvy,njets,hardj1,hardj2
      logical notgood,debug, foundheavy

      double precision etmin(nincoming+1:nexternal),etamax(nincoming+1:nexternal)
      double precision emin(nincoming+1:nexternal)
      double precision                    r2min(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_min(nexternal,nexternal)
      double precision etmax(nincoming+1:nexternal),etamin(nincoming+1:nexternal)
      double precision emax(nincoming+1:nexternal)
      double precision r2max(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_max(nexternal,nexternal)
      common/to_cuts/  etmin, emin, etamax, r2min, s_min,
     $     etmax, emax, etamin, r2max, s_max

C $B$ TO_SPECISA $B$ !this is a tag for MadWeight
      LOGICAL  IS_A_J(NEXTERNAL),IS_A_L(NEXTERNAL)
      LOGICAL  IS_A_B(NEXTERNAL),IS_A_A(NEXTERNAL),IS_A_ONIUM(NEXTERNAL)
      LOGICAL  IS_A_NU(NEXTERNAL),IS_HEAVY(NEXTERNAL)
      COMMON /TO_SPECISA/IS_A_J,IS_A_A,IS_A_L,IS_A_B,IS_A_NU,IS_HEAVY,
     . IS_A_ONIUM
C $E$ TO_SPECISA $E$ !this is a tag for MadWeight

      double precision ptjmin4(4),ptjmax4(4),htjmin4(2:4),htjmax4(2:4)
      logical jetor
      common/to_jet_cuts/ ptjmin4,ptjmax4,htjmin4,htjmax4,jetor
      integer        lbw(0:nexternal)  !Use of B.W.
      common /to_BW/ lbw

      logical is_jet(nexternal)
      common/jetinfo/is_jet

      double precision pp(0:3,max_particles)
      common /momenta_pp/pp

      logical p_in_j

      debug=.false.
      zcuts1=.true.


      zcuts1=jetcut(P,njet,debug)

c      do i=1,nexternal
c       p1(:,i)=0d0
c      enddo
c call modified getjets, all particlles are treated equally there, no distinction between photon and
c jets in order to get a correct clustering
c      call getjets1(P,jetp,njet,p1)



c 1. possibility: four jets, i.e. all particles are well separated.
c      if (njet.eq.4) then
c        is_jet(3)=.false.
c        is_jet(4)=.false.
c        is_jet(5)=.true.
c        is_jet(6)=.true.
c        zcuts1=jetcut(P,2,debug)
c        return

c 2. possibility: three jets:
c      elseif (njet.eq.3) then
c 2.1 the two qcd-particles were combined
c     this means none of the parton momenta is present in the jet momenta
c        if (.not. p_in_j(p,p1,5) .and. .not.p_in_j(p,p1,6)) then
c          call reorder2(p,p1,3,4)
c          is_jet(3)=.false.
c          is_jet(4)=.false.
c          is_jet(5)=.true.
c          zcuts1=jetcut(p1,1,debug)

c 2.2 
c        endif

c       print*, njet
c       print*, P(:,1)
c       print*, P(:,2)
c       print*, P(:,3)
c       print*, P(:,4)
c       print*, P(:,5)
c       print*, P(:,6)
c       print*, ' '
c       print* , 'jets vor reorder'
c       print*, p1(:,1)
c       print*, p1(:,2)
c       print*, p1(:,3)
c       print*, p1(:,4)
c       print*, p1(:,5)
c       print*, p1(:,6)      
c       print*, ' '




c       endif

      end



      logical function p_in_j(p,jet,i)
      implicit none

      include 'nexternal.inc'

      double precision p(0:3,nexternal),jet(0:3,nexternal)
      integer i,j

      p_in_j=.false.
      do j=1,nexternal
        if (p(0,i).eq.jet(0,j)) then
          p_in_j=.true.
          return
        endif
      enddo


      end

      subroutine reorder2(p,jet,i,j)
      implicit none
      
      include 'nexternal.inc'
      double precision p(0:3,nexternal),jet(0:3,nexternal),ptemp(0:3)
      integer i,j,k

      do k=1,nexternal
        if(jet(0,k).eq.p(0,i)) then
          ptemp(:)=jet(:,k)
          jet(:,k)=jet(:,i)
          jet(:,i)=ptemp(:)
        endif
        if(jet(0,k).eq.p(0,j)) then
          ptemp(:)=jet(:,k)
          jet(:,k)=jet(:,j)
          jet(:,j)=ptemp(:)
        endif
      enddo

      end






