      SUBROUTINE INTDIPOLESQED(P,P1,P2,X,Z,ZI,PSWGT,EPS,EPSSQ,FIN)
C
C Generated by MadGraph II
C RETURNS COEFFICIENTS OF 1/eps^2,1/eps AND FINITE TERMS
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C
C FOR PROCESS : P1_dc_aadc
C WHERE Z IS THE MOMENTUM FRACTION OF THE INITAL EMITTER/SPECTATOR.
C
      IMPLICIT NONE
      include "nexternal.inc"
      include "dipole.inc"
      include "coupl.inc"
C
C ARGUMENTS
C
      REAL*8 P(0:3,NEXTERNAL),P1(0:3,NEXTERNAL),P2(0:3,NEXTERNAL),X(2),Z,PSWGT(3)
      REAL*8 ZI,EPS,EPSSQ,FIN
C
C GLOBAL
C
      REAL*8 dot,lambda_tr,DFRAG
      LOGICAL PASSCUTSDIP,THETACUT
      EXTERNAL dot,lambda_tr,PASSCUTSDIP,THETACUT,DFRAG
C
C LOCAL
C
      REAL*8 sij,sik,sjk,zp,e,esq,pdfwgt(3),FINITE(3)
      REAL*8 y_ijk,omx_ija,u_i,vtilde_i,zplus
      REAL*8 mass_i,mass_j,mass_k,mass_ij
      REAL*8 msq_i,msq_j,msq_k,msq_ij,sikzone
      REAL*8 musq_i,musq_j,musq_k,musq_ij
      REAL*8 vij,vtildeij,rho_i,rho_k,rho,qsq
      REAL*8 one,two,three,four,qtot(0:3),pi
      REAL*8 gsq,gammaE,ff,fi(9),sab,sabt
      parameter (one=1d0,two=2d0,three=3d0,four=4d0)
      REAL*8 ANS(  32)
      REAL*8 ZERO
      INTEGER NU
      PARAMETER (ZERO=0D0)
      PARAMETER (gammaE=0.57721566d0)
      PARAMETER (pi=3.1415926d0)
C
C BEGIN CODE
C
      INTDIPOLE=.TRUE.
      eps=0d0
      epssq=0d0
      fin=0d0
      e=0d0
      esq=0d0
      DO NU=1,3
         finite(NU)=0d0
      ENDDO
      DO NU=1,  32
         ANS(NU)=0d0
      ENDDO
      IF (PASSCUTSDIP(P,0)) THEN

      mass_i=ZERO
      mass_k=ZERO
      DO NU=0,3
       qtot(NU)=p(NU,4)+p(NU,5)
      ENDDO
      qsq=dot(qtot,qtot)
      CALL DIPOLEPDF(x(1),x(2),  1, 4,pdfwgt(2))
      IF (PASSCUTSDIP(P,0)) THEN
       CALL SDIPOLQED020(P,ANS(   20))
      ENDIF
       CALL EPSFFQED(mass_i,mass_k,qsq,zi,  1,  1, -13, 23,  1,esq,e)
      epssq=epssq-esq*ANS(  6)*pdfwgt(2)
      eps=eps-e*ANS(  6)*pdfwgt(2)
       CALL FINITEFFQED(mass_i,mass_k,qsq,zi,  1,  1, -13,  23,  5,  1,fi)
       finite(2)=finite(2)-fi(2)*ANS(  20)*pdfwgt(2)
      IF(NCS) THEN
       IF(PHOTONFRAG) THEN
        fi(3)=fi(3)+DFRAG(ZI)
       ENDIF
       IF(THETACUT(P,zi)) THEN
        finite(2)=finite(2)-fi(3)*ANS(  20)*pdfwgt(2)
       ENDIF
       IF(THETACUT(P,1d0)) THEN
        finite(2)=finite(2)+fi(3)*ANS(  20)*pdfwgt(2)
       ENDIF
      ENDIF


      mass_i=ZERO
      mass_k=ZERO
      DO NU=0,3
       qtot(NU)=p(NU,4)+p(NU,5)
      ENDDO
      qsq=dot(qtot,qtot)
      CALL DIPOLEPDF(x(1),x(2),  1, 4,pdfwgt(2))
      IF (PASSCUTSDIP(P,0)) THEN
       CALL SDIPOLQED024(P,ANS(   24))
      ENDIF
       CALL EPSFFQED(mass_i,mass_k,qsq,zi,  1,  1, -13, 23,  1,esq,e)
      epssq=epssq-esq*ANS(  6)*pdfwgt(2)
      eps=eps-e*ANS(  6)*pdfwgt(2)
       CALL FINITEFFQED(mass_i,mass_k,qsq,zi,  1,  1, -13,  23,  5,  1,fi)
       finite(2)=finite(2)-fi(2)*ANS(  24)*pdfwgt(2)
      IF(NCS) THEN
       IF(PHOTONFRAG) THEN
        fi(3)=fi(3)+DFRAG(ZI)
       ENDIF
       IF(THETACUT(P,zi)) THEN
        finite(2)=finite(2)-fi(3)*ANS(  24)*pdfwgt(2)
       ENDIF
       IF(THETACUT(P,1d0)) THEN
        finite(2)=finite(2)+fi(3)*ANS(  24)*pdfwgt(2)
       ENDIF
      ENDIF


      mass_i=ZERO
      mass_k=ZERO
      DO NU=0,3
       qtot(NU)=p(NU,5)+p(NU,4)
      ENDDO
      qsq=dot(qtot,qtot)
      CALL DIPOLEPDF(x(1),x(2),  1, 4,pdfwgt(2))
      IF (PASSCUTSDIP(P,0)) THEN
       CALL SDIPOLQED028(P,ANS(   28))
      ENDIF
       CALL EPSFFQED(mass_i,mass_k,qsq,zi,  1,  1, 23, -13,  1,esq,e)
      epssq=epssq-esq*ANS(  6)*pdfwgt(2)
      eps=eps-e*ANS(  6)*pdfwgt(2)
       CALL FINITEFFQED(mass_i,mass_k,qsq,zi,  1,  1, 23,  -13,  6,  1,fi)
       finite(2)=finite(2)-fi(2)*ANS(  28)*pdfwgt(2)
      IF(NCS) THEN
       IF(PHOTONFRAG) THEN
        fi(3)=fi(3)+DFRAG(ZI)
       ENDIF
       IF(THETACUT(P,zi)) THEN
        finite(2)=finite(2)-fi(3)*ANS(  28)*pdfwgt(2)
       ENDIF
       IF(THETACUT(P,1d0)) THEN
        finite(2)=finite(2)+fi(3)*ANS(  28)*pdfwgt(2)
       ENDIF
      ENDIF


      mass_i=ZERO
      mass_k=ZERO
      DO NU=0,3
       qtot(NU)=p(NU,5)+p(NU,4)
      ENDDO
      qsq=dot(qtot,qtot)
      CALL DIPOLEPDF(x(1),x(2),  1, 4,pdfwgt(2))
      IF (PASSCUTSDIP(P,0)) THEN
       CALL SDIPOLQED032(P,ANS(   32))
      ENDIF
       CALL EPSFFQED(mass_i,mass_k,qsq,zi,  1,  1, 23, -13,  1,esq,e)
      epssq=epssq-esq*ANS(  6)*pdfwgt(2)
      eps=eps-e*ANS(  6)*pdfwgt(2)
       CALL FINITEFFQED(mass_i,mass_k,qsq,zi,  1,  1, 23,  -13,  6,  1,fi)
       finite(2)=finite(2)-fi(2)*ANS(  32)*pdfwgt(2)
      IF(NCS) THEN
       IF(PHOTONFRAG) THEN
        fi(3)=fi(3)+DFRAG(ZI)
       ENDIF
       IF(THETACUT(P,zi)) THEN
        finite(2)=finite(2)-fi(3)*ANS(  32)*pdfwgt(2)
       ENDIF
       IF(THETACUT(P,1d0)) THEN
        finite(2)=finite(2)+fi(3)*ANS(  32)*pdfwgt(2)
       ENDIF
      ENDIF


      ENDIF
      FIN=(FINITE(1)/z+FINITE(2))!*pswgt(1)
      CALL WRITEHIST(P,FIN)
      INTDIPOLE=.FALSE.
      RETURN
      END

      LOGICAL FUNCTION THETACUT(P,ZI)
      IMPLICIT NONE
C This is a template for a Theta function to include
C correction terms for non-collinear-safe observables.

      include "nexternal.inc"
      REAL*8 P(0:3,nexternal),zi

C This is an empty routine so return TRUE
      THETACUT=.TRUE.

      END


      REAL*8 FUNCTION DFRAG(ZI)
      IMPLICIT NONE
C This is a template for calculating the non-perturbative
C parts of the quark-to-photon fragmentation function

      include "nexternal.inc"
      REAL*8 zi

C This is an empty routine so return zero
      DFRAG=0d0

      END
