      program histol
      implicit real*8(a-h,o-z)
      character*35 fname,frooty,frooti,froote(9),frootn
      dimension ivoid(2)
      common/voidlist/iv(100),nv

      data ivoid/4,10/

      nv=0
      do i=1,nv
         iv(i) = ivoid(i)
      enddo

      minfile = 1
      maxfile = 2

      read(*,'(a)') fname
c      fname='pt(jet1).dattemp'
      call combinehisto(2,fname,minfile,maxfile)

      end


      subroutine combinehisto(inum,fname,minfile,maxfile)
      implicit real*8(a-h,o-z)
      character*35 fname
      parameter (nbins0=400,nbins1=200,nbins2=500,nbins3=50,nbins4=10)
      dimension t0(1:nbins0),t1(1:nbins1),t2(1:nbins2),
     .          t3(1:nbins3),t4(1:nbins4)
      dimension yi0(minfile:maxfile,1:nbins0)
     .         ,ei0(minfile:maxfile,1:nbins0)
     .         ,wi0(minfile:maxfile,1:nbins0)
     .         ,di0(minfile:maxfile,1:nbins0)
      dimension yi1(minfile:maxfile,1:nbins1)
     .         ,ei1(minfile:maxfile,1:nbins1)
     .         ,wi1(minfile:maxfile,1:nbins1)
     .         ,di1(minfile:maxfile,1:nbins1)
      dimension yi2(minfile:maxfile,1:nbins2)
     .         ,ei2(minfile:maxfile,1:nbins2)
     .         ,wi2(minfile:maxfile,1:nbins2)
     .         ,di2(minfile:maxfile,1:nbins2)
      dimension yi3(minfile:maxfile,1:nbins3)
     .         ,ei3(minfile:maxfile,1:nbins3)
     .         ,wi3(minfile:maxfile,1:nbins3)
     .         ,di3(minfile:maxfile,1:nbins3)
      dimension yi4(minfile:maxfile,1:nbins4)
     .         ,ei4(minfile:maxfile,1:nbins4)
     .         ,wi4(minfile:maxfile,1:nbins4)
     .         ,di4(minfile:maxfile,1:nbins4)

      if (inum.eq.0) then
      call loadhisto(nbins0,yi0,ei0,wi0,di0,t0,fname(1:16)//'a'
     .               ,minfile,maxfile)
      call writehisto(nbins0,yi0,ei0,wi0,di0,t0,fname(1:16)//'a'
     .               ,minfile,maxfile)
      call loadhisto(nbins0,yi0,ei0,wi0,di0,t0,fname(1:16)//'b'
     .               ,minfile,maxfile)
      call writehisto(nbins0,yi0,ei0,wi0,di0,t0,fname(1:16)//'b'
     .               ,minfile,maxfile)
      elseif (inum.eq.1) then
      call loadhisto(nbins1,yi1,ei1,wi1,di1,t1,fname(1:16)//'a'
     .               ,minfile,maxfile)
      call writehisto(nbins1,yi1,ei1,wi1,di1,t1,fname(1:16)//'a'
     .               ,minfile,maxfile)
      call loadhisto(nbins1,yi1,ei1,wi1,di1,t1,fname(1:16)//'b'
     .               ,minfile,maxfile)
      call writehisto(nbins1,yi1,ei1,wi1,di1,t1,fname(1:16)//'b'
     .               ,minfile,maxfile)
      elseif (inum.eq.2) then
      call loadhisto(nbins2,yi2,ei2,wi2,di2,t2,fname,minfile,maxfile)
      call writehisto(nbins2,yi2,ei2,wi2,di2,t2,fname,minfile,maxfile)
      elseif (inum.eq.3) then
      call loadhisto(nbins3,yi3,ei3,wi3,di3,t3,fname(1:16)//'a'
     .               ,minfile,maxfile)
      call writehisto(nbins3,yi3,ei3,wi3,di3,t3,fname(1:16)//'a'
     .               ,minfile,maxfile)
      call loadhisto(nbins3,yi3,ei3,wi3,di3,t3,fname(1:16)//'b'
     .               ,minfile,maxfile)
      call writehisto(nbins3,yi3,ei3,wi3,di3,t3,fname(1:16)//'b'
     .               ,minfile,maxfile)
      elseif (inum.eq.4) then
      call loadhisto(nbins4,yi4,ei4,wi4,di4,t4,fname,minfile,maxfile)
      call writehisto(nbins4,yi4,ei4,wi4,di4,t4,fname,minfile,maxfile)
c      call loadhisto(nbins4,yi4,ei4,wi4,di4,t4,fname(1:16)//'b'
c     .               ,minfile,maxfile)
c      call writehisto(nbins4,yi4,ei4,wi4,di4,t4,fname(1:16)//'b'
c     .               ,minfile,maxfile)
      endif
      return
      end


      subroutine loadhisto(nbins,yi,ei,wi,di,t,froot,minfile,maxfile)
      implicit real*8(a-h,o-z)
      integer k
      character*35 froot,fname
      dimension yi(minfile:maxfile,1:nbins)
     .         ,ei(minfile:maxfile,1:nbins)
     .         ,wi(minfile:maxfile,1:nbins)
     .         ,di(minfile:maxfile,1:nbins)
     .         ,t(1:nbins)
      common/voidlist/iv(100),nv
      
      do i=minfile,maxfile    
         iflag = 0
         do j=1,nv
            if (i.eq.iv(j)) iflag = 1
         enddo
         if (iflag.eq.1) goto 60   
c         write(fname,100) i
         k=index(froot,' ')
         if (i.lt.10) fname=froot(1:k-1)//char(48+i)
         if (i.ge.10.and.i.lt.100) 
     .             fname=froot(1:k-1)//char(i/10+48)//char(48+mod(i,10))
         if(i.ge.100) fname=froot(1:k-1)//char(i/100+48)
     &              //char((i-(i/100)*100)/10+48)
     &              //char(mod(i-(i/100)*100,10)+48)
         open(12,file=fname,status='old',position='rewind')
c         rewind(11)
         do j=1,nbins
            read(12,*) t(j),yi(i,j),ei(i,j)
            wi(i,j) = 0d0
            if (ei(i,j).ne.0d0) wi(i,j)=1d0/ei(i,j)**2
         enddo
         close(12)
 60      continue
      enddo
 100  format(i2)
      return
      end

      subroutine writehisto(nbins,yi,ei,wi,di,t,froot,minfile,maxfile)
      implicit real*8(a-h,o-z)
      character*35 froot,fname
      dimension yi(minfile:maxfile,1:nbins)
     .         ,ei(minfile:maxfile,1:nbins)
     .         ,wi(minfile:maxfile,1:nbins)
     .         ,di(minfile:maxfile,1:nbins)
      dimension t(1:nbins),ymean(1:nbins)
     .          ,wsum(1:nbins),errymean(1:nbins)
      common/voidlist/iv(100),nv

      sum = 0d0
      errsum = 0d0
      open(11,file=froot)
      do j=1,nbins
         ymean(j) = 0d0
         wsum(j) = 0d0
         do i=minfile,maxfile
            ymean(j) = ymean(j)+wi(i,j)*yi(i,j)
            wsum(j) = wsum(j)+wi(i,j)
         enddo
         if (wsum(j).ne.0d0) ymean(j) = ymean(j)/wsum(j)
         sum = sum+ymean(j)

         errymean(j) = 0d0
         do i=minfile,maxfile
            di(i,j) = yi(i,j)-ymean(j)
            errymean(j) = errymean(j)+wi(i,j)*di(i,j)**2
         enddo
         if (wsum(j).ne.0d0) errymean(j) = errymean(j)/ 
     .                real(maxfile-minfile)/wsum(j)
         errsum = errsum + errymean(j)
c         print*, 'hier',  errymean(j)
         write(11,101) t(j),ymean(j),dsqrt(errymean(j))
      enddo
      close(11)
c      write(6,*) sum/16d0,dsqrt(errsum)/16d0
 101  format(f11.5,1pe20.11,1pe20.11)
      return
      end
