#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import sys

cwd=os.getcwd()
srcdir=cwd+'/src'
sys.path.append(srcdir)

from install import *
from robo import *

VERSION = "1.0.0"
INFO = { "name": "pp_aaj", "version" : VERSION}

lhapdf='lhapdf'
fastjet='fastjet'

if __name__== "__main__" :
  if len(sys.argv)==1:
    print_info(INFO)


  elif sys.argv[1].lower()=='install':

    os.chdir(cwd)
    contrib_path=os.path.join(cwd,'gosam-contrib')    
    compile_contrib(contrib_path)
    os.chdir(cwd)
    
    virt_dir, samurai_lib, golem_lib, samurai_inc, golem_inc= get_contrib()
    lhapdf_lib, lhapdf_inc= get_path(lhapdf)
    fastjet_lib, fastjet_inc= get_path(fastjet)
    DOC=robo.RoboDocInfo('src/makefile_temp')
    write_makefile(DOC,lhapdf_lib, lhapdf_inc, fastjet_lib, fastjet_inc, virt_dir, samurai_lib, golem_lib, samurai_inc, golem_inc)
    
    DOC=robo.RoboDocInfo('src/pdfwrap.f_temp')
    write_pdfwrap(DOC,lhapdf_lib)


    os.chdir(cwd)
    compile_virt()
    os.chdir(cwd)
    compile_sub('tree_level')
    os.chdir(cwd)
    compile_sub('int_sub')
    os.chdir(cwd)
    compile_sub('real_emission')
    
  elif sys.argv[1].lower()=='uninstall':
    
    os.chdir(cwd)
    contrib_path=os.path.join(cwd,'gosam-contrib')
    clean_contrib(contrib_path)
    
    os.chdir(cwd)
    virt_dir=os.path.join(cwd,'virt','ug_aau')
    clean_virt(virt_dir)
    
    os.chdir(cwd)
    virt_dir=os.path.join(cwd,'virt','dg_aad')
    clean_virt(virt_dir)
    
    os.chdir(cwd)
    clean_sub('tree_level')
    
    os.chdir(cwd)
    clean_sub('int_sub')
    
    os.chdir(cwd)
    clean_sub('real_emission')
    
    os.chdir(cwd)
    clean_results()
