#!/usr/bin/python
# -*- coding: utf-8 -*-

import subprocess
import os
import os.path
import sys
import robo
import shutil

def print_info(info):
  print 'PROGRAM :', info['name']
  print 'VERSION :', info['version']
  print 'USAGE: ./setup.py [cmd]'
  print 'cmd: List if available commands'
  print '	INSTALL    Installs and compiles package.'
  print '       UNINSTALL  Uninstalls package, genereated files are removed.'
  print ''
  

def compile_contrib(path):
  print 'Compiling GoSam-contrib'
  os.chdir(path)
  subprocess.Popen('./configure --prefix=$PWD',shell=True).wait()
  subprocess.Popen('make', shell=True).wait()
  subprocess.Popen('make install', shell=True).wait()
  
  
  
def get_contrib():
  cwd=os.getcwd()
  virt_dir=os.path.join(cwd,'virt','ug_aau')
  path=subprocess.Popen('echo $LD_LIBRARY_PATH',shell=True,stdout=subprocess.PIPE).communicate()[0]
  if path.lower().find('gosam')>0 or path.lower().find('samurai')>0 or path.lower().find('golem95')>0:
    sub_path=path.split(':')
    for i in range(0,len(sub_path)+1):
      if sub_path[i].lower().find('gosam')>0 or sub_path[i].lower().find('samurai')>0 or sub_path[i].lower().find('golem95') >0:
        gosam_path=sub_path[i]
	break
    print 'WARNING:  A version of samurai/golem95 has been detected in ', gosam_path
    print 'This could lead problems/wrong results if you are not using the most recent version'
    print 'Press any button to continue'
    cont=raw_input()
#    samurai_lib=gosam_path
#    golem_lib=gosam_path
#    gosam_main=gosam_path.split('lib')[0]
#    gosam_inc=os.path.join(gosam_main,'include', 'gosam-contrib')
#    samurai_inc=gosam_inc
#    golem_inc=gosam_inc
  golem_path= os.path.join(cwd,'gosam-contrib')
  sysconf=subprocess.Popen('getconf LONG_BIT',shell=True,stdout=subprocess.PIPE).communicate()[0]
  sysconf=sysconf.split()[0]
  golem_inc=os.path.join(golem_path,'include/gosam-contrib')
  samurai_inc=golem_inc
  os.chdir(cwd)
  if sysconf=='64':
    golem_lib=os.path.join(golem_path,'lib64')
    samurai_lib=golem_lib
    if not os.path.isdir(golem_lib) and os.path.isdir(os.path.join(golem_path,'lib')):
      golem_lib=os.path.join(golem_path,'lib')
      samurai_lib=golem_lib
  else:
    golem_lib=os.path.join(golem_path,'lib')
    samurai_lib=golem_lib

  return virt_dir, samurai_lib, golem_lib, samurai_inc, golem_inc
  
def get_path(prg):
  prg_config=prg+'-config >& /dev/null'
  print 'Looking for ',prg,'  ...'
  status = os.system(prg_config)
  sysconf=subprocess.Popen('getconf LONG_BIT',shell=True,stdout=subprocess.PIPE).communicate()[0]
  sysconf=sysconf.split()[0]
  if sysconf=='64':
    lib='lib64'
  else:
    lib='lib'
  if status==0:
    path=subprocess.Popen(prg+'-config --prefix',shell=True,stdout=subprocess.PIPE).communicate()[0]
    path=path.split()[0]
    print 'Found ',prg 
    if os.path.isdir(os.path.join(path,'lib64')):
      lib='lib64'
    else:
      lib='lib'
    return os.path.join(path,lib), os.path.join(path,'include')
  else:
    print 'Could not find path to ',prg,', please enter correct path (full path required, no $(VARIABLE) statements possible'
    path=raw_input()
    binpath=path+'/bin/'
    if os.path.isdir(os.path.join(path,'lib64')):
      lib='lib64'
    else:
      lib='lib'
    status = os.system(binpath+prg_config)
    if os.path.isfile(binpath+prg+'-config'):
      print 'Found ', prg
      return os.path.join(path,lib), os.path.join(path,'include')
    else:
      print 'Error: ',prg, ' not found'
      
      
      
      
def write_makefile(DOC,lhapdf_lib, lhapdf_inc,fastjet_lib, fastjet_inc,virt_dir, samurai_lib, golem_lib, samurai_inc, golem_inc):
  
  f= open('src/makefile_tree','w')
  
  for line in DOC.makefile_tree(lhapdf_lib, lhapdf_inc,virt_dir,samurai_lib, golem_lib, samurai_inc, golem_inc):
    f.write(line+"\n")
  
  f.close()
  
  f= open('src/makefile_int','w')
  
  for line in DOC.makefile_int(lhapdf_lib, lhapdf_inc):
    f.write(line+"\n")
    
  f.close()
  
  f= open('src/makefile_real','w')
  
  for line in DOC.makefile_real(lhapdf_lib, lhapdf_inc, fastjet_lib, fastjet_inc):
    f.write(line+"\n")
    
  f.close()
  
  shutil.move('src/makefile_tree','tree_level/SubProcesses/makefile')
  shutil.move('src/makefile_int', 'int_sub/SubProcesses/makefile')
  shutil.move('src/makefile_real', 'real_emission/SubProcesses/makefile')
  
  f= open('src/Makefile.conf_virt','w')
  
  for line in DOC.makefileconf_virt(samurai_lib, golem_lib, samurai_inc, golem_inc):
    f.write(line+"\n")
    
  f.close()
  
  shutil.copy('src/Makefile.conf_virt','virt/ug_aau/Makefile.conf')
  shutil.move('src/Makefile.conf_virt','virt/dg_aad/Makefile.conf')
  
  
  
def write_pdfwrap(DOC, lhapdf_lib):
  
  f = open('src/pdfwrap.f','w')
  path=subprocess.Popen(lhapdf_lib+'/../bin/lhapdf-config --pdfsets-path',shell=True,stdout=subprocess.PIPE).communicate()[0]
  lhapdf=path.split('/PDFsets')[0]
  
  for line in DOC.pdf_head(lhapdf):
    f.write(line+"\n")
    
  f.close()
  
  shutil.copy('src/pdfwrap.f','tree_level/Source/PDF/')
  shutil.copy('src/pdfwrap.f','int_sub/Source/PDF/')
  shutil.move('src/pdfwrap.f','real_emission/Source/PDF/pdfwrap.f')
 
 
def compile_virt():
  cwd=os.getcwd()
  os.chdir(os.path.join(cwd,'virt','ug_aau'))
  subprocess.Popen('make compile', shell=True).wait()
  os.chdir(os.path.join(cwd,'virt','dg_aad'))
  subprocess.Popen('make compile', shell=True).wait()  
  os.chdir(cwd)
 
 
 
def compile_sub(path):
  cwd=os.getcwd()
  os.chdir(cwd)
  os.chdir(path)
  if os.path.isdir(os.path.join(cwd,path,'Source')):
    os.chdir(os.path.join(cwd,path,'Source'))
    subprocess.Popen('make', shell=True).wait()
  else:
    print 'Error: ', os.path.join(cwd,path,'Source'), ' not found.'
    sys.exit()
  
  if os.path.isdir(os.path.join(cwd,path,'SubProcesses')):
    os.chdir(os.path.join(cwd,path,'SubProcesses'))
    if os.path.isfile('compile_sub.sh'):
      subprocess.Popen('./compile_sub.sh', shell=True).wait()
    else:
      print 'Error, file compile_sub.sh not found in ', os.getcwd()
      sys.exit()
  else:
    print 'Error: ', os.path.join(path,'SubProcesses'), ' not found.'
    sys.exit()
    
  os.chdir(cwd)
  
def clean_contrib(path):
  os.chdir(path)
  subprocess.Popen('make distclean', shell=True).wait()
  share_dir=os.path.join(path,'share')
  include_dir=os.path.join(path,'include')
  libdir=os.path.join(path,'lib')
  lib64dir=os.path.join(path,'lib64')
  autotoolsdir=os.path.join(path,'autom4te.cache')
  if os.path.isdir(share_dir):
    shutil.rmtree(share_dir)
  if os.path.isdir(include_dir):
    shutil.rmtree(include_dir)
  if os.path.isdir(libdir):
    shutil.rmtree(libdir)  
  if os.path.isdir(lib64dir):
    shutil.rmtree(lib64dir)
  if os.path.isdir(autotoolsdir):
    shutil.rmtree(autotoolsdir)
  
def clean_virt(path):
  os.chdir(path)
  subprocess.Popen('make clean', shell=True).wait()

  
  
def clean_sub(path):
  cwd=os.getcwd()
  os.chdir(cwd)
  os.chdir(path)
  os.system('rm lib/*.a')
  source_dir= os.path.join(cwd,path,'Source')
  os.chdir(source_dir)
  os.system('./clean_source.sh')
  sub_dir=os.path.join(cwd,path,'SubProcesses')
  os.chdir(sub_dir)
  os.system('./clean_sub.sh')
  
  
def clean_results():
  cwd=os.getcwd()
  res_dir=os.path.join(cwd,'results')
  if os.path.isdir(res_dir):
    os.chdir(res_dir)
    tree_dir=os.path.join(res_dir,'tree_level')
    int_dir=os.path.join(res_dir,'int_sub')
    real_dir=os.path.join(res_dir,'real_emission')
    virt_dir=os.path.join(res_dir,'virt')
    nlo_dir=os.path.join(res_dir,'NLO')
    if os.path.isdir(tree_dir):
      shutil.rmtree(tree_dir)
      os.mkdir('tree_level')
    if os.path.isdir(int_dir):
      shutil.rmtree(int_dir)
      os.mkdir('int_sub')
    if os.path.isdir(real_dir):
      shutil.rmtree(real_dir)
      os.mkdir('real_emission')
    if os.path.isdir(virt_dir):
      shutil.rmtree(virt_dir)
      os.mkdir('virt')      
    if os.path.isdir(nlo_dir):
      shutil.rmtree(nlo_dir)
  else:
    print 'Error: results directory does not exist. '
    sys.exit()
  
  
  
