      DOUBLE PRECISION FUNCTION DSIG(PP,WGT)
C ****************************************************
C Generated by MadGraph II                                              
C     RETURNS DIFFERENTIAL CROSS SECTION
C     Input:
C             pp    4 momentum of external particles
C             wgt   weight from Monte Carlo
C     Output:
C             Amplitude squared and summed
C ****************************************************
      IMPLICIT NONE
C  
C CONSTANTS
C  
      include "genps.inc"
      include "nexternal.inc"
      DOUBLE PRECISION       CONV
      PARAMETER (CONV=389379.66*1000)  !CONV TO PICOBARNS
      REAL*8     PI
      PARAMETER (PI=3.1415926d0)
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION PP(0:3,NEXTERNAL), WGT
C  
C LOCAL VARIABLES 
C  
      INTEGER I, ICROSS,ITYPE,LP
      DOUBLE PRECISION P1(0:3,NEXTERNAL)
      DOUBLE PRECISION u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1
      DOUBLE PRECISION u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2
      DOUBLE PRECISION g1,g2
      DOUBLE PRECISION a1,a2
      DOUBLE PRECISION XPQ(-7:7)
      DOUBLE PRECISION DSIGUU
C  
C EXTERNAL FUNCTIONS
C  
      LOGICAL PASSCUTS
      DOUBLE PRECISION ALPHAS2,REWGT,PDG2PDF
C  
C GLOBAL VARIABLES
C  
      INTEGER              IPROC
      DOUBLE PRECISION PD(0:MAXPROC)
      COMMON /SubProc/ PD, IPROC
      include "coupl.inc"
      include "run.inc"

      integer Ntot,Nnonzero
      real*8  checkxsec
      common /nmc/ Ntot,Nnonzero,checkxsec

C  
C DATA
C  
      DATA u1,ub1,d1,db1,c1,cb1,s1,sb1,b1,bb1/10*1d0/
      DATA u2,ub2,d2,db2,c2,cb2,s2,sb2,b2,bb2/10*1d0/
      DATA a1,g1/2*1d0/
      DATA a2,g2/2*1d0/
      DATA IPROC,ICROSS/1,1/
C ----------
C BEGIN CODE
C ----------
      DSIG = 0D0
      IF (PASSCUTS(PP)) THEN
         IF (ABS(LPP(1)) .GE. 1) THEN
            LP=SIGN(1,LPP(1))
             d1= PDG2PDF(ABS(LPP(1)), 1*LP,XBK(1),DSQRT(Q2FACT(1)))
             s1= PDG2PDF(ABS(LPP(1)), 3*LP,XBK(1),DSQRT(Q2FACT(1)))  
             c1= PDG2PDF(ABS(LPP(1)), 4*LP,XBK(1),DSQRT(Q2FACT(1))) 
             u1= PDG2PDF(ABS(LPP(1)), 2*LP,XBK(1),DSQRT(Q2FACT(1)))
             b1= PDG2PDF(ABS(LPP(1)), 5*LP,XBK(1),DSQRT(Q2FACT(1)))
             db1= PDG2PDF(ABS(LPP(1)),-1*LP,XBK(1),DSQRT(Q2FACT(1)))
             sb1= PDG2PDF(ABS(LPP(1)),-3*LP,XBK(1),DSQRT(Q2FACT(1)))
             cb1= PDG2PDF(ABS(LPP(1)),-4*LP,XBK(1),DSQRT(Q2FACT(1)))              
             ub1= PDG2PDF(ABS(LPP(1)),-2*LP,XBK(1),DSQRT(Q2FACT(1)))
             bb1= PDG2PDF(ABS(LPP(1)),-5*LP,XBK(1),DSQRT(Q2FACT(1)))
         ENDIF
         IF (ABS(LPP(2)) .GE. 1) THEN
            LP=SIGN(1,LPP(2))
             d2= PDG2PDF(ABS(LPP(2)), 1*LP,XBK(2),DSQRT(Q2FACT(2)))               
             u2= PDG2PDF(ABS(LPP(2)), 2*LP,XBK(2),DSQRT(Q2FACT(2)))
             s2= PDG2PDF(ABS(LPP(2)), 3*LP,XBK(2),DSQRT(Q2FACT(2)))               
             c2= PDG2PDF(ABS(LPP(2)), 4*LP,XBK(2),DSQRT(Q2FACT(2)))
             b2= PDG2PDF(ABS(LPP(2)), 5*LP,XBK(2),DSQRT(Q2FACT(2)))
             db2= PDG2PDF(ABS(LPP(2)),-1*LP,XBK(2),DSQRT(Q2FACT(2)))               
             ub2= PDG2PDF(ABS(LPP(2)), -2*LP,XBK(2),DSQRT(Q2FACT(2)))
             sb2= PDG2PDF(ABS(LPP(2)),-3*LP,XBK(2),DSQRT(Q2FACT(2)))               
             cb2= PDG2PDF(ABS(LPP(2)),-4*LP,XBK(2),DSQRT(Q2FACT(2)))
             bb2= PDG2PDF(ABS(LPP(2)),-5*LP,XBK(2),DSQRT(Q2FACT(2)))
         ENDIF
         PD(0) = 0d0
         IPROC = 0
         IPROC=IPROC+1      ! d d~ -> a a g                              
         PD(IPROC)= d1*db2+db1*d2+s1*sb2+sb1*s2+b1*bb2+bb1*b2+
     &          16d0*(u1*ub2+ub1*u2+c1*cb2+cb1*c2)                                
          CALL SMATRIX(PP,DSIGUU)                                              
         dsiguu=dsiguu*rewgt(PP)
         If (dsiguu .lt. 1d199) then
             dsig = pd(IPROC) * conv * dsiguu
         else
             write(*,*) "Error in matrix element"
             dsiguu=0d0
             dsig = 0d0
         endif
c         call unwgt(pp,pd(iproc)*conv*dsiguu*wgt)
          Nnonzero=Nnonzero+1
          checkxsec=checkxsec+pd(iproc)*conv*dsiguu*wgt
         call write_me_hist(pp,pd(iproc)*conv*dsiguu*wgt)
      ENDIF
      END
