      subroutine Zoom_Event(wgt,p)
C**************************************************************************
C     Determines if region needs to be investigated in case of large
c     weight events.
C**************************************************************************
      IMPLICIT NONE
c
c     Constant
c
      integer    max_zoom
      parameter (max_zoom=2000)
      include 'genps.inc'
      include 'nexternal.inc'

c
c     Arguments
c
      double precision wgt, p(0:3,nexternal)
c
c     Local
c
      double precision xstore(2),gstore,qstore(2)
      double precision trunc_wgt, xsum, wstore,pstore(0:3,nexternal)
      integer ix, i,j

C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw
      integer nzoom
      double precision  tx(1:3,maxinvar)
      common/to_xpoints/tx, nzoom
      double precision xzoomfact
      common/to_zoom/  xzoomfact
      include 'run.inc'
      include 'coupl.inc'
c
c     DATA
c
      data trunc_wgt /-1d0/
      data xsum/0d0/
      data wstore /0d0/
      save ix, pstore, wstore, xstore, gstore, qstore
c-----
c  Begin Code
c-----
      if (trunc_Wgt .lt. 0d0 .and. twgt .gt. 0d0) then
         write(*,*) 'Selecting zoom level', twgt*500, wgt
      endif
      if (twgt .lt. 0d0) then
         write(*,*) 'Resetting zoom iteration', twgt
         twgt = -twgt
         trunc_wgt = twgt * 500d0
      endif
      if (nw .eq. 0) then
         trunc_wgt = twgt * 500d0
      endif
      trunc_wgt=max(trunc_wgt, twgt*500d0)
      if (nzoom .eq. 0 .and. trunc_wgt .gt. 0d0 ) then
         if (wgt .gt. trunc_wgt) then
            write(*,*) 'Zooming on large event ',wgt / trunc_wgt
            wstore=wgt
            do i=1,nexternal
               do j=0,3
                  pstore(j,i) = p(j,i)
               enddo
            enddo
            do i=1,2
               xstore(i)=xbk(i)
               qstore(i)=q2fact(i)
            enddo
            gstore=g
            xsum = wgt
            nzoom = max_zoom
            wgt=0d0
            ix = 1
         endif
      elseif (trunc_wgt .gt. 0 .and. wgt .gt. 0d0) then
         xsum = xsum + wgt
         if (nzoom .gt. 1) wgt = 0d0
         ix = ix + 1
      endif
      if (xsum .ne. 0d0 .and. nzoom .le. 1) then
         if (wgt .gt. 0d0) then
c            xzoomfact = xsum/real(max_zoom) / wgt !Store avg wgt
            xzoomfact = wstore / wgt  !Store large wgt
         else
            xzoomfact = -xsum/real(max_zoom)
         endif
         wgt = max(xsum/real(max_zoom),trunc_wgt)  !Don't make smaller then truncated wgt
         do i=1,nexternal
            do j=0,3
               p(j,i) = pstore(j,i)
            enddo
         enddo
         do i=1,2
            xbk(i)=xstore(i)
            q2fact(i)=qstore(i)
         enddo
         g=gstore
         write(*,'(a,2e15.3,2f15.3, i8)') 'Stored wgt ',
     $            wgt/trunc_wgt, wstore, wstore/wgt, real(ix)/max_zoom, ix
         trunc_wgt = max(trunc_wgt, wgt)
         xsum = 0d0
         nzoom = 0
      endif
      end

      subroutine clear_events
c-------------------------------------------------------------------
c     delete all events thus far, start from scratch
c------------------------------------------------------------------
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'nexternal.inc'
c
c     Global
c
      integer iseed, nover, nstore
C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw

c-----
c  Begin Code
c-----
c      write(*,*) 'storing Events'
      call store_events
      rewind(lun)
      nw = 0
      maxwgt = 0d0
      end

      SUBROUTINE unwgt(px,wgt)
C**************************************************************************
C     Determines if event should be written based on its weight
C**************************************************************************
      IMPLICIT NONE
c
c     Constants
c
      include 'genps.inc'
      include 'nexternal.inc'
c
c     Arguments
c
      double precision px(0:3,nexternal),wgt
c
c     Local
c
      integer idum, i,j
      double precision uwgt,yran,fudge, p(0:3,nexternal), xwgt
C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw

      double precision    matrix
      common/to_maxmatrix/matrix

      logical               zooming
      common /to_zoomchoice/zooming

c
c     External
c
      real xran1
      external xran1
c
c     Data
c
      data idum/-1/
      data yran/1d0/
      data fudge/10d0/
C-----
C  BEGIN CODE
C-----
      if (twgt .ge. 0d0) then
         do i=1,nexternal
            do j=0,3
               p(j,i)=px(j,i)
            enddo
         enddo
         xwgt = wgt
         if (zooming) call zoom_event(xwgt,P)
         if (xwgt .eq. 0d0) return
         yran = xran1(idum)
         if (xwgt .gt. twgt*fudge*yran) then
            uwgt = max(xwgt,twgt*fudge)
            if (twgt .gt. 0) uwgt=uwgt/twgt/fudge
c            call write_event(p,uwgt)
c            write(29,'(2e15.5)') matrix,wgt
c $B$ S-COMMENT_C $B$
            call write_leshouche(p,uwgt)
         elseif (xwgt .gt. 0d0 .and. nw .lt. 5) then
            call write_leshouche(p,wgt/twgt*1d-6)
c $E$ S-COMMENT_C $E$
         endif
         maxwgt=max(maxwgt,xwgt)
      endif
      end

      subroutine store_events()
C**************************************************************************
C     Takes events from scratch file (lun) and writes them to a permanent
c     file  events.dat
C**************************************************************************
      IMPLICIT NONE
c
c     Constants
c
      include 'genps.inc'
      include 'nexternal.inc'
      double precision trunc_max
      parameter       (trunc_max = 0.01)  !Maximum % cross section to truncate
c
c     Arguments
c
c
c     Local
c
      integer i, lunw, ic(7,2*nexternal-3), n, j
      logical done
      double precision wgt,p(0:4,2*nexternal-3)
      double precision xsec,xerr,xscale,xtot
      double precision xsum, xover
      double precision target_wgt,orig_Wgt(maxevents)
      logical store_event(maxevents)
      integer iseed, nover, nstore
      double precision scale,aqcd,aqed
      integer ievent
      character*140 buff
C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw

      integer                   neventswritten
      common /to_eventswritten/ neventswritten
c      save neventswritten

      integer ngroup
      common/to_group/ngroup

c
c     external
c
      real xran1

      data iseed/0/
      data neventswritten/0/
C-----
C  BEGIN CODE
C-----
c
c     First scale all of the events to the total cross section
c
      if (nw .le. 0) return
      call sample_result(xsec,xerr)
      if (xsec .le. 0) return             ! Fix by TS Dec 03/2010
      xtot=0
      call dsort(nw, swgt)
      do i=1,nw
         xtot=xtot+swgt(i)
      enddo
c
c     Determine minimum target weight given truncation parameter
c
      xsum = 0d0
      i = nw
      do while (xsum-swgt(i)*(nw-i) .lt. xtot*trunc_max .and. i .gt. 2)
         xsum = xsum + swgt(i)
         i = i-1
      enddo
      if (i .lt. nw) i=i+1
      target_wgt = swgt(i)
c
c     Select events which will be written
c
      xsum = 0d0
      nstore = 0
      rewind(lun)
      done = .false. 
      do i=1,nw
         if (.not. done) then
            call read_event(lun,P,wgt,n,ic,ievent,scale,aqcd,aqed,buff,done)
         else
            wgt = 0d0
         endif
         if (wgt .gt. target_wgt*xran1(iseed)) then
            xsum=xsum+max(wgt,target_Wgt)
            store_event(i)=.true.
            nstore=nstore+1
         else
            store_event(i) = .false.
         endif
      enddo
      xscale = xsec/xsum
      target_wgt = target_wgt*xscale
      rewind(lun)
      if (nstore .le. neventswritten) then
         write(*,*) 'No improvement in events',nstore, neventswritten
         return
      endif
      lunw = 25
      open(unit = lunw, file='events.lhe', status='unknown')
      done = .false.
      i=0      
      xtot = 0
      xover = 0
      nover = 0
      do j=1,nw
         if (.not. done) then
            call read_event(lun,P,wgt,n,ic,ievent,scale,aqcd,aqed,buff,done)
         else
            write(*,*) 'Error done early',j,nw
         endif
         if (store_event(j) .and. .not. done) then
            wgt=wgt*xscale
            wgt = max(wgt, target_wgt)
            if (wgt .gt. target_wgt) then
               xover = xover + wgt - target_wgt
               nover = nover+1
            endif
            xtot = xtot + wgt
            i=i+1
            call write_Event(lunw,p,wgt,n,ic,ngroup,scale,aqcd,aqed,buff)
         endif
      enddo
      write(*,*) 'Found ',nw,' events.'
      write(*,*) 'Wrote ',i ,' events.'
      write(*,*) 'Correct xsec ',xsec
      write(*,*) 'Event xsec ', xtot
      write(*,*) 'Events wgts > 1: ', nover
      write(*,*) '% Cross section > 1: ',xover, xover/xtot*100.
      neventswritten = i
 99   close(lunw)
c      close(lun)
      end

      SUBROUTINE write_leshouche(p,wgt)
C**************************************************************************
C     Writes out information for event
C**************************************************************************
      IMPLICIT NONE
c
c     Constants
c
      double precision zero
      parameter       (ZERO = 0d0)
      include 'genps.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'message.inc'
      include 'cluster.inc'
      include 'run.inc'
c
c     Arguments
c
      double precision p(0:3,nexternal),wgt
c
c     Local
c
      integer i,j,k
      double precision sum_wgt,sum_wgt2, xtarget,targetamp(maxflow)
      integer ip, np, ic, nc, jpart(7,-nexternal+3:2*nexternal-3)
      integer ida(2),ito(-nexternal+3:nexternal),ns,nres,ires,icloop
      integer iseed
      double precision pboost(0:3),pb(0:4,-nexternal+3:2*nexternal-3),eta
      double precision ptcltmp(nexternal)

      integer idup(nexternal,maxproc)
      integer mothup(2,nexternal,maxproc)
      integer icolup(2,nexternal,maxflow)

      integer isym(nexternal,99), nsym, jsym

      double precision sscale,aaqcd,aaqed
      integer ievent,npart

      real ran1
      external ran1

      character*140 buff

C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw

      integer              IPROC 
      DOUBLE PRECISION PD(0:MAXPROC)
      COMMON /SubProc/ PD, IPROC

      Double Precision amp2(maxamps), jamp2(0:maxflow)
      common/to_amps/  amp2,       jamp2

      character*79       hel_buf
      common/to_helicity/hel_buf

      integer           mincfig, maxcfig
      common/to_configs/mincfig, maxcfig

      integer ngroup
      common/to_group/ngroup

c
c     Data
c
      include 'leshouche.inc'
      data iseed /0/

      double precision pmass(nexternal)
      common/to_mass/  pmass

c      integer ncols,ncolflow(maxamps),ncolalt(maxamps)
c      common/to_colstats/ncols,ncolflow,ncolalt,ic
c      data ncolflow/maxamps*0/
c      data ncolalt/maxamps*0/

      include 'symswap.inc'
      include 'coupl.inc'
C-----
C  BEGIN CODE
C-----
      
      if (nw .ge. maxevents) return
      nw = nw+1
      swgt(nw)=wgt
      sum_wgt=sum_wgt+wgt
      sum_wgt2=sum_wgt2+wgt**2
c
c     First choose a process  iproc comes set to the number of processes
c
      if(ickkw.gt.0)then
        ip = iprocset
      else
        np = iproc
        xtarget=ran1(iseed)*pd(np)
        ip = 1
        do while (pd(ip) .lt. xtarget .and. ip .lt. np)
          ip=ip+1
        enddo
      endif
      
c
c     Now choose a color flow
c
      nc = jamp2(0)
c      ncols=jamp2(0)
      if(nc.gt.0)then
        targetamp(1)=jamp2(1)
        do ic =2,nc
          targetamp(ic) = jamp2(ic)+targetamp(ic-1)
        enddo
        xtarget=ran1(iseed)*targetamp(nc)
        ic = 1
        do while (targetamp(ic) .lt. xtarget .and. ic .lt. nc)
          ic=ic+1
        enddo
c        ncolflow(ic)=ncolflow(ic)+1
      endif
c
c     In case of identical particles symmetry, choose assignment
c
      xtarget = ran1(iseed)*nsym
      jsym = 1
      do while (xtarget .gt. jsym .and. jsym .lt. nsym)
         jsym = jsym+1
      enddo
c
c     Fill jpart color and particle info
c
      do i=1,nexternal
         jpart(1,isym(i,jsym)) = idup(i,ip)
         jpart(2,isym(i,jsym)) = mothup(1,i,ip)
         jpart(3,isym(i,jsym)) = mothup(2,i,ip)
         jpart(4,isym(i,jsym)) = icolup(1,i,ic)
         jpart(5,isym(i,jsym)) = icolup(2,i,ic)
         jpart(6,isym(i,jsym)) = 1
      enddo
      do i=1,nincoming
         jpart(6,isym(i,jsym))=-1
      enddo

c   Set helicities
c      write(*,*) 'Getting helicity',hel_buf(1:50)
      read(hel_buf,'(15i5)') (jpart(7,isym(i, jsym)),i=1,nexternal)
c      write(*,*) 'ihel',jpart(7,1),jpart(7,2)

c   Fix ordering of ptclus
      do i=1,nexternal
        ptcltmp(isym(i,jsym)) = ptclus(i)
      enddo
      do i=1,nexternal
        ptclus(i) = ptcltmp(i)
      enddo

c
c     Boost momentum to lab frame
c
      pboost(0)=1d0
      pboost(1)=0d0
      pboost(2)=0d0
      pboost(3)=0d0
      if (xbk(2)*xbk(1) .gt. 0d0) then
         eta = sqrt(xbk(1)*ebeam(1)/(xbk(2)*ebeam(2)))
         pboost(0)=p(0,1)*(eta + 1d0/eta)
         pboost(3)=p(0,1)*(eta - 1d0/eta)
      else
         write(*,*) 'Warning bad x1 or x2 in write_leshouche',
     $           xbk(1),xbk(2)
      endif
      do j=1,nexternal
         call boostx(p(0,j),pboost,pb(0,isym(j,jsym)))
c      Add mass information in pb(4)
         pb(4,isym(j,jsym))=pmass(j)
      enddo

c
c     Add info on resonant mothers
c
      call addmothers(ip,jpart,pb,isym,jsym,sscale,aaqcd,aaqed,buff,npart)

c
c     Write events to lun
c
c      write(*,*) 'Writing event'
      if(q2fact(1).gt.0.and.q2fact(2).gt.0)then
         sscale = (q2fact(1)*q2fact(2))**0.25
      else if(q2fact(1).gt.0)then
         sscale = sqrt(q2fact(1))
      else if(q2fact(2).gt.0)then
         sscale = sqrt(q2fact(2))
      else
         sscale = 0d0
      endif
      aaqcd = g*g/4d0/3.1415926d0
      aaqed = gal(1)*gal(1)/4d0/3.1415926d0

      if (btest(mlevel,3)) then
        write(*,*)' write_leshouche: SCALUP to: ',sscale
      endif
      
      
      call write_event(lun,pb(0,1),wgt,npart,jpart(1,1),ngroup,
     &   sscale,aaqcd,aaqed,buff)
      if(btest(mlevel,1))
     &   call write_event(6,pb(0,1),wgt,npart,jpart(1,1),ngroup,
     &   sscale,aaqcd,aaqed,buff)

      end
      
      integer function n_unwgted()
c************************************************************************
c     Determines the number of unweighted events which have been written
c************************************************************************
      implicit none
c
c     Parameter
c
      include 'genps.inc'
      include 'nexternal.inc'
c
c     Local
c
      integer i
      double precision xtot, sum
C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw
c-----
c  Begin Code
c-----

c      write(*,*) 'Sorting ',nw
      if (nw .gt. 1) call dsort(nw,swgt)
      sum = 0d0
      do i=1,nw
         sum=sum+swgt(i)
      enddo
      xtot = 0d0
      i = nw
      do while (xtot .lt. sum/100d0 .and. i .gt. 2)    !Allow for 1% accuracy
         xtot = xtot + swgt(i)
         i=i-1
      enddo
      if (i .lt. nw) i = i+1
c      write(*,*) 'Found ',nw,' events'
c      write(*,*) 'Integrated weight',sum
c      write(*,*) 'Maximum wgt',swgt(nw), swgt(i)
c      write(*,*) 'Average wgt', sum/nw
c      write(*,*) 'Unweight Efficiency', (sum/nw)/swgt(i)
      n_unwgted = sum/swgt(i)
c      write(*,*) 'Number unweighted ',sum/swgt(i), nw
      if (nw .ge. maxevents) n_unwgted = -sum/swgt(i)
      end


      subroutine dsort(n,ra)
      integer n
      double precision ra(n)

      l=n/2+1
      ir=n
10    continue
        if(l.gt.1)then
          l=l-1
          rra=ra(l)
        else
          rra=ra(ir)
          ra(ir)=ra(1)
          ir=ir-1
          if(ir.eq.1)then
            ra(1)=rra
            return
          endif
        endif
        i=l
        j=l+l
20      if(j.le.ir)then
          if(j.lt.ir)then
            if(ra(j).lt.ra(j+1))j=j+1
          endif
          if(rra.lt.ra(j))then
            ra(i)=ra(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        go to 20
        endif
        ra(i)=rra
      go to 10
      end

      SUBROUTINE write_me(p,wgt)
C**************************************************************************
C     Writes out information for event
C**************************************************************************
      IMPLICIT NONE
c
c     Constants
c
      double precision zero
      parameter       (ZERO = 0d0)
      include 'genps.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
c      integer    maxamps
c      parameter (maxamps=2500)
c      integer    maxflow
c      parameter (maxflow=2)
      include 'message.inc'
      include 'cluster.inc'
      include 'run.inc'
c
c     Arguments
c
      double precision p(0:3,nexternal),wgt
c
c     Local
c
      integer i,j,k
      double precision sum_wgt,sum_wgt2, xtarget,targetamp(maxamps)
      integer ip, np, ic, nc, jpart(7,-nexternal+3:2*nexternal-3)
      integer ida(2),ito(-nexternal+3:nexternal),ns,nres,ires,icloop
      integer iseed
      double precision pboost(0:3),pb(0:4,-nexternal+3:2*nexternal-3),eta

      integer idup(nexternal,maxproc)
      integer mothup(2,nexternal,maxproc)
      integer icolup(2,nexternal,maxflow)

      integer isym(nexternal,99), nsym, jsym

      double precision sscale,aaqcd,aaqed
      integer ievent,npart

      real ran1
      external ran1

      character*140 buff

C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw

      integer              IPROC 
      DOUBLE PRECISION PD(0:MAXPROC)
      COMMON /SubProc/ PD, IPROC

      Double Precision amp2(maxamps), jamp2(0:maxflow)
      common/to_amps/  amp2,       jamp2

      character*79       hel_buf
      common/to_helicity/hel_buf

      integer           mincfig, maxcfig
      common/to_configs/mincfig, maxcfig

      integer ngroup
      common/to_group/ngroup
      character*2 filenumber
      common /evtfile/ filenumber

c
c     Data
c
      include 'leshouche.inc'
      data iseed /0/

      double precision pmass(nexternal)
      common/to_mass/  pmass

c      integer ncols,ncolflow(maxamps),ncolalt(maxamps)
c      common/to_colstats/ncols,ncolflow,ncolalt,ic
c      data ncolflow/maxamps*0/
c      data ncolalt/maxamps*0/

      include 'symswap.inc'
      include 'coupl.inc'
C-----
C  BEGIN CODE
C-----
c      print*, 'in write_me'
      open(unit=10,file='events.lhe'//filenumber,status='unknown',access='append')

      if (nw .ge. maxevents) return
      nw = nw+1
      swgt(nw)=wgt
      sum_wgt=sum_wgt+wgt
      sum_wgt2=sum_wgt2+wgt**2
c
c     First choose a process  iproc comes set to the number of processes
c
      np = iproc
      xtarget=ran1(iseed)*pd(np)
      ip = 1
      do while (pd(ip) .lt. xtarget .and. ip .lt. np)
        ip=ip+1
      enddo
      
c
c     Now choose a color flow
c
      nc = jamp2(0)
c      ncols=jamp2(0)
      if(nc.gt.0)then
        targetamp(1)=jamp2(1)
        do ic =2,nc
          targetamp(ic) = jamp2(ic)+targetamp(ic-1)
        enddo
        xtarget=ran1(iseed)*targetamp(nc)
        ic = 1
        do while (targetamp(ic) .lt. xtarget .and. ic .lt. nc)
          ic=ic+1
        enddo
c        ncolflow(ic)=ncolflow(ic)+1
      endif
c
c     In case of identical particles symmetry, choose assignment
c
      xtarget = ran1(iseed)*nsym
      jsym = 1
      do while (xtarget .gt. jsym .and. jsym .lt. nsym)
         jsym = jsym+1
      enddo
c
c     Fill jpart color and particle info
c
      do i=1,nexternal
         jpart(1,isym(i,jsym)) = idup(i,ip)
         jpart(2,isym(i,jsym)) = mothup(1,i,ip)
         jpart(3,isym(i,jsym)) = mothup(2,i,ip)
         jpart(4,isym(i,jsym)) = icolup(1,i,ic)
         jpart(5,isym(i,jsym)) = icolup(2,i,ic)
         jpart(6,isym(i,jsym)) = 1
      enddo
      do i=1,nincoming
         jpart(6,isym(i,jsym))=-1
      enddo

c      write(*,*) 'Getting helicity',hel_buf(1:50)
      read(hel_buf,'(15i5)') (jpart(7,i),i=1,nexternal)
c      write(*,*) 'ihel',jpart(7,1),jpart(7,2)

c
c     Boost momentum to lab frame
c
      pboost(0)=1d0
      pboost(1)=0d0
      pboost(2)=0d0
      pboost(3)=0d0
      if (xbk(2)*xbk(1) .gt. 0d0) then
         eta = sqrt(xbk(1)*ebeam(1)/(xbk(2)*ebeam(2)))
         pboost(0)=p(0,1)*(eta + 1d0/eta)
         pboost(3)=p(0,1)*(eta - 1d0/eta)
      else
         write(*,*) 'Warning bad x1 or x2 in write_leshouche',
     $           xbk(1),xbk(2)
      endif
      do j=1,nexternal
         call boostx(p(0,j),pboost,pb(0,isym(j,jsym)))
c      Add mass information in pb(4)
         pb(4,isym(j,jsym))=pmass(j)
      enddo
c
c     Add info on resonant mothers
c
      call addmothers(ip,jpart,pb,isym,jsym,sscale,aaqcd,aaqed,buff,npart)

c
c     Write events to lun
c
c      write(*,*) 'Writing event'
      if(q2fact(1).gt.0.and.q2fact(2).gt.0)then
         sscale = (q2fact(1)*q2fact(2))**0.25
      else if(q2fact(1).gt.0)then
         sscale = sqrt(q2fact(1))
      else if(q2fact(2).gt.0)then
         sscale = sqrt(q2fact(2))
      else
         sscale = 0d0
      endif
      aaqcd = g*g/4d0/3.1415926d0
      aaqed = gal(1)*gal(1)/4d0/3.1415926d0

      if (btest(mlevel,3)) then
        write(*,*)' write_leshouche: SCALUP to: ',sscale
      endif
      
      call write_event(10,pb(0,1),wgt,npart,jpart(1,1),ngroup,
     &   sscale,aaqcd,aaqed,buff)
c      if(btest(mlevel,1))
c     &   call write_event(6,pb(0,1),wgt,npart-1,jpart(1,1),ngroup,
c     &   sscale,aaqcd,aaqed,buff)
      close(10)
      end



      SUBROUTINE write_me_hist(p1,wgt)
      implicit none
      include 'genps.inc'
      include 'nexternal.inc'
      include 'info.inc'
      include 'run.inc'
      double precision P1(0:3,nexternal)
      include 'maxamps.inc'
c      integer    maxamps
c      parameter (maxamps=2500)
c      integer    maxflow
c      parameter (maxflow=999)

      integer nfinal,ictemp(MaxParticles),next,ic(7,MaxParticles)
      integer ievent,nevent,npar,i,idn(maxparticles),k,j,checkwght,ip,np,nc
      integer jpart(7,-nexternal+3:2*nexternal-3),ic1
      character*130 infile
      character*140 buff2
      logical done,firsttime
      data firsttime/.true./
      double precision P(0:4,MaxParticles),wgt,pmiss(0:3),P2(0:4,MaxParticles),wgt2
      double precision aqcd,aqed,sumw,sumpw,sum,mxwgt,targetamp(maxamps)
      double precision ptv(maxparticles),ordering,pt,mEt,xtarget
      real*8 sump,mxwgtp
      integer idup(nexternal,maxproc)
      integer mothup(2,nexternal,maxproc)
      integer icolup(2,nexternal,maxflow)

      integer maxclass,maxevparticles,partoclass(-300:300,0:Maxparticles)
      integer maxevpart(0:maxclasses),neventp,neventcut
      common/classes/maxclass,maxevparticles,partoclass,maxevpart
      logical lhe,unweighted
      common/fileformat/lhe,unweighted
      double precision awgt
      common/ne/sum,awgt,nevent

      integer nhisto,maxbin,iseed
      parameter(nhisto=100,maxbin=500)
      double precision hmin(nhisto), hwidth(nhisto),ibin(nhisto)
      common /hispar/hmin,hwidth,ibin 
      double precision itmax1,itmax2,nshota,nshotb,nshotc,nshotd,nshote
      common /runinfo/itmax1,itmax2,nshota,nshotb,nshotc,nshotd,nshote

      logical passcuts,decayed
      double precision et
      common/plot_decayed/decayed

c      integer filenumber
c      common/file/ filenumber

      double precision bin(nhisto,4,maxbin),xbin(nhisto,4)
      common/bins/ bin,xbin
      double precision pboost(0:3),pb(0:4,-nexternal+3:2*nexternal-3),eta
      double precision pmass(nexternal)
      common/to_mass/  pmass
      integer isym(nexternal,99), nsym, jsym
      real ran1
      external ran1
      integer              IPROC 
      DOUBLE PRECISION PD(0:MAXPROC)
      COMMON /SubProc/ PD, IPROC
      character*79       hel_buf
      common/to_helicity/hel_buf
      Double Precision amp2(maxamps), jamp2(0:maxflow)
      common/to_amps/  amp2,       jamp2
      include 'symswap.inc'
      data iseed /0/

      include 'leshouche.inc'


c      print*, 'in write_hist'

c
c     First choose a process  iproc comes set to the number of processes
c
      np = iproc
      xtarget=ran1(iseed)*pd(np)
      ip = 1
      do while (pd(ip) .lt. xtarget .and. ip .lt. np)
        ip=ip+1
      enddo
c
c     Now choose a color flow
c
      nc = jamp2(0)
c      ncols=jamp2(0)
      if(nc.gt.0)then
        targetamp(1)=jamp2(1)
        do ic1 =2,nc
          targetamp(ic1) = jamp2(ic1)+targetamp(ic1-1)
        enddo
        xtarget=ran1(iseed)*targetamp(nc)
        ic1 = 1
        do while (targetamp(ic1) .lt. xtarget .and. ic1 .lt. nc)
          ic1=ic1+1
        enddo
c        ncolflow(ic)=ncolflow(ic)+1
      endif
c
c     In case of identical particles symmetry, choose assignment
c
      xtarget = ran1(iseed)*nsym
      jsym = 1
      do while (xtarget .gt. jsym .and. jsym .lt. nsym)
         jsym = jsym+1
      enddo
c
c     Fill jpart color and particle info
c
c      print*, 'nexternal',nexternal
      do i=1,nexternal!-1
         jpart(1,isym(i,jsym)) = idup(i,1)
         jpart(2,isym(i,jsym)) = mothup(1,i,ip)
         jpart(3,isym(i,jsym)) = mothup(2,i,ip)
         jpart(4,isym(i,jsym)) = icolup(1,i,ic1)
         jpart(5,isym(i,jsym)) = icolup(2,i,ic1)
         jpart(6,isym(i,jsym)) = 1
         ic(1,i)=idup(i,1)
         ic(2,i)=mothup(1,i,ip)
         ic(3,i)=mothup(2,i,ip)
         ic(4,i)=icolup(1,i,ic1)
         ic(5,i)=icolup(2,i,ic1)
         ic(6,i)=1
      enddo
      do i=1,nincoming
         jpart(6,isym(i,jsym))=-1
         ic(6,i)=-1
      enddo

c      write(*,*) 'Getting helicity',hel_buf(1:50)
      read(hel_buf,'(15i5)') (jpart(7,i),i=1,nexternal)
c      write(*,*) 'ihel',jpart(7,1),jpart(7,2)

c
c     Boost momentum to lab frame
c
      pboost(0)=1d0
      pboost(1)=0d0
      pboost(2)=0d0
      pboost(3)=0d0
      if (xbk(2)*xbk(1) .gt. 0d0) then
         eta = sqrt(xbk(1)*ebeam(1)/(xbk(2)*ebeam(2)))
         pboost(0)=p1(0,1)*(eta + 1d0/eta)
         pboost(3)=p1(0,1)*(eta - 1d0/eta)
      else
         write(*,*) 'Warning bad x1 or x2 in write_leshouche',
     $           xbk(1),xbk(2)
      endif
c      print*, xbk(1),xbk(2),eta
      do j=1,nexternal!-1
c        print*, j, isym(j,jsym)
         call boostx(p1(0,j),pboost,pb(0,isym(j,jsym)))
c      Add mass information in pb(4)
         pb(4,isym(j,jsym))=pmass(j)
      enddo



      do j=1,nexternal
       do i=0,3
        p(i,j)=pb(i,j)
       enddo
        p(4,j)=0d0
      enddo
      do j=nexternal+1,maxparticles
        do i=0,4
         p(i,j)=0d0
        enddo
      enddo
c     
c     remove decayed resonances from particle listing if .not.decayed and parton level events
c     
            nfinal=nexternal
            if (lhe)then
               do i=nexternal-2,1,-1
                  if(ic(6,i).ne.1.and.(.not.decayed.or.ic(6,i).ne.2))then
c     $              .or.pt(p(0,i)).lt.ptminclass(partoclass(ic(1,i),1))) then
                     do j=i+1,nfinal
                        do k=1,7
                           ic(k,j-1)=ic(k,j)
                        enddo
                        do k=0,4
                           P(k,j-1)=P(k,j)
                        enddo
                     enddo
                     nfinal=nfinal-1
                  endif
               enddo
             else
               do i=nexternal,1,-1
                  if(partoclass(ic(1,i),1).gt.0.and.
     $               pt(p(0,i)).lt.ptminclass(partoclass(ic(1,i),1))) then
                     do j=i+1,nfinal
                        do k=1,7
                           ic(k,j-1)=ic(k,j)
                        enddo
                        do k=0,4
                           P(k,j-1)=P(k,j)
                        enddo
                     enddo
                     nfinal=nfinal-1
                  endif
               enddo
            endif


            do i=1,nfinal
               ictemp(i)=MOD(ic(1,i),1000000)+ic(1,i)/1000000*100
            enddo
           do i=0,maxclasses
               do j=1, maxparticles
                  if (eventinfo(i,j).ne.0) eventinfo(i,j)=0
               enddo
            enddo
            do i=1,nfinal
              if (partoclass(ictemp(i),0).ge.1)then
                  do j=1,partoclass(ictemp(i),0)
                     k=1
                     do while(eventinfo(partoclass(ictemp(i),j),k).ne.0)
                        k=k+1
                     enddo
                     eventinfo(partoclass(ictemp(i),j),k)=i  
                  enddo
               endif
            enddo
c
c     Order particles in vector per class -> Uses the ordering function to order
c
            do i=0,maxclass         
               npar=1
               do while (npar.le.maxparticles.and.eventinfo(i,npar).ne.0)
                     ptv(npar)=ordering(p(0,eventinfo(i,npar)))
                     idn(npar)=eventinfo(i,npar)
                    npar=npar+1
               enddo
               if (npar-1.gt.1)then
                  call sort2(ptv,idn,npar-1)
                  do k=1,npar-1
                     eventinfo(i,k)=idn(k)
                  enddo
               endif
            enddo
c
c For the missing ET class (mET) we have to calculated the missing ET
c
            if (maxevpart(0).ge.1) then
               do j=0,3
                  pmiss(j)=0d0
               enddo
               do k=1,maxevpart(0)
                  do j=0,3
                     pmiss(j)=pmiss(j)+p(j,eventinfo(0,k))
                  enddo
               enddo
               mET=pt(pmiss) !Missing Et
            else
               mET=0d0
            endif


            neventp=neventp+1

      call graph_event(p,wgt,mET)


c      close(98)
      end


      subroutine get_classes
c###################################################################
c Get all classes and max number of particles
c and matrix with all particle info
c###################################################################
      implicit none
      include 'info.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'genps.inc'


      integer nfinal,ic(7,MaxParticles),ictemp(MaxParticles)
      double precision P(0:4,MaxParticles),wgt,sum,wgt1
      integer ievent,idn(maxparticles),neventcut,npar
      double precision scale,aqcd,aqed,pmiss(0:3),pt,sump,ptv(maxparticles),ordering
      logical done
      data done/.false./

      character*25 classesfile
      character*4 classname(0:maxclasses),buffclass
      character*15 plotname
      character*7 test,output
      character*140 buff2,buffer
      character*18 dum
      character*3 ordering_function
      common/ordering_func/ordering_function
      logical found_ordering_function
      integer iname(maxparticles),l1
      logical foundallclasses, foundallparticles,firsttime
      integer nclass,nparticles,class(0:maxclasses,maxparticles)
      integer maxparticlesinclass(0:maxclasses),evpartinclass(0:maxclasses)
      integer partoclass(-300:300,0:maxparticles),maxevpart(0:maxclasses)
      integer maxevparticles,maxclass,avpart
      integer beginclasses,endclasses,beginoptions,endoptions
      integer plot,plotclass
      integer i,j,k,l,m
      logical lhe,unweighted
      common/classes/maxclass,maxevparticles,partoclass,maxevpart
      common/fileformat/lhe,unweighted
      logical decayed
      common/plot_decayed/decayed
      character*4 id(-300:300)
      common/to_id/id
      data classesfile/'ma_card.dat'/

      integer idup(nexternal,maxproc)
      integer mothup(2,nexternal,maxproc)
      integer icolup(2,nexternal,maxflow)

      include 'leshouche.inc'


      lhe=.true.


      write (*,*) "Classes will be read from file: ./ma_card.dat"
      open(unit=97,file=classesfile,status='old')

      call set_id



      rewind(97)
 61   read(97,'(a)',end=90,err=90)buffer
      if(buffer(1:18).eq. "# Begin PlotOutput ")then
 60      read(97,'(a)')buffer
            if (buffer(1:16).eq. "# End PlotOutput ") goto 63 ! End of PlotOptions
            l1=40
            if(index(buffer,"#").ne.0) l1=index(buffer,"#")-1 ! ignore comments
            read(buffer(1:l1),*,end=62,err=62) plotname,output
 62         continue
            if (plotname(1:6).eq.'output') then
               if (output(1:7).eq.'gnuplot')then
                  gnu=.true.
               else
                  gnu=.false.
               endif
            elseif (plotname(1:12).eq.'plot_decayed') then
               if (output(1:3).eq.'yes')then
                  decayed=.true.
               else
                  decayed=.false.
               endif
            endif
         goto 60  !Not yet at end of PlotOptions -> Read next line
 63      continue !Found all PlotOptions ->  continue here
      endif     
      goto 61   !Go back to beginning to read next line
 90   continue  !End of file -> continue






      do i=0,maxclasses
         do j=1,maxparticles
            class(i,j)=0
         enddo
      enddo
      nclass=0
      m=0
      rewind(97)
 10   read (97,'(a)',end=76,err=76) buffer
      if(buffer(1:16).eq. "# Begin Classes ")then
 43      read (97,'(a)') buffer
            if (buffer(1:14).eq. "# End Classes ") goto 44 ! End of classes list
            l1=40
            if(index(buffer,"#").ne.0) l1=index(buffer,"#")-1 ! ignore comments
            nclass=nclass+1
            read(buffer(1:l1),*,end=11,err=11) classname(nclass),(class(nclass,i),i=1,maxparticles)
 11         continue
ccc   Missing ET class (mET) is special. Also remove empty classes from the list
            if (classname(nclass).eq.'mET')then !missing ET class is special
               classname(0)='mET'
               do i=1,maxparticles
                  class(0,i)=class(nclass,i)
               enddo
               if (class(0,1).eq.0) then !empty missing ET class
                  maxparticlesinclass(0)=0
               else
                  l=1
                  do while (class(0,l).ne.0) !find all particles in missing ET class
                     maxparticlesinclass(0)=l
                     l=l+1
                  enddo
               endif
               nclass=nclass-1
            elseif (class(nclass,1).eq.0 !empty class, remove from list
     &              .and.classname(nclass).ne.'mET')then !if it is not the mET class
               nclass=nclass-1
            endif
            l=1
            do while (class(nclass,l).ne.0) !find all particles in class
               maxparticlesinclass(nclass)=l
               l=l+1
            enddo
         goto 43   ! Go back to read class from list
 44      continue  ! Found all classes in list -> continue here
      endif
      goto 10      ! Go back to beginning to read next line of the file 
 76   continue     ! Continue here when at end of file
c Make sure that the missing ET class exists
      if (classname(0).ne.'mET')then
         classname(0)='mET'
         maxparticlesinclass(0)=0
         if (.not.lhe) then     ! for the .lhco file add the 'neutrino' to this class
            maxparticlesinclass(0)=1
            class(0,1)=12
         endif
      endif
c      write (*,*) nclass

c      do i=1,nclass
c         write (*,*) classname(i),(class(i,j),j=1,maxparticlesinclass(i))
c      enddo
      
 45   foundallclasses=.true.

      write (*,*) 'Found the following classes in input classes file:'
      if (nclass.ne.0)then
         do i=0,nclass
            do j=1,maxparticlesinclass(i)
               class(i,j)=MOD(class(i,j),1000000)+class(i,j)/1000000*100
            enddo
            write (*,'(2x,a7,i2,a3,3x,a4,30(i4))')
     &           'class #',i,' is',classname(i),(class(i,j),j=1,maxparticlesinclass(i))
         enddo
      else
         write (*,*)'None, no classes specified in ',classesfile
      endif



c
c Find the ordering function from the ma_card.dat
c
      found_ordering_function=.false.
      rewind(97)
 89   read (97,'(a)',end=92,err=92) buffer
      if (buffer(1:18).eq.'ordering_function ')then
         read (buffer,*) dum, ordering_function
         found_ordering_function=.true.
         write(52,*)'ordering function for particles in classes: ',ordering_function
         goto 92
      endif
      goto 89
 92   continue
      if(.not.found_ordering_function.or.(
     & ordering_function.ne.'pt '.and.
     & ordering_function.ne.'et '.and.
     & ordering_function.ne.'e '.and.
     & ordering_function.ne.'X1 '.and.
     & ordering_function.ne.'X2 '.and.
     & ordering_function.ne.'X3 '      ))then
         write(52,*)'no valid ordering function found in ma_card,'
         write(52,*)'Using the default, pt'
         ordering_function='pt '
      endif
C      write (*,*) ordering_function

c
c Find normalization
c
      rewind(97)
c      normalization=0
c 189   read (97,'(a)',end=192,err=192) buffer
c      if (buffer(1:14).eq.'normalization ')then
c         read (buffer,*,err=192) dum, normalization
c         write(52,*)'normalization for histograms: ',normalization
c         goto 192
c      endif
c      goto 189
c 192  continue
c      if(normalization.eq.0)
c     $   write(52,*)'histograms normalized according to cross section'

c
c read all events to fill the classes
c
c      write (*,*) "Now start parsing events a first time"
      do i=0,maxclasses
         maxevpart(i)=0
      enddo
      firsttime=.true.


c
c     Fill jpart color and particle info
c
      do i=1,nexternal
         ic(1,i) = idup(i,1)
         ic(2,i) = 0!mothup(1,i,ip)
         ic(3,i) = 0!mothup(2,i,ip)
         ic(4,i) = 0!icolup(1,i,ic)
         ic(5,i) = 0!icolup(2,i,ic)
         ic(6,i) = 1
      enddo
      do i=1,nincoming
         ic(6,i)=-1
      enddo

      unweighted=.false.

c
c     remove decayed resonances from particle listing if .not.decayed and parton level events
c
c      print*, 'hier in get classes', nexternal
         nfinal=nexternal
         if (lhe)then
            do i=nexternal-2,1,-1
              if(ic(6,i).ne.1.and.(.not.decayed.or.ic(6,i).ne.2)) then
                  do j=i+1,nfinal
                     do k=1,7
                        ic(k,j-1)=ic(k,j)
                     enddo
                     do k=0,4
                        P(k,j-1)=P(k,j)
                     enddo
                  enddo
                  nfinal=nfinal-1
               endif
            enddo
         endif
c For Susy particles:
         do i=1,nfinal
            ictemp(i)=MOD(ic(1,i),1000000)+ic(1,i)/1000000*100
         enddo
c
c Compare the particles in the events with the classes
c
         do i=0,nclass
            evpartinclass(i)=0
         enddo
         do i=1,nfinal
            k=0
            do j=0,nclass
               do l=1,maxparticlesinclass(j)
c                  write (*,*) ictemp(i),class(j,l)
                  if (ictemp(i).eq.class(j,l)) then
                     k=k+1
                     partoclass(ictemp(i),0) = k
                     partoclass(ictemp(i),k) = j
                     evpartinclass(j) = evpartinclass(j)+1
c                     write (*,*)ictemp(i),partoclass(ictemp(i),1)
                     maxevpart(j)=max(maxevpart(j),evpartinclass(j))
c                     if (maxevpart(j).ge.)write (*,*) j,maxevpart(j)
                  endif
               enddo
            enddo
            if (k.eq.0) then !particle does not fit in existing class -> create new class
               nclass=nclass+1
               if (nclass.gt.maxclasses)then
                  write (*,*) '---------------------- -----------------'
                  write (*,*) 'Error! Too many classes, max is',MaxClasses
                  write (*,*) '----------------------------------------'
               endif
               class(nclass,1)=ictemp(i)
               classname(nclass)=id(ictemp(i))
               partoclass(ictemp(i),0) = 1
               partoclass(ictemp(i),1) = nclass
               maxparticlesinclass(nclass)=1
               maxevpart(nclass)=1
        write (*,*)'created new class ',classname(nclass),'for particle',ictemp(i)
            endif
         enddo

      
      maxclass=nclass

      maxevparticles=0
      avpart=0
      do i=0,nclass
         maxevparticles=maxevparticles+maxevpart(i)
         avpart=max(maxevpart(i),avpart)
c      write (*,*) i,maxevpart(i)
      enddo
      if (maxevparticles.gt.maxparticles)then
         write (*,*) '-------------------------------------------------'
         write (*,*) 'Error! Too many particles, max is',MaxParticles
         write (*,*) 'You have',maxevparticles,' particles.'
         write (*,*) 'Try grouping more particles together in one class'
         write (*,*) '-------------------------------------------------'
      else
      write(52,*)'Final states contain',maxevparticles,
     &                                ' different particles.'
      endif

c
c     Give all classes and particles appropriate names
c
      k=1
      do i=0,maxclasses
         call no_spaces1(classname(i),iname(i))
         do j=1,maxevpart(i)
            lname(i,j)=iname(i)
            name(i,j)(1:lname(i,j))=classname(i)
            if(maxevpart(i).ge.1.and.j.le.9)then
               lname(i,j)=lname(i,j)+1
               name(i,j)(lname(i,j):lname(i,j))=char(48+j)
            elseif (j.gt.9)then
               lname(i,j)=lname(i,j)+1
               name(i,j)(lname(i,j):lname(i,j))=char(49)
               lname(i,j)=lname(i,j)+1
               name(i,j)(lname(i,j):lname(i,j))=char(38+j)
            endif
      write (52,'(a10,x,i2,a2,a6,3x,a15,i2)')'particle #',k,': ',name(i,j)(1:lname(i,j)),
     &           'fits in class #',i
            k=k+1
         enddo
      enddo


c
c     Read plotting options from ma_card.dat
c
      plot=0
      plotclass=0
      delta_phiplot(0)=0
      plotname=''
      do i=1,maxclasses
         ptplot(i)=0
         etplot(i)=0
         eplot(i)=0
         momplot(i)=0
         etaplot(i)=0
         yplot(i)=0
         costhplot(i)=0
         phiplot(i)=0
         X1plot(i)=0
         X2plot(i)=0
         X3plot(i)=0
         dRijplot(i)=0
         mijplot(i)=0
         cosijplot(i)=0
         delta_phiplot(i)=0
         delta_etaplot(i)=0
         kTijplot(i)=0
         XY1plot(i)=0
         XY2plot(i)=0
         XY3plot(i)=0
         XYZ1plot(i)=0
         XYZ2plot(i)=0
         XYZ3plot(i)=0
         XYZA1plot(i)=0
         XYZA2plot(i)=0
         XYZA3plot(i)=0
      enddo
      rewind(97)
 51   read(97,'(a)',end=80,err=80)buffer
      if(buffer(1:17).eq. "# Begin PlotDefs ")then
 50      read(97,'(a)')buffer
            if (buffer(1:15).eq. "# End PlotDefs ") goto 53 ! End of PlotOptions
            l1=40
            if(index(buffer,"#").ne.0) l1=index(buffer,"#")-1 ! ignore comments
            read(buffer(1:l1),*,end=52,err=52) plotname,plotclass,plot
 52         continue
            if (plotname(1:3).eq.'pt ')then
               ptplot(plotclass)=plot
            elseif (plotname(1:3).eq.'et ')then
               etplot(plotclass)=plot
            elseif (plotname(1:2).eq.'e ')then
               eplot(plotclass)=plot
            elseif (plotname(1:4).eq.'mom ')then
               momplot(plotclass)=plot
            elseif (plotname(1:4).eq.'eta ')then
               etaplot(plotclass)=plot
            elseif (plotname(1:2).eq.'y ')then
               yplot(plotclass)=plot
            elseif (plotname(1:6).eq.'costh ')then
               costhplot(plotclass)=plot
            elseif (plotname(1:4).eq.'phi ')then
               phiplot(plotclass)=plot
            elseif (plotname(1:3).eq.'X1 ')then
               X1plot(plotclass)=plot
            elseif (plotname(1:3).eq.'X2 ')then
               X2plot(plotclass)=plot
            elseif (plotname(1:3).eq.'X3 ')then
               X3plot(plotclass)=plot
            elseif (plotname(1:5).eq.'dRij ')then
               dRijplot(plotclass)=plot
            elseif (plotname(1:4).eq.'mij ')then
               mijplot(plotclass)=plot
            elseif (plotname(1:6).eq.'cosij ')then
               cosijplot(plotclass)=plot
            elseif (plotname(1:10).eq.'delta_phi ')then
               delta_phiplot(plotclass)=plot
            elseif (plotname(1:10).eq.'delta_eta ')then
               delta_etaplot(plotclass)=plot
            elseif (plotname(1:5).eq.'kTij ')then
               kTijplot(plotclass)=plot
            elseif (plotname(1:4).eq.'XY1 ')then
               XY1plot(plotclass)=plot
            elseif (plotname(1:4).eq.'XY2 ')then
               XY2plot(plotclass)=plot
            elseif (plotname(1:4).eq.'XY3 ')then
               XY3plot(plotclass)=plot
            elseif (plotname(1:5).eq.'XYZ1 ')then
               XYZ1plot(plotclass)=plot
            elseif (plotname(1:5).eq.'XYZ2 ')then
               XYZ2plot(plotclass)=plot
            elseif (plotname(1:5).eq.'XYZ3 ')then
               XYZ3plot(plotclass)=plot
            elseif (plotname(1:6).eq.'XYZA1 ')then
               XYZA1plot(plotclass)=plot
            elseif (plotname(1:6).eq.'XYZA2 ')then
               XYZA2plot(plotclass)=plot
            elseif (plotname(1:6).eq.'XYZA3 ')then
               XYZA3plot(plotclass)=plot
            endif
         goto 50  !Not yet at end of PlotOptions -> Read next line
 53      continue !Found all PlotOptions ->  continue here
      endif     
      goto 51   !Go back to beginning to read next line
 80   continue  !End of file -> continue

      rewind(98)
      close(98)
      end


      subroutine histo_init
c*************************************************************************
c     Set up graphing
c*************************************************************************
      implicit none
      include 'info.inc'
c
c     LOCAL
c
      integer i,j,l,npar,ntot,k,n,m,a,b,c,d
      character*1 cparti,cpartj
      character*50 title(maxparticles)
      common/to_title/title
c
c     Global
c
      integer nexternal
      character*4 id(-300:300)
      common/to_id/id
      integer maxclass,maxevparticles,partoclass(-300:300,0:MaxParticles)
      integer maxevpart(0:maxclasses),maxpart(0:maxclasses)
      common/classes/maxclass,nexternal,partoclass,maxevpart

      integer nhisto,maxbin
      parameter(nhisto=100,maxbin=500)
      double precision hmin(nhisto), hwidth(nhisto),ibin(nhisto)
      common /hispar/hmin,hwidth,ibin 
      double precision itmax1,itmax2,nshota,nshotb,nshotc,nshotd,nshote
      common /runinfo/itmax1,itmax2,nshota,nshotb,nshotc,nshotd,nshote

      double precision bin(nhisto,4,maxbin),xbin(nhisto,4)
      common/bins/ bin,xbin


      call setplotrange
C
      print*,'Setting up graphs'
c

      write (52,*)''
      write (52,*)'plots set up:'

C
C     PLOTS 
C
      l=0      !counter of the number of plots
c-- weight
      l=l+1
      title(l)='Weights'
c      write (52,*) title
c      call mbook(l,title,0.02d0,-0.1d0,1.5d0)
      call histoi(l,-1d0,1d0,100)
c-- counts
      do i=1,maxclass
         if (maxevpart(i).ge.1)then
            l=l+1
            title(l)='number'//name(i,1)(1:lname(i,1)-1)
c      write (52,*) title
c            call mbook(l,title,1d0,-0.5d0,10.5d0)
          call histoi(l,-0.5d0,9.5d0,10)
         endif
      enddo
c-- Ht
      l=l+1
      title(l)='Ht'
c      write (52,*) title
c      call mbook(l,title,htrange(1),htrange(2),htrange(3))
      call histoi(l,htrange(2),htrange(3),100)

c-- Missing ET
      if (maxevpart(0).ge.1) then
         l=l+1
         title(l)='MissingET'
c      write (52,*) title
c         call mbook(l,title,etmissrange(1),etmissrange(2),etmissrange(3))
      call histoi(l,etmissrange(2),etmissrange(3),100)
      endif
c-- pt
      do i=1, maxclass 
         if (ptplot(i).ne.0) then
            j=1
            do while (j.le.ptplot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='pt('//name(i,j)(1:lname(i,j))//')'
c      write (52,*) title
c               call mbook(l,title,ptrange(1),ptrange(2),ptrange(3))
                call histoi(l,ptrange(2),ptrange(3),100)
               j=j+1
            enddo
         endif
      enddo
c-- et
      do i=1, maxclass 
         if (etplot(i).ne.0) then
            j=1
            do while (j.le.etplot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='et('//name(i,j)(1:lname(i,j))//')'
c      write (52,*) title
c               call mbook(l,title,etrange(1),etrange(2),etrange(3))
               call histoi(l,etrange(2),etrange(3),100)
               j=j+1
            enddo
         endif
      enddo
c-- e
      do i=1, maxclass 
         if (eplot(i).ne.0) then
            j=1
            do while (j.le.eplot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='e('//name(i,j)(1:lname(i,j))//')'
c      write (52,*) title
c               call mbook(l,title,erange(1),erange(2),erange(3))
               call histoi(l,erange(2),erange(3),100)
               j=j+1
            enddo
         endif
      enddo
c-- momentum
      do i=1, maxclass 
         if (momplot(i).ne.0) then
            j=1
            do while (j.le.momplot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='mom|'//name(i,j)(1:lname(i,j))//'|'
c      write (52,*) title
c               call mbook(l,title,momrange(1),momrange(2),momrange(3))
               call histoi(l,momrange(2),momrange(3),100)
               j=j+1
            enddo
         endif
      enddo
c-- pseudo-rapidity eta
      do i=1, maxclass 
         if (etaplot(i).ne.0) then
            j=1
            do while (j.le.etaplot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='eta('//name(i,j)(1:lname(i,j))//')'
c      write (52,*) title
c               call mbook(l,title,etarange(1),etarange(2),etarange(3))
               call histoi(l,etarange(2),etarange(3),100)
               j=j+1
            enddo
         endif
      enddo
c-- rapidity y
      do i=1, maxclass 
         if (yplot(i).ne.0) then
            j=1
            do while (j.le.yplot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='y('//name(i,j)(1:lname(i,j))//')'
c      write (52,*) title
c               call mbook(l,title,yrange(1),yrange(2),yrange(3))
               call histoi(l,yrange(2),yrange(3),100)
               j=j+1
            enddo
         endif
      enddo
c-- cos theta
      do i=1, maxclass 
         if (costhplot(i).ne.0) then
            j=1
            do while (j.le.costhplot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='costh('//name(i,j)(1:lname(i,j))//')'
c      write (52,*) title
c               call mbook(l,title,costhrange(1),costhrange(2),costhrange(3))
                call histoi(l,costhrange(2),costhrange(3),100)
               j=j+1
            enddo
         endif
      enddo
c-- azymuthal phi
      do i=1, maxclass 
         if (phiplot(i).ne.0) then
            j=1
            do while (j.le.phiplot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='phi('//name(i,j)(1:lname(i,j))//')'
c      write (52,*) title
c               call mbook(l,title,phirange(1),phirange(2),phirange(3))
               call histoi(l,phirange(2),phirange(3),100)
               j=j+1
            enddo
         endif
      enddo
c-- User defined
      do i=1, maxclass 
         if (X1plot(i).ne.0) then
            j=1
            do while (j.le.X1plot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='X1('//name(i,j)(1:lname(i,j))//')'
c      write (52,*) title
c               call mbook(l,title,X1range(1),X1range(2),X1range(3))
                call histoi(l,X1range(2),X1range(3),100)
               j=j+1
            enddo
         endif
      enddo
      do i=1, maxclass 
         if (X2plot(i).ne.0) then
            j=1
            do while (j.le.X2plot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='X2('//name(i,j)(1:lname(i,j))//')'
c      write (52,*) title
c               call mbook(l,title,X2range(1),X2range(2),X2range(3))
                call histoi(l,X2range(2),X2range(3),100)
               j=j+1
            enddo
         endif
      enddo
      do i=1, maxclass 
         if (X3plot(i).ne.0) then
            j=1
            do while (j.le.X3plot(i).and.j.le.maxevpart(i))
               l=l+1
               title(l)='X3('//name(i,j)(1:lname(i,j))//')'
c      write (52,*) title
c               call mbook(l,title,X3range(1),X3range(2),X3range(3))
                call histoi(l,X3range(2),X3range(3),100)
               j=j+1
            enddo
         endif
      enddo
c-- DeltaR
      do i=1, maxclass
         if (dRijplot(i).ne.0) then
            do m=i, maxclass
               if (dRijplot(m).ne.0) then
                  j=1
                  do while (j.le.dRijplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.dRijplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           title(l)='R('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//')'
c      write (52,*) title
c                           call mbook(l,title,dRijrange(1),dRijrange(2),dRijrange(3))
                        call histoi(l,dRijrange(2),dRijrange(3),100)
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- invariant mass
      do i=1, maxclass
         if (mijplot(i).ne.0) then
            do m=i, maxclass
               if (mijplot(m).ne.0) then
                  j=1
                  do while (j.le.mijplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.mijplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           title(l)='m('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//')'
c      write (52,*) title
c                           call mbook(l,title,mijrange(1),mijrange(2),mijrange(3))
                         call histoi(l,mijrange(2),mijrange(3),100)
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- angle between particles
      do i=1, maxclass
         if (cosijplot(i).ne.0) then
            do m=i, maxclass
               if (cosijplot(m).ne.0) then
                  j=1
                  do while (j.le.cosijplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.cosijplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           title(l)='cos('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//')'
c      write (52,*) title
c                           call mbook(l,title,cosijrange(1),cosijrange(2),cosijrange(3))
                        call histoi(l,cosijrange(2),cosijrange(3),100)
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- delta_phi
c      do i=1, maxclass
      do i=0, maxclass
         if (delta_phiplot(i).ne.0) then
            do m=i, maxclass
               if (delta_phiplot(m).ne.0) then
                  j=1
                  do while (j.le.delta_phiplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.delta_phiplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           title(l)='Dphi('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//')'
c      write (52,*) title
c                           call mbook(l,title,delta_phirange(1),delta_phirange(2),delta_phirange(3))
                        call histoi(l,delta_phirange(2),delta_phirange(3),100)
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- delta_eta
      do i=1, maxclass
         if (delta_etaplot(i).ne.0) then
            do m=i, maxclass
               if (delta_etaplot(m).ne.0) then
                  j=1
                  do while (j.le.delta_etaplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.delta_etaplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           title(l)='Deta('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//')'
c      write (52,*) title
c                           call mbook(l,title,delta_etarange(1),delta_etarange(2),delta_etarange(3))
                        call histoi(l,delta_etarange(2),delta_etarange(3),100)
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- kTij
      do i=1, maxclass
         if (kTijplot(i).ne.0) then
            do m=i, maxclass
               if (kTijplot(m).ne.0) then
                  j=1
                  do while (j.le.kTijplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.kTijplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           title(l)='kTij('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//')'
c      write (52,*) title
c                           call mbook(l,title,kTijrange(1),kTijrange(2),kTijrange(3))
                        call histoi(l,kTijrange(2),kTijrange(3),100)
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- User defined
      do i=1, maxclass
         if (XY1plot(i).ne.0) then
            do m=i, maxclass
               if (XY1plot(m).ne.0) then
                  j=1
                  do while (j.le.XY1plot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.XY1plot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           title(l)='MTmiss('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//')'
c      write (52,*) title
c                           call mbook(l,title,XY1range(1),XY1range(2),XY1range(3))

                        call histoi(l,XY1range(2),XY1range(3),100)
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XY2plot(i).ne.0) then
            do m=i, maxclass
               if (XY2plot(m).ne.0) then
                  j=1
                  do while (j.le.XY2plot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.XY2plot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           title(l)='XY2('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//')'
c      write (52,*) title
c                           call mbook(l,title,XY2range(1),XY2range(2),XY2range(3))
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XY3plot(i).ne.0) then
            do m=i, maxclass
               if (XY3plot(m).ne.0) then
                  j=1
                  do while (j.le.XY3plot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.XY3plot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           title(l)='XY3('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//')'
c      write (52,*) title
c                           call mbook(l,title,XY3range(1),XY3range(2),XY3range(3))
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- User defined
      do i=1, maxclass
         if (XYZ1plot(i).ne.0) then
            do m=i, maxclass
               if (XYZ1plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZ1plot(a).ne.0) then
                        j=1
                        do while (j.le.XYZ1plot(i).and.j.le.maxevpart(i))
                           n=1
                           do while (n.le.XYZ1plot(m).and.n.le.maxevpart(m))
                              b=1
                              do while (b.le.XYZ1plot(a).and.b.le.maxevpart(a))
                                 if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b))then ! Removes double counting
                                    l=l+1
                                    title(l)='XYZ1('//name(i,j)(1:lname(i,j))//
     &                                    ','//name(m,n)(1:lname(m,n))//','//name(a,b)(1:lname(a,b))//')'
c      write (52,*) title
c                                    call mbook(l,title,XYZ1range(1),XYZ1range(2),XYZ1range(3))
                                 endif
                                 b=b+1
                              enddo
                              n=n+1
                           enddo
                           j=j+1
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XYZ2plot(i).ne.0) then
            do m=i, maxclass
               if (XYZ2plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZ2plot(a).ne.0) then
                        j=1
                        do while (j.le.XYZ2plot(i).and.j.le.maxevpart(i))
                           n=1
                           do while (n.le.XYZ2plot(m).and.n.le.maxevpart(m))
                              b=1
                              do while (b.le.XYZ2plot(a).and.b.le.maxevpart(a))
                                 if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b))then ! Removes double counting
                                    l=l+1
                                    title(l)='XYZ2('//name(i,j)(1:lname(i,j))//
     &                                    ','//name(m,n)(1:lname(m,n))//','//name(a,b)(1:lname(a,b))//')'
c      write (52,*) title
c                                    call mbook(l,title,XYZ2range(1),XYZ2range(2),XYZ2range(3))
                                 endif
                                 b=b+1
                              enddo
                              n=n+1
                           enddo
                           j=j+1
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XYZ3plot(i).ne.0) then
            do m=i, maxclass
               if (XYZ3plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZ3plot(a).ne.0) then
                        j=1
                        do while (j.le.XYZ3plot(i).and.j.le.maxevpart(i))
                           n=1
                           do while (n.le.XYZ3plot(m).and.n.le.maxevpart(m))
                              b=1
                              do while (b.le.XYZ3plot(a).and.b.le.maxevpart(a))
                                 if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b))then ! Removes double counting
                                    l=l+1
                                    title(l)='XYZ3('//name(i,j)(1:lname(i,j))//
     &                                    ','//name(m,n)(1:lname(m,n))//','//name(a,b)(1:lname(a,b))//')'
c      write (52,*) title
c                                    call mbook(l,title,XYZ3range(1),XYZ3range(2),XYZ3range(3))
                                 endif
                                 b=b+1
                              enddo
                              n=n+1
                           enddo
                           j=j+1
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XYZA1plot(i).ne.0) then
            do m=i, maxclass
               if (XYZA1plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZA1plot(a).ne.0) then
                        do c=a, maxclass
                           if (XYZA1plot(c).ne.0) then
                              j=1
                              do while (j.le.XYZA1plot(i).and.j.le.maxevpart(i))
                                 n=1
                                 do while (n.le.XYZA1plot(m).and.n.le.maxevpart(m))
                                    b=1
                                    do while (b.le.XYZA1plot(a).and.b.le.maxevpart(a))
                                       d=1
                                       do while (d.le.XYZA1plot(c).and.d.le.maxevpart(c))
                                          if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b).and.(a.ne.c.or.b.lt.d))then
                                             l=l+1
                                             title(l)='mETmLEP('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//
     &                                            ','//name(a,b)(1:lname(a,b))//','//name(c,d)(1:lname(c,d))//')'
c      write (52,*) title
c                                             call mbook(l,title,XYZA1range(1),XYZA1range(2),XYZA1range(3))
               call histoi(l,xyza1range(2),xyza1range(3),100)
                                          endif
                                          d=d+1
                                       enddo
                                       b=b+1
                                    enddo
                                    n=n+1
                                 enddo
                                 j=j+1
                              enddo
                           endif
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XYZA2plot(i).ne.0) then
            do m=i, maxclass
               if (XYZA2plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZA2plot(a).ne.0) then
                        do c=a, maxclass
                           if (XYZA2plot(c).ne.0) then
                              j=1
                              do while (j.le.XYZA2plot(i).and.j.le.maxevpart(i))
                                 n=1
                                 do while (n.le.XYZA2plot(m).and.n.le.maxevpart(m))
                                    b=1
                                    do while (b.le.XYZA2plot(a).and.b.le.maxevpart(a))
                                       d=1
                                       do while (d.le.XYZA2plot(c).and.d.le.maxevpart(c))
                                          if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b).and.(a.ne.c.or.b.lt.d))then
                                             l=l+1
                                             title(l)='MWW('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//
     &                                            ','//name(a,b)(1:lname(a,b))//','//name(c,d)(1:lname(c,d))//')'
c      write (52,*) title
c                                             call mbook(l,title,XYZA2range(1),XYZA2range(2),XYZA2range(3))
               call histoi(l,xyza2range(2),xyza2range(3),100)
                                          endif
                                          d=d+1
                                       enddo
                                       b=b+1
                                    enddo
                                    n=n+1
                                 enddo
                                 j=j+1
                              enddo
                           endif
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XYZA3plot(i).ne.0) then
            do m=i, maxclass
               if (XYZA3plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZA3plot(a).ne.0) then
                        do c=a, maxclass
                           if (XYZA3plot(c).ne.0) then
                              j=1
                              do while (j.le.XYZA3plot(i).and.j.le.maxevpart(i))
                                 n=1
                                 do while (n.le.XYZA3plot(m).and.n.le.maxevpart(m))
                                    b=1
                                    do while (b.le.XYZA3plot(a).and.b.le.maxevpart(a))
                                       d=1
                                       do while (d.le.XYZA3plot(c).and.d.le.maxevpart(c))
                                          if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b).and.(a.ne.c.or.b.lt.d))then
                                             l=l+1
                                             title(l)='MWWT('//name(i,j)(1:lname(i,j))//','//name(m,n)(1:lname(m,n))//
     &                                            ','//name(a,b)(1:lname(a,b))//','//name(c,d)(1:lname(c,d))//')'
c      write (52,*) title
c                                             call mbook(l,title,XYZA3range(1),XYZA3range(2),XYZA3range(3))
               call histoi(l,xyza3range(2),xyza3range(3),100)
                                          endif
                                          d=d+1
                                       enddo
                                       b=b+1
                                    enddo
                                    n=n+1
                                 enddo
                                 j=j+1
                              enddo
                           endif
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo

     
      write(*,*) l," plots set up"

      end


      subroutine histo_final
      implicit none
      include 'info.inc'

      integer i,j,k

      character*50 title(maxparticles)
      common/to_title/title
      character*50 filename,buff

      integer nhisto,maxbin
      parameter(nhisto=100,maxbin=500)
      double precision hmin(nhisto), hwidth(nhisto),ibin(nhisto)
      common /hispar/hmin,hwidth,ibin 
      double precision itmax1,itmax2,nshota,nshotb,nshotc,nshotd,nshote
      common /runinfo/itmax1,itmax2,nshota,nshotb,nshotc,nshotd,nshote
      integer filenumber
      common/file/ filenumber
c      integer intfile
c      common /div/ intfile

      double precision bin(nhisto,4,maxbin),xbin(nhisto,4)
      common/bins/ bin,xbin

      filenumber=intfile
c      print*, 'in histo-final', intfile
      open(unit=12,file="../plotlist.txt",status='unknown')

      do j=1,50
       call histoe(3,j)
      enddo
      do j=1,50
      i=index(title(j),' ')
      if(filenumber .le.9) then
       filename=title(j)(1:i-1)//".dat"//char(48+filenumber)
      elseif(filenumber.le.99) then
       filename=title(j)(1:i-1)//".dat"//char(filenumber/10+48)//char(48+mod(filenumber,10))
      endif

      k=index(filename,' ')

      if(i.gt.1) then
       open(unit=11,file=filename(1:k-1),status='unknown')
       write(12,'(a)') title(j)(1:i-1)
      call histowf(j,11)

       close(11)
      endif
      enddo

      close(12)
      end



      subroutine set_id
c****************************************
c     to set the particles ids
*****************************************
      implicit none
c
c    Particle's ID
c     	
      character*4 id(-300:300)
      common/to_id/id
c
c
c-Quarks: d u s c b t d~ u~ s~ c~ b~ t~ 
      id(1) ='d'
      id(2) ='u'
      id(3) ='s'
      id(4) ='c'
      id(5) ='b'
      id(6) ='t'
      id(-1)='d~'
      id(-2)='u~'
      id(-3)='s~'
      id(-4)='c~'
      id(-5)='b~'
      id(-6)='t~'  
c-Leptons: e- mu- ta- ve vm vt e+ mu+ ta+ ve~ vm~ vt~ 
      id(11) ='e-'
      id(12) ='ve'
      id(13) ='mu-'
      id(14) ='vm'
      id(15) ='ta-'
      id(16) ='vt'
      id(-11)='e+'
      id(-12)='ve~'
      id(-13)='mu+'
      id(-14)='vm~'
      id(-15)='ta+'
      id(-16)='vt~'
c-Bosons: g a z w+ w- h        
      id(21)  ='j'
      id(22)  ='a'
      id(23)  ='z'
      id(24)  ='w+'
      id(-24) ='w-'
      id(25)  ='h'

c-SUSY particles
c     squarks
      id(101) = 'dl'
      id(-101) = 'dl~'
      id(201) = 'dr'
      id(-201) = 'dr~'
      id(102) = 'ul'
      id(-102) = 'ul~'
      id(202) = 'ur'
      id(-202) = 'ur~'
      id(103) = 'sl'
      id(-103) = 'sl~'
      id(203) = 'sr'
      id(-203) = 'sr~'
      id(104) = 'cl'
      id(-104) = 'cl~'
      id(204) = 'cr'
      id(-204) = 'cr~'
      id(105) = 'b1'
      id(-105) = 'b1~'
      id(205) = 'b2'
      id(-205) = 'b2~'
      id(106) = 't1'
      id(-106) = 't1~'
      id(206) = 't2'
      id(-206) = 't2~'

c     sleptons
      id(111) = 'el-'
      id(-111) = 'el+'
      id(211) = 'er-'
      id(-211) = 'er+'
      id(113) = 'mul-'
      id(-113) = 'mul+'
      id(213) = 'mur-'
      id(-213) = 'mur+'
      id(115) = 'ta1-'
      id(-115) = 'ta1+'
      id(215) = 'ta2-'
      id(-215) = 'ta2+'
      id(112) = 'sve'
      id(-112) = 'sve~'
      id(114) = 'svm'
      id(-114) = 'svm~'
      id(116) = 'svt'
      id(-116) = 'svt~'

c     higgs bosons
      id(25) = 'h1'
      id(35) = 'h2'
      id(36) = 'h3'
      id(37) = 'h-'
      id(-37) = 'h+'

c     inos
      id(121) = 'go'
      id(122) = 'n1'
      id(123) = 'n2'
      id(125) = 'n3'
      id(135) = 'n4'
      id(124) = 'x1-'
      id(-124) = 'x1+'
      id(137) = 'x2-'
      id(-137) = 'x2+'

      return
      end


      subroutine no_spaces1(buff,nchars)
c**********************************************************************
c     Given buff a buffer of words separated by spaces
c     returns it where all space are moved to the right
c     returns also the length of the single word.
c     maxlength is the length of the buffer
c**********************************************************************
      implicit none
c
c     Constants
c
      integer    maxline
      parameter (maxline=4)
      character*1 null
      parameter  (null=' ')
c
c     Arguments
c
      character*(maxline) buff
      integer nchars,maxlength
c
c     Local
c
      integer i,j
      character*(maxline) temp
      
c-----
c  Begin Code
c-----
      nchars=0
c      write (*,*) "buff=",buff(1:maxlength)
      do i=1,maxline
         if(buff(i:i).ne.null) then
            nchars=nchars+1
            temp(nchars:nchars)=buff(i:i)
         endif
c         write(*,*) i,":",buff(1:maxlength),":",temp(1:nchars),":"
      enddo
      buff=temp      
      end



      subroutine graph_event(p,dwgt,mET)
c***************************************************************************
c     fill historgrams
c
c     Use eventinfo(i,j) to specify particles.
c     i              class  (i=0 for missing Et class)
c     j              particle in class (ordered from large to small pt)
c     eventinfo(i,j) is equal to 0 if particle does not exists
c***************************************************************************
      implicit none
      include 'info.inc'
      double precision  pi              , to_deg
      parameter        (pi = 3.1415927d0, to_deg=180d0/pi)
c
c     Arguments
c
      double precision dwgt,mET
      REAL*8 P(0:4,MaxParticles)
c
c     Local
c
      real*8 www,mij,R,ptv(MaxParticles)
      integer i,j,k,l,lmax,m,n,a,b,c,d
      integer idn(MaxParticles),npart(MaxParticles),ntot,npar
      real*8 dj,Ht
c
c     External
c
      double precision sumdot,dot,et,pt,eta,dRij,delta_phi,y,e,mom,costh,phi,delta_eta,kTij,cosij
      double precision X1,X2,X3,XY1,XY2,XY3,XYZ1,XYZ2,XYZ3,XYZA1,XYZA2,XYZA3
c
c     Global
c
      integer maxclass,maxevparticles,partoclass(-300:300,0:MaxParticles)
      integer maxevpart(0:maxclasses),maxpart(0:maxclasses)
      common/classes/maxclass,maxevparticles,partoclass,maxevpart

      integer nhisto,maxbin
      parameter(nhisto=100,maxbin=500)
      double precision hmin(nhisto), hwidth(nhisto),ibin(nhisto)
      common /hispar/hmin,hwidth,ibin 
      double precision nshota,nshotb,nshotc,nshotd,nshote
      common /runinfo/nshota,nshotb,nshotc,nshotd,nshote

      double precision bin(nhisto,4,maxbin),xbin(nhisto,4)
      common/bins/ bin,xbin


c-----
c  Begin Code
c-----

c      print *,'Now graphing event'
      www=dwgt


      l=0 !counter of the number of plots


C      print*, p(0,1),p(1,1),p(2,1),p(3,1)
C      print*, p(0,2),p(1,2),p(2,2),p(3,2)
C      print*, p(0,3),p(1,3),p(2,3),p(3,3)
c      print*, p(0,4),p(1,4),p(2,4),p(3,4)
c      print*, p(0,5),p(1,5),p(2,5),p(3,5)
c      print*, p(0,6),p(1,6),p(2,6),p(3,6)
c      print*, p(0,7),p(1,7),p(2,7),p(3,7)
c      print*, p(0,8),p(1,8),p(2,8),p(3,8)
c      print*, ' '
c      print*, ' '

c-- weights
      l=l+1
c      call mfill(l,www,www)
      call histoa(l,www,www)

c-- counts
      do i=1,maxclass
         if (maxevpart(i).ge.1)then
         l=l+1
         j=1
         do while (eventinfo(i,j).ne.0)
            j=j+1
         enddo
         dj=real(j-1)
c         call mfill(l,dj,www)
         call histoa(l,dj,www)
         call histoe(2,l)
c         call histoe(3,l)
         endif
      enddo

c-- Ht
      l=l+1
      Ht=0d0
      do i=1,maxclass  ! Loop over all classes
         do j=1,maxevpart(i)   ! Loop from 1 to max # particles in any event (belonging to class i)
            if (eventinfo(i,j).ne.0)then       ! Do not sum if particle does not exist in an event
              if(i.gt.1.or.(j.le.4))
     $           Ht=Ht+et(p(0,eventinfo(i,j)))
c               Ht=Ht+et(p(0,eventinfo(i,j)))
            endif
         enddo
      enddo
      Ht=Ht+mET
c      call mfill(l,Ht,www)
      call histoa(l,Ht,www)
      call histoe(2,l)
c      call histoe(3,l)
c-- Missing ET
      if (maxevpart(0).ge.1) then
         l=l+1
c         call mfill(l,mET,www)
       call histoa(l,mET,www)
       call histoe(2,l)
c       call histoe(3,l)
      endif
c-- pt
      do i=1, maxclass 
         if (ptplot(i).ne.0) then
            j=1
c                print*, 'hier bei pt'
            do while (j.le.ptplot(i).and.j.le.maxevpart(i))
               l=l+1
c                print*, i,j,eventinfo(i,j)
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,pt(p(0,eventinfo(i,j))),www)
c                print*, eventinfo(i,j), www
                call histoa(l,pt(p(0,eventinfo(i,j))),www)
                call histoe(2,l)
c                call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
c-- et
      do i=1, maxclass 
         if (etplot(i).ne.0) then
            j=1
            do while (j.le.etplot(i).and.j.le.maxevpart(i))
               l=l+1
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,et(p(0,eventinfo(i,j))),www)
                call histoa(l,et(p(0,eventinfo(i,j))),www)
                call histoe(2,l)
c                call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
c-- e
      do i=1, maxclass 
         if (eplot(i).ne.0) then
            j=1
            do while (j.le.eplot(i).and.j.le.maxevpart(i))
               l=l+1
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,e(p(0,eventinfo(i,j))),www)
               call histoa(l,e(p(0,eventinfo(i,j))),www)
               call histoe(2,l)
c               call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
c-- mom
      do i=1, maxclass 
         if (momplot(i).ne.0) then
            j=1
            do while (j.le.momplot(i).and.j.le.maxevpart(i))
               l=l+1
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,mom(p(0,eventinfo(i,j))),www)
                call histoa(l,mom(p(0,eventinfo(i,j))),www)
                call histoe(2,l)
c                call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
c-- pseudo-rapidity eta
      do i=1, maxclass 
         if (etaplot(i).ne.0) then
            j=1
            do while (j.le.etaplot(i).and.j.le.maxevpart(i))
               l=l+1
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,eta(p(0,eventinfo(i,j))),www)
                call histoa(l,eta(p(0,eventinfo(i,j))),www)
                call histoe(2,l)
c                call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
c-- rapidity y
      do i=1, maxclass 
         if (yplot(i).ne.0) then
            j=1
            do while (j.le.yplot(i).and.j.le.maxevpart(i))
               l=l+1
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,y(p(0,eventinfo(i,j))),www)
                call histoa(l,y(p(0,eventinfo(i,j))),www)
                call histoe(2,l)
c                call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
c-- cos theta
      do i=1, maxclass 
         if (costhplot(i).ne.0) then
            j=1
            do while (j.le.costhplot(i).and.j.le.maxevpart(i))
               l=l+1
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,costh(p(0,eventinfo(i,j))),www)
                call histoa(l,costh(p(0,eventinfo(i,j))),www)
                call histoe(2,l)
c                call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
c-- azymuthal phi
      do i=1, maxclass 
         if (phiplot(i).ne.0) then
            j=1
            do while (j.le.phiplot(i).and.j.le.maxevpart(i))
               l=l+1
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,phi(p(0,eventinfo(i,j))),www)
                call histoa(l,phi(p(0,eventinfo(i,j))),www)
                call histoe(2,l)
c                call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
c-- User defined
      do i=1, maxclass 
         if (X1plot(i).ne.0) then
            j=1
            do while (j.le.X1plot(i).and.j.le.maxevpart(i))
               l=l+1
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,X1(p(0,eventinfo(i,j))),www)
                call histoa(l,X1(p(0,eventinfo(i,j))),www)
                call histoe(2,l)
c               call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
      do i=1, maxclass 
         if (X2plot(i).ne.0) then
            j=1
            do while (j.le.X2plot(i).and.j.le.maxevpart(i))
               l=l+1
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,X2(p(0,eventinfo(i,j))),www)
                call histoa(l,X2(p(0,eventinfo(i,j))),www)
                call histoe(2,l)
c                call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
      do i=1, maxclass 
         if (X3plot(i).ne.0) then
            j=1
            do while (j.le.X3plot(i).and.j.le.maxevpart(i))
               l=l+1
               if (eventinfo(i,j).ne.0)then ! Do not plot if particle does not exist in an event
c                  call mfill(l,X3(p(0,eventinfo(i,j))),www)
                call histoa(l,X3(p(0,eventinfo(i,j))),www)
                call histoe(2,l)
c                call histoe(3,l)
               endif
               j=j+1
            enddo
         endif
      enddo
c-- DeltaR
      do i=1, maxclass
         if (dRijplot(i).ne.0) then
            do m=i, maxclass
               if (dRijplot(m).ne.0) then
                  j=1
                  do while (j.le.dRijplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.dRijplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0)then
c                              call mfill(l,dRij(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoa(l,dRij(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoe(2,l)
c                        call histoe(3,l)
                           endif
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- invariant mass
      do i=1, maxclass
         if (mijplot(i).ne.0) then
            do m=i, maxclass
               if (mijplot(m).ne.0) then
                  j=1
                  do while (j.le.mijplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.mijplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0)then
c                              call mfill(l,mij(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoa(l,mij(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoe(2,l)
c                        call histoe(3,l)
                           endif
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- angle between particles
      do i=1, maxclass
         if (cosijplot(i).ne.0) then
            do m=i, maxclass
               if (cosijplot(m).ne.0) then
                  j=1
                  do while (j.le.cosijplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.cosijplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0)then
c                              call mfill(l,cosij(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoa(l,cosij(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoe(2,l)
c                        call histoe(3,l)
                           endif
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- delta_phi
      do i=0, maxclass
         if (delta_phiplot(i).ne.0) then
            do m=i, maxclass
               if (delta_phiplot(m).ne.0) then
                  j=1
                  do while (j.le.delta_phiplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.delta_phiplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0)then
c                              call mfill(l,delta_phi(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoa(l,delta_phi(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoe(2,l)
c                        call histoe(3,l)
                           endif
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- delta_eta
      do i=1, maxclass
         if (delta_etaplot(i).ne.0) then
            do m=i, maxclass
               if (delta_etaplot(m).ne.0) then
                  j=1
                  do while (j.le.delta_etaplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.delta_etaplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0)then
c                              call mfill(l,delta_eta(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoa(l,delta_eta(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoe(2,l)
c                        call histoe(3,l)
                           endif
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- kTij
      do i=1, maxclass
         if (kTijplot(i).ne.0) then
            do m=i, maxclass
               if (kTijplot(m).ne.0) then
                  j=1
                  do while (j.le.kTijplot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.kTijplot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0)then
c                              call mfill(l,kTij(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoa(l,kTij(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoe(2,l)
c                        call histoe(3,l)
                           endif
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- user defined
      do i=1, maxclass
         if (XY1plot(i).ne.0) then
            do m=i, maxclass
               if (XY1plot(m).ne.0) then
                  j=1
                  do while (j.le.XY1plot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.XY1plot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0)then
c                              call mfill(l,XY1(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                        call histoa(l,XY1(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
c                         print*, eventinfo(i,j), eventinfo(m,n)
c                         print*, p(0,eventinfo(i,j)), p(1,eventinfo(i,j)), p(2,eventinfo(i,j)), p(3,eventinfo(i,j))
c                         print*, p(0,eventinfo(m,n)), p(1,eventinfo(m,n)), p(2,eventinfo(m,n)), p(3,eventinfo(m,n))
c                         print*, p(0,1),p(1,1),p(2,1),p(3,1)
c                         print*, p(0,2),p(1,2),p(2,2),p(3,2)
c                         print*, ' '
                        call histoe(2,l)
                           endif
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XY2plot(i).ne.0) then
            do m=i, maxclass
               if (XY2plot(m).ne.0) then
                  j=1
                  do while (j.le.XY2plot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.XY2plot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0)then
c                              call mfill(l,XY2(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                           endif
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XY3plot(i).ne.0) then
            do m=i, maxclass
               if (XY3plot(m).ne.0) then
                  j=1
                  do while (j.le.XY3plot(i).and.j.le.maxevpart(i))
                     n=1
                     do while (n.le.XY3plot(m).and.n.le.maxevpart(m))
                        if (i.ne.m.or.j.lt.n)then ! Removes double counting
                           l=l+1
                           if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0)then
c                              call mfill(l,XY3(p(0,eventinfo(i,j)),p(0,eventinfo(m,n))),www)
                           endif
                        endif
                        n=n+1
                     enddo
                     j=j+1
                  enddo
               endif
            enddo
         endif
      enddo
c-- User defined
      do i=1, maxclass
         if (XYZ1plot(i).ne.0) then
            do m=i, maxclass
               if (XYZ1plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZ1plot(a).ne.0) then
                        j=1
                        do while (j.le.XYZ1plot(i).and.j.le.maxevpart(i))
                           n=1
                           do while (n.le.XYZ1plot(m).and.n.le.maxevpart(m))
                              b=1
                              do while (b.le.XYZ1plot(a).and.b.le.maxevpart(a))
                                 if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b))then ! Removes double counting
                                    l=l+1
                                    if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0.and.eventinfo(a,b).ne.0)then
c                                       call mfill(l,XYZ1(p(0,eventinfo(i,j)),p(0,eventinfo(m,n)),p(0,eventinfo(a,b))),www)
                                    endif
                                 endif
                                 b=b+1
                              enddo
                              n=n+1
                           enddo
                           j=j+1
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XYZ2plot(i).ne.0) then
            do m=i, maxclass
               if (XYZ2plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZ2plot(a).ne.0) then
                        j=1
                        do while (j.le.XYZ2plot(i).and.j.le.maxevpart(i))
                           n=1
                           do while (n.le.XYZ2plot(m).and.n.le.maxevpart(m))
                              b=1
                              do while (b.le.XYZ2plot(a).and.b.le.maxevpart(a))
                                 if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b))then ! Removes double counting
                                    l=l+1
                                    if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0.and.eventinfo(a,b).ne.0)then
c                                       call mfill(l,XYZ2(p(0,eventinfo(i,j)),p(0,eventinfo(m,n)),p(0,eventinfo(a,b))),www)
                                    endif
                                 endif
                                 b=b+1
                              enddo
                              n=n+1
                           enddo
                           j=j+1
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XYZ3plot(i).ne.0) then
            do m=i, maxclass
               if (XYZ3plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZ3plot(a).ne.0) then
                        j=1
                        do while (j.le.XYZ3plot(i).and.j.le.maxevpart(i))
                           n=1
                           do while (n.le.XYZ3plot(m).and.n.le.maxevpart(m))
                              b=1
                              do while (b.le.XYZ3plot(a).and.b.le.maxevpart(a))
                                 if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b))then ! Removes double counting
                                    l=l+1
                                    if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0.and.eventinfo(a,b).ne.0)then
c                                       call mfill(l,XYZ3(p(0,eventinfo(i,j)),p(0,eventinfo(m,n)),p(0,eventinfo(a,b))),www)
                                    endif
                                 endif
                                 b=b+1
                              enddo
                              n=n+1
                           enddo
                           j=j+1
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XYZA1plot(i).ne.0) then
            do m=i, maxclass
               if (XYZA1plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZA1plot(a).ne.0) then
                        do c=a, maxclass
                           if (XYZA1plot(c).ne.0) then
                              j=1
                              do while (j.le.XYZA1plot(i).and.j.le.maxevpart(i))
                                 n=1
                                 do while (n.le.XYZA1plot(m).and.n.le.maxevpart(m))
                                    b=1
                                    do while (b.le.XYZA1plot(a).and.b.le.maxevpart(a))
                                       d=1
                                       do while (d.le.XYZA1plot(c).and.d.le.maxevpart(c))
                                          if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b).and.(a.ne.c.or.b.lt.d))then
                                             l=l+1
                                             if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0.and.eventinfo(a,b).ne.0)then
c                                                call mfill(l,XYZA1(p(0,eventinfo(i,j)),p(0,eventinfo(m,n)),
c     &                                               p(0,eventinfo(a,b)),p(0,eventinfo(c,d))),www)
                call histoa(l,XYZA1(p(0,eventinfo(i,j)),p(0,eventinfo(m,n)),
     &                       p(0,eventinfo(a,b)),p(0,eventinfo(c,d))),www)
                call histoe(2,l)
                                             endif
                                          endif
                                          d=d+1
                                       enddo
                                       b=b+1
                                    enddo
                                    n=n+1
                                 enddo
                                 j=j+1
                              enddo
                           endif
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XYZA2plot(i).ne.0) then
            do m=i, maxclass
               if (XYZA2plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZA2plot(a).ne.0) then
                        do c=a, maxclass
                           if (XYZA2plot(c).ne.0) then
                              j=1
                              do while (j.le.XYZA2plot(i).and.j.le.maxevpart(i))
                                 n=1
                                 do while (n.le.XYZA2plot(m).and.n.le.maxevpart(m))
                                    b=1
                                    do while (b.le.XYZA2plot(a).and.b.le.maxevpart(a))
                                       d=1
                                       do while (d.le.XYZA2plot(c).and.d.le.maxevpart(c))
                                          if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b).and.(a.ne.c.or.b.lt.d))then
                                             l=l+1
                                             if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0.and.eventinfo(a,b).ne.0)then
c                                                call mfill(l,XYZA2(p(0,eventinfo(i,j)),p(0,eventinfo(m,n)),
c     &                                               p(0,eventinfo(a,b)),p(0,eventinfo(c,d))),www)
                call histoa(l,XYZA2(p(0,eventinfo(i,j)),p(0,eventinfo(m,n)),
     &                       p(0,eventinfo(a,b)),p(0,eventinfo(c,d))),www)
                call histoe(2,l)
                                             endif
                                          endif
                                          d=d+1
                                       enddo
                                       b=b+1
                                    enddo
                                    n=n+1
                                 enddo
                                 j=j+1
                              enddo
                           endif
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      do i=1, maxclass
         if (XYZA3plot(i).ne.0) then
            do m=i, maxclass
               if (XYZA3plot(m).ne.0) then
                  do a=m, maxclass
                     if (XYZA3plot(a).ne.0) then
                        do c=a, maxclass
                           if (XYZA3plot(c).ne.0) then
                              j=1
                              do while (j.le.XYZA3plot(i).and.j.le.maxevpart(i))
                                 n=1
                                 do while (n.le.XYZA3plot(m).and.n.le.maxevpart(m))
                                    b=1
                                    do while (b.le.XYZA3plot(a).and.b.le.maxevpart(a))
                                       d=1
                                       do while (d.le.XYZA3plot(c).and.d.le.maxevpart(c))
                                          if ((i.ne.m.or.j.lt.n).and.(m.ne.a.or.n.lt.b).and.(a.ne.c.or.b.lt.d))then
                                             l=l+1
                                             if (eventinfo(i,j).ne.0.and.eventinfo(m,n).ne.0.and.eventinfo(a,b).ne.0)then
c                                                call mfill(l,XYZA3(p(0,eventinfo(i,j)),p(0,eventinfo(m,n)),
c     &                                               p(0,eventinfo(a,b)),p(0,eventinfo(c,d))),www)
                call histoa(l,XYZA2(p(0,eventinfo(i,j)),p(0,eventinfo(m,n)),
     &                       p(0,eventinfo(a,b)),p(0,eventinfo(c,d))),www)
                call histoe(2,l)
                                             endif
                                          endif
                                          d=d+1
                                       enddo
                                       b=b+1
                                    enddo
                                    n=n+1
                                 enddo
                                 j=j+1
                              enddo
                           endif
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo

      return
      end

      subroutine sort2(array,aux1,n)
      implicit none
! Arguments
      integer n
      integer aux1(n)
      double precision array(n)
!  Local Variables
      integer i,k
      double precision temp
      logical done


!-----------
! Begin Code
!-----------
      do i=n-1,1,-1
         done = .true.
         do k=1,i
            if (array(k) .lt. array(k+1)) then
               temp = array(k)
               array(k) = array(k+1)
               array(k+1) = temp
               temp = aux1(k)
               aux1(k) = aux1(k+1)
               aux1(k+1) = temp
               done = .false.
            end if
         end do
         if (done) return
      end do
      end 

