module     dgaad_abbrevd17h0
   use dgaad_config, only: ki
   use dgaad_globalsh0
   implicit none
   private
   complex(ki), dimension(22), public :: abb17
   complex(ki), public :: R2d17
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb17(1)=NC**(-1)
      abb17(2)=es45**(-1)
      abb17(3)=es12**(-1)
      abb17(4)=1.0_ki/(-es34+es12-es45)
      abb17(5)=abb17(2)*spbe3k2
      abb17(6)=abb17(5)*spbk5e4
      abb17(7)=abb17(4)*spbe4k2
      abb17(8)=abb17(7)*spbk5e3
      abb17(6)=abb17(6)+abb17(8)
      abb17(6)=abb17(6)*abb17(1)
      abb17(8)=abb17(7)*NC
      abb17(9)=abb17(8)*spbk5e3
      abb17(10)=abb17(5)*NC
      abb17(11)=abb17(10)*spbk5e4
      abb17(6)=abb17(6)-abb17(9)-abb17(11)
      abb17(9)=spbe2k1*spae2k2
      abb17(11)=abb17(9)*spae3k5
      abb17(12)=abb17(6)*abb17(11)
      abb17(5)=abb17(1)*abb17(5)
      abb17(5)=abb17(5)-abb17(10)
      abb17(10)=spbk4e4*spae3k4
      abb17(5)=abb17(10)*abb17(5)
      abb17(13)=abb17(5)*abb17(9)
      abb17(12)=abb17(12)+abb17(13)
      abb17(12)=abb17(12)*spae4k5
      abb17(7)=abb17(1)*abb17(7)
      abb17(7)=abb17(7)-abb17(8)
      abb17(8)=spak3e4*spbk3e3
      abb17(7)=abb17(8)*abb17(7)
      abb17(13)=abb17(7)*abb17(11)
      abb17(12)=abb17(12)-abb17(13)
      abb17(13)=i_*c1*TR
      abb17(14)=abb17(13)*abb17(3)
      abb17(15)=-1.0_ki/9.0_ki*abb17(12)*abb17(14)
      abb17(16)=abb17(2)*spbe3k1
      abb17(17)=spbk5e4*abb17(16)
      abb17(18)=abb17(4)*spbe4k1
      abb17(19)=spbk5e3*abb17(18)
      abb17(17)=abb17(17)+abb17(19)
      abb17(17)=abb17(17)*abb17(1)
      abb17(19)=NC*abb17(18)
      abb17(20)=abb17(19)*spbk5e3
      abb17(21)=NC*abb17(16)
      abb17(22)=abb17(21)*spbk5e4
      abb17(17)=abb17(17)-abb17(20)-abb17(22)
      abb17(20)=spae3k5*abb17(17)
      abb17(16)=abb17(1)*abb17(16)
      abb17(16)=abb17(16)-abb17(21)
      abb17(10)=abb17(10)*abb17(16)
      abb17(16)=abb17(20)+abb17(10)
      abb17(16)=spae4k5*abb17(16)
      abb17(18)=abb17(1)*abb17(18)
      abb17(18)=abb17(18)-abb17(19)
      abb17(8)=abb17(8)*abb17(18)
      abb17(18)=-spae3k5*abb17(8)
      abb17(16)=abb17(18)+abb17(16)
      abb17(14)=4.0_ki/9.0_ki*abb17(16)*abb17(14)
      abb17(13)=abb17(13)*abb17(3)**2
      abb17(16)=2.0_ki/9.0_ki*abb17(13)
      abb17(18)=abb17(12)*abb17(16)
      abb17(12)=4.0_ki/9.0_ki*abb17(12)*abb17(13)
      abb17(19)=spak1k2*spbk2e2
      abb17(20)=-abb17(19)*abb17(17)
      abb17(6)=-spbe2k1*spak1k2*abb17(6)
      abb17(6)=abb17(6)+abb17(20)
      abb17(6)=spae3k5*abb17(6)
      abb17(20)=-abb17(19)*abb17(10)
      abb17(21)=spbe2k1*spak1k2
      abb17(5)=-abb17(5)*abb17(21)
      abb17(5)=abb17(6)+abb17(5)+abb17(20)
      abb17(5)=spae4k5*abb17(5)
      abb17(6)=abb17(19)*abb17(8)
      abb17(7)=abb17(7)*abb17(21)
      abb17(6)=abb17(7)+abb17(6)
      abb17(6)=spae3k5*abb17(6)
      abb17(5)=abb17(6)+abb17(5)
      abb17(5)=abb17(5)*abb17(16)
      abb17(6)=-abb17(17)*abb17(11)
      abb17(7)=-abb17(10)*abb17(9)
      abb17(6)=abb17(7)+abb17(6)
      abb17(6)=spae4k5*abb17(6)
      abb17(7)=abb17(8)*abb17(11)
      abb17(6)=abb17(7)+abb17(6)
      abb17(6)=1.0_ki/9.0_ki*abb17(6)*abb17(13)
      R2d17=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d17
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='17' value='", &
          & R2d17, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd17h0
