module     dgaad_abbrevd65h0
   use dgaad_config, only: ki
   use dgaad_globalsh0
   implicit none
   private
   complex(ki), dimension(38), public :: abb65
   complex(ki), public :: R2d65
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb65(1)=NC**(-1)
      abb65(2)=es45**(-1)
      abb65(3)=-spbk2k1*spak2e3
      abb65(4)=-spbk3k1*spae3k3
      abb65(3)=abb65(4)+abb65(3)
      abb65(4)=i_*TR*c1*spae4k5*abb65(2)*abb65(1)
      abb65(5)=abb65(4)*spbk4e4
      abb65(6)=abb65(5)*spae2k4
      abb65(4)=abb65(4)*spbk5e4
      abb65(7)=abb65(4)*spae2k5
      abb65(6)=abb65(6)+abb65(7)
      abb65(7)=spbe3e2*abb65(6)
      abb65(3)=abb65(7)*abb65(3)
      abb65(8)=spbk2e2*spak2e3
      abb65(9)=abb65(8)*abb65(6)
      abb65(10)=spbe3k1*abb65(9)
      abb65(3)=abb65(10)+abb65(3)
      abb65(3)=1.0_ki/9.0_ki*abb65(3)
      abb65(10)=2.0_ki/9.0_ki*abb65(6)
      abb65(11)=spbe2k1*abb65(10)
      abb65(12)=2.0_ki/9.0_ki*spbk2k1
      abb65(13)=abb65(4)*spak2e3
      abb65(14)=-abb65(13)*abb65(12)
      abb65(15)=abb65(4)*spbe2k1
      abb65(16)=abb65(15)*spae2e3
      abb65(17)=2.0_ki/9.0_ki*abb65(16)
      abb65(16)=-1.0_ki/9.0_ki*abb65(16)
      abb65(18)=abb65(5)*spak2e3
      abb65(12)=-abb65(18)*abb65(12)
      abb65(19)=abb65(5)*spbe2k1
      abb65(20)=abb65(19)*spae2e3
      abb65(21)=2.0_ki/9.0_ki*abb65(20)
      abb65(20)=-1.0_ki/9.0_ki*abb65(20)
      abb65(22)=abb65(4)*spbe3k2
      abb65(23)=abb65(22)*spak2k5
      abb65(24)=abb65(5)*spbe3k2
      abb65(25)=abb65(24)*spak2k4
      abb65(23)=abb65(23)+abb65(25)
      abb65(25)=-spak3k5*abb65(4)
      abb65(26)=-spak3k4*abb65(5)
      abb65(25)=abb65(26)+abb65(25)
      abb65(25)=spbk3e3*abb65(25)
      abb65(25)=-2.0_ki*abb65(23)+abb65(25)
      abb65(25)=2.0_ki/9.0_ki*abb65(25)
      abb65(26)=2.0_ki/9.0_ki*abb65(7)
      abb65(7)=-1.0_ki/9.0_ki*abb65(7)
      abb65(27)=spbk3e2*spae3k3
      abb65(8)=abb65(27)+abb65(8)
      abb65(8)=-1.0_ki/9.0_ki*abb65(8)*abb65(23)
      abb65(23)=spak2k5*abb65(4)
      abb65(28)=spak2k4*abb65(5)
      abb65(23)=abb65(23)+abb65(28)
      abb65(28)=2.0_ki/9.0_ki*spbk2e2
      abb65(23)=abb65(23)*abb65(28)
      abb65(28)=abb65(5)*spae3k4
      abb65(29)=abb65(4)*spae3k5
      abb65(28)=abb65(28)+abb65(29)
      abb65(29)=spbe3e2*abb65(28)
      abb65(30)=-2.0_ki/9.0_ki*abb65(29)
      abb65(29)=1.0_ki/9.0_ki*abb65(29)
      abb65(31)=spae2k2*spbe2k1
      abb65(31)=1.0_ki/9.0_ki*abb65(31)
      abb65(32)=abb65(31)*abb65(22)
      abb65(33)=spae3k3*abb65(32)
      abb65(34)=2.0_ki/9.0_ki*spbe3k1
      abb65(35)=abb65(34)*spae3k3
      abb65(36)=abb65(4)*abb65(35)
      abb65(32)=spak2e3*abb65(32)
      abb65(37)=2.0_ki/9.0_ki*spae2k2
      abb65(15)=-abb65(15)*abb65(37)
      abb65(13)=abb65(13)*abb65(34)
      abb65(4)=4.0_ki/9.0_ki*abb65(4)
      abb65(31)=abb65(31)*abb65(24)
      abb65(38)=spae3k3*abb65(31)
      abb65(35)=abb65(5)*abb65(35)
      abb65(31)=spak2e3*abb65(31)
      abb65(19)=-abb65(19)*abb65(37)
      abb65(18)=abb65(18)*abb65(34)
      abb65(5)=4.0_ki/9.0_ki*abb65(5)
      abb65(28)=2.0_ki/9.0_ki*spbk3e3*abb65(28)
      abb65(6)=abb65(6)*abb65(27)
      abb65(6)=abb65(6)+abb65(9)
      abb65(6)=1.0_ki/9.0_ki*spbe3k2*abb65(6)
      abb65(9)=-spbk2e2*abb65(10)
      abb65(10)=spae3k5*abb65(22)
      abb65(22)=spae3k4*abb65(24)
      abb65(10)=abb65(10)+abb65(22)
      abb65(10)=4.0_ki/9.0_ki*abb65(10)
      R2d65=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d65
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='65' value='", &
          & R2d65, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd65h0
