module     dgaad_abbrevd68h0
   use dgaad_config, only: ki
   use dgaad_globalsh0
   implicit none
   private
   complex(ki), dimension(23), public :: abb68
   complex(ki), public :: R2d68
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb68(1)=1.0_ki/(-es34+es12-es45)
      abb68(2)=NC**(-1)
      abb68(3)=es12**(-1)
      abb68(4)=1.0_ki/(es23-es51-es45)
      abb68(5)=NC-abb68(2)
      abb68(6)=i_*TR*c1*abb68(1)
      abb68(7)=abb68(5)*abb68(6)*spbe4k1*abb68(4)
      abb68(8)=abb68(7)*spbk4e2*spae4k4
      abb68(9)=spak1e4*spbe2k1*abb68(7)
      abb68(8)=abb68(8)-abb68(9)
      abb68(9)=-spae2k5*abb68(8)
      abb68(5)=abb68(5)*abb68(6)
      abb68(6)=-spbe2k1*abb68(5)
      abb68(10)=spbe4k2*spae2k2
      abb68(11)=abb68(6)*abb68(10)*abb68(3)
      abb68(12)=spae4k5*abb68(11)
      abb68(12)=abb68(9)+abb68(12)
      abb68(13)=es45+es34
      abb68(13)=abb68(12)*abb68(13)
      abb68(9)=-es12*abb68(9)
      abb68(10)=-abb68(10)*abb68(6)*spae4k5
      abb68(9)=abb68(9)+abb68(10)+abb68(13)
      abb68(9)=2.0_ki/9.0_ki*abb68(9)
      abb68(10)=spak3k5*abb68(3)
      abb68(13)=spbk3k2*spae2k2*abb68(10)*abb68(6)
      abb68(14)=-spae2k4*spbk3e2*spak3k5*abb68(5)*abb68(4)
      abb68(15)=spbk4k1*abb68(14)
      abb68(13)=abb68(13)+abb68(15)
      abb68(13)=8.0_ki/9.0_ki*abb68(13)
      abb68(15)=spbk4k3*spae4k4
      abb68(16)=-spbk3k1*spak1e4
      abb68(15)=abb68(15)+abb68(16)
      abb68(7)=-abb68(7)*spak3k5
      abb68(15)=abb68(7)*abb68(15)
      abb68(10)=abb68(10)*spbe4k3
      abb68(5)=-abb68(5)*abb68(10)*spak2e4
      abb68(16)=-spbk2k1*abb68(5)
      abb68(15)=abb68(16)+abb68(15)
      abb68(15)=8.0_ki/9.0_ki*abb68(15)
      abb68(16)=-spae2e3*abb68(8)
      abb68(17)=spae3e4*abb68(11)
      abb68(16)=abb68(16)-abb68(17)
      abb68(16)=abb68(16)*spbk3e3*spak3k5
      abb68(8)=-abb68(8)*spae2k3
      abb68(11)=abb68(11)*spak3e4
      abb68(8)=abb68(8)-abb68(11)
      abb68(11)=abb68(8)*spbk3e3*spae3k5
      abb68(17)=-abb68(11)+abb68(16)
      abb68(17)=2.0_ki/9.0_ki*abb68(17)
      abb68(18)=-4.0_ki/9.0_ki*abb68(12)
      abb68(7)=abb68(7)*spbk3e2
      abb68(19)=8.0_ki/9.0_ki*spae2e4
      abb68(20)=-abb68(7)*abb68(19)
      abb68(21)=spbk5e3*abb68(12)*spae3k5
      abb68(16)=abb68(21)+abb68(16)
      abb68(16)=2.0_ki/9.0_ki*abb68(16)
      abb68(22)=-8.0_ki/9.0_ki*abb68(12)
      abb68(6)=abb68(10)*abb68(6)
      abb68(10)=abb68(6)*abb68(19)
      abb68(23)=abb68(6)+abb68(7)
      abb68(19)=abb68(23)*abb68(19)
      abb68(11)=abb68(21)+abb68(11)
      abb68(11)=1.0_ki/9.0_ki*abb68(11)
      abb68(12)=-1.0_ki/9.0_ki*spbk5k3*spae3k3*abb68(12)
      abb68(14)=-spbk4e4*abb68(14)
      abb68(7)=spak1e2*abb68(7)
      abb68(7)=abb68(14)+abb68(7)
      abb68(7)=4.0_ki/9.0_ki*abb68(7)
      abb68(6)=-spak1e4*abb68(6)
      abb68(5)=spbk2e2*abb68(5)
      abb68(5)=abb68(6)+abb68(5)
      abb68(5)=4.0_ki/9.0_ki*abb68(5)
      abb68(6)=2.0_ki/9.0_ki*abb68(8)
      R2d68=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d68
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='68' value='", &
          & R2d68, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd68h0
