module     dgaad_d24h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d24h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd24h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc24(35)
      complex(ki) :: Qspk3
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspe3
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak5e2
      complex(ki) :: Qspk2
      complex(ki) :: QspQ
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak5e4
      complex(ki) :: Qspvak5k4
      Qspk3 = dotproduct(Q,k3)
      Qspk1 = dotproduct(Q,k1)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspe3 = dotproduct(Q,e3)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspe2 = dotproduct(Q,e2)
      Qspvak5e2 = dotproduct(Q,spvak5e2)
      Qspk2 = dotproduct(Q,k2)
      QspQ = dotproduct(Q,Q)
      Qspe4 = dotproduct(Q,e4)
      Qspvak5e4 = dotproduct(Q,spvak5e4)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      acc24(1)=abb24(3)
      acc24(2)=abb24(4)
      acc24(3)=abb24(5)
      acc24(4)=abb24(6)
      acc24(5)=abb24(7)
      acc24(6)=abb24(8)
      acc24(7)=abb24(9)
      acc24(8)=abb24(10)
      acc24(9)=abb24(11)
      acc24(10)=abb24(12)
      acc24(11)=abb24(13)
      acc24(12)=abb24(14)
      acc24(13)=abb24(15)
      acc24(14)=abb24(16)
      acc24(15)=abb24(17)
      acc24(16)=abb24(18)
      acc24(17)=abb24(20)
      acc24(18)=abb24(23)
      acc24(19)=abb24(27)
      acc24(20)=abb24(28)
      acc24(21)=abb24(29)
      acc24(22)=abb24(30)
      acc24(23)=abb24(31)
      acc24(24)=abb24(32)
      acc24(25)=abb24(33)
      acc24(26)=abb24(35)
      acc24(27)=abb24(36)
      acc24(28)=Qspk3-Qspk1
      acc24(29)=acc24(24)*acc24(28)
      acc24(30)=acc24(15)*Qspvak5k1
      acc24(31)=acc24(12)*Qspvak5k3
      acc24(32)=Qspe3*acc24(19)
      acc24(33)=Qspvae3k1*acc24(2)
      acc24(29)=acc24(33)+acc24(32)+acc24(31)+acc24(18)+acc24(30)+acc24(29)
      acc24(29)=Qspe2*acc24(29)
      acc24(30)=-acc24(22)*acc24(28)
      acc24(31)=acc24(16)*Qspvak5e2
      acc24(32)=Qspk2*acc24(27)
      acc24(33)=Qspe3*acc24(10)
      acc24(34)=Qspvae3k1*acc24(9)
      acc24(35)=QspQ*acc24(26)
      acc24(29)=acc24(29)+acc24(35)+acc24(34)+acc24(33)+acc24(31)+acc24(32)+acc&
      &24(30)
      acc24(29)=Qspe4*acc24(29)
      acc24(30)=-acc24(4)*acc24(28)
      acc24(31)=acc24(21)*Qspvak5e4
      acc24(32)=Qspe3*acc24(3)
      acc24(33)=Qspvae3k1*acc24(6)
      acc24(30)=acc24(33)+acc24(32)+acc24(31)+acc24(14)+acc24(30)
      acc24(30)=QspQ*acc24(30)
      acc24(31)=acc24(23)*acc24(28)
      acc24(32)=Qspvak5k4*acc24(11)
      acc24(33)=Qspe3*acc24(13)
      acc24(34)=Qspvae3k1*acc24(1)
      acc24(31)=acc24(34)+acc24(33)+acc24(17)+acc24(32)+acc24(31)
      acc24(31)=Qspe2*acc24(31)
      acc24(28)=-acc24(20)*acc24(28)
      acc24(32)=Qspk2*acc24(25)
      acc24(33)=Qspvak5k4*acc24(8)
      acc24(34)=Qspe3*acc24(7)
      acc24(35)=Qspvae3k1*acc24(5)
      brack=acc24(28)+acc24(29)+acc24(30)+acc24(31)+acc24(32)+acc24(33)+acc24(3&
      &4)+acc24(35)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram24_sign, shift => diagram24_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd24h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d24
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k2
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d24 = 0.0_ki
      d24 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d24, ki), aimag(d24), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd24h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d24
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k2
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d24 = 0.0_ki
      d24 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d24, ki), aimag(d24), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d24h0l1
