module     dgaad_d68h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d68h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd68h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc68(25)
      complex(ki) :: Qspk4
      complex(ki) :: Qspk1
      complex(ki) :: Qspe2
      complex(ki) :: Qspe4
      complex(ki) :: Qspk2
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspk3
      complex(ki) :: Qspk5
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak5e3
      complex(ki) :: QspQ
      Qspk4 = dotproduct(Q,k4)
      Qspk1 = dotproduct(Q,k1)
      Qspe2 = dotproduct(Q,e2)
      Qspe4 = dotproduct(Q,e4)
      Qspk2 = dotproduct(Q,k2)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspk3 = dotproduct(Q,k3)
      Qspk5 = dotproduct(Q,k5)
      Qspe3 = dotproduct(Q,e3)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      QspQ = dotproduct(Q,Q)
      acc68(1)=abb68(5)
      acc68(2)=abb68(6)
      acc68(3)=abb68(7)
      acc68(4)=abb68(9)
      acc68(5)=abb68(10)
      acc68(6)=abb68(11)
      acc68(7)=abb68(12)
      acc68(8)=abb68(13)
      acc68(9)=abb68(15)
      acc68(10)=abb68(16)
      acc68(11)=abb68(17)
      acc68(12)=abb68(18)
      acc68(13)=abb68(19)
      acc68(14)=abb68(20)
      acc68(15)=abb68(22)
      acc68(16)=acc68(14)*Qspk4
      acc68(17)=acc68(13)*Qspk1
      acc68(18)=acc68(9)*Qspe2
      acc68(19)=acc68(8)*Qspe4
      acc68(20)=acc68(5)*Qspk2
      acc68(21)=acc68(3)*Qspvae4k1
      acc68(22)=acc68(2)*Qspvak5k3
      acc68(23)=acc68(1)*Qspvae2k1
      acc68(24)=Qspk3*acc68(15)
      acc68(25)=Qspk5*acc68(12)
      acc68(16)=acc68(25)+acc68(24)+acc68(23)+acc68(22)+acc68(21)+acc68(4)+acc6&
      &8(20)+acc68(19)+acc68(18)+acc68(16)+acc68(17)
      acc68(16)=Qspe3*acc68(16)
      acc68(17)=acc68(7)*Qspvak5e3
      acc68(18)=Qspk3*acc68(10)
      acc68(19)=Qspk5*acc68(11)
      acc68(20)=-mu2+QspQ
      acc68(20)=acc68(6)*acc68(20)
      brack=acc68(16)+acc68(17)+acc68(18)+acc68(19)+acc68(20)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram68_sign, shift => diagram68_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd68h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d68
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d68 = 0.0_ki
      d68 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d68, ki), aimag(d68), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd68h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d68
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d68 = 0.0_ki
      d68 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d68, ki), aimag(d68), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d68h0l1
