module     dgaad_d6h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity0d6h0l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd6h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc6(21)
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak2k4
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspe4
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspk4
      complex(ki) :: Qspk1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak2k3
      complex(ki) :: QspQ
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak2k4 = dotproduct(Q,spvak2k4)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspe4 = dotproduct(Q,e4)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspk4 = dotproduct(Q,k4)
      Qspk1 = dotproduct(Q,k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak2k3 = dotproduct(Q,spvak2k3)
      QspQ = dotproduct(Q,Q)
      acc6(1)=abb6(4)
      acc6(2)=abb6(5)
      acc6(3)=abb6(6)
      acc6(4)=abb6(7)
      acc6(5)=abb6(8)
      acc6(6)=abb6(9)
      acc6(7)=abb6(10)
      acc6(8)=abb6(11)
      acc6(9)=abb6(12)
      acc6(10)=abb6(13)
      acc6(11)=abb6(14)
      acc6(12)=abb6(15)
      acc6(13)=abb6(16)
      acc6(14)=acc6(11)*Qspvak5k1
      acc6(15)=acc6(7)*Qspvak5k4
      acc6(16)=acc6(6)*Qspvak2k4
      acc6(17)=acc6(1)*Qspvak2k1
      acc6(18)=Qspe4*acc6(4)
      acc6(19)=Qspvae4k1*acc6(3)
      acc6(20)=Qspk4-Qspk1
      acc6(21)=-acc6(8)*acc6(20)
      acc6(14)=acc6(21)+acc6(19)+acc6(18)+acc6(17)+acc6(16)+acc6(14)+acc6(15)
      acc6(14)=Qspe3*acc6(14)
      acc6(15)=acc6(13)*Qspvak5k3
      acc6(16)=acc6(12)*Qspvak2k3
      acc6(17)=Qspe4*acc6(9)
      acc6(18)=Qspvae4k1*acc6(2)
      acc6(19)=-mu2+QspQ
      acc6(19)=acc6(10)*acc6(19)
      acc6(20)=-acc6(5)*acc6(20)
      brack=acc6(14)+acc6(15)+acc6(16)+acc6(17)+acc6(18)+acc6(19)+acc6(20)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram6_sign, shift => diagram6_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd6h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d6
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d6 = 0.0_ki
      d6 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d6, ki), aimag(d6), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd6h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d6
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d6 = 0.0_ki
      d6 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d6, ki), aimag(d6), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d6h0l1
