module     dgaad_golem95h0
   use precision_golem, only: ki_gol => ki
   use dgaad_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
      module procedure reconstruct_group1
      module procedure reconstruct_group2
      module procedure reconstruct_group3
      module procedure reconstruct_group4
      module procedure reconstruct_group5
      module procedure reconstruct_group6
      module procedure reconstruct_group7
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use dgaad_config
   use dgaad_groups, only: tensrec_info_group0
   use dgaad_d6h0l1, only: numerator_d6 => numerator_golem95
   use dgaad_d16h0l1, only: numerator_d16 => numerator_golem95
   use dgaad_d26h0l1, only: numerator_d26 => numerator_golem95
   use dgaad_d60h0l1, only: numerator_d60 => numerator_golem95
   use dgaad_d125h0l1, only: numerator_d125 => numerator_golem95
   use dgaad_d160h0l1, only: numerator_d160 => numerator_golem95
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 6:
         call reconstruct2(numerator_d6, coeffs%coeffs_6, &
            & coeffs%coeffs_6s1)
   !------#] Diagram 6:
   !------#[ Diagram 16:
         call reconstruct1(numerator_d16, coeffs%coeffs_16)
   !------#] Diagram 16:
   !------#[ Diagram 26:
         call reconstruct3(numerator_d26, coeffs%coeffs_26, &
            & coeffs%coeffs_26s1)
   !------#] Diagram 26:
   !------#[ Diagram 60:
         call reconstruct3(numerator_d60, coeffs%coeffs_60, &
            & coeffs%coeffs_60s1)
   !------#] Diagram 60:
   !------#[ Diagram 125:
         call reconstruct2(numerator_d125, coeffs%coeffs_125, &
            & coeffs%coeffs_125s1)
   !------#] Diagram 125:
   !------#[ Diagram 160:
         call reconstruct4(numerator_d160, coeffs%coeffs_160)
   !------#] Diagram 160:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
!---#[ subroutine reconstruct_group1:
subroutine     reconstruct_group1(coeffs)
   use tens_rec
   use dgaad_config
   use dgaad_groups, only: tensrec_info_group1
   use dgaad_d7h0l1, only: numerator_d7 => numerator_golem95
   use dgaad_d9h0l1, only: numerator_d9 => numerator_golem95
   use dgaad_d27h0l1, only: numerator_d27 => numerator_golem95
   use dgaad_d63h0l1, only: numerator_d63 => numerator_golem95
   use dgaad_d68h0l1, only: numerator_d68 => numerator_golem95
   use dgaad_d159h0l1, only: numerator_d159 => numerator_golem95
   implicit none
   type(tensrec_info_group1), intent(out) :: coeffs
   !------#[ Diagram 7:
         call reconstruct2(numerator_d7, coeffs%coeffs_7, &
            & coeffs%coeffs_7s1)
   !------#] Diagram 7:
   !------#[ Diagram 9:
         call reconstruct1(numerator_d9, coeffs%coeffs_9)
   !------#] Diagram 9:
   !------#[ Diagram 27:
         call reconstruct3(numerator_d27, coeffs%coeffs_27, &
            & coeffs%coeffs_27s1)
   !------#] Diagram 27:
   !------#[ Diagram 63:
         call reconstruct3(numerator_d63, coeffs%coeffs_63, &
            & coeffs%coeffs_63s1)
   !------#] Diagram 63:
   !------#[ Diagram 68:
         call reconstruct2(numerator_d68, coeffs%coeffs_68, &
            & coeffs%coeffs_68s1)
   !------#] Diagram 68:
   !------#[ Diagram 159:
         call reconstruct4(numerator_d159, coeffs%coeffs_159)
   !------#] Diagram 159:
end subroutine reconstruct_group1
!---#] subroutine reconstruct_group1:
!---#[ subroutine reconstruct_group2:
subroutine     reconstruct_group2(coeffs)
   use tens_rec
   use dgaad_config
   use dgaad_groups, only: tensrec_info_group2
   use dgaad_d24h0l1, only: numerator_d24 => numerator_golem95
   use dgaad_d29h0l1, only: numerator_d29 => numerator_golem95
   use dgaad_d66h0l1, only: numerator_d66 => numerator_golem95
   use dgaad_d82h0l1, only: numerator_d82 => numerator_golem95
   use dgaad_d95h0l1, only: numerator_d95 => numerator_golem95
   use dgaad_d157h0l1, only: numerator_d157 => numerator_golem95
   implicit none
   type(tensrec_info_group2), intent(out) :: coeffs
   !------#[ Diagram 24:
         call reconstruct3(numerator_d24, coeffs%coeffs_24, &
            & coeffs%coeffs_24s1)
   !------#] Diagram 24:
   !------#[ Diagram 29:
         call reconstruct4(numerator_d29, coeffs%coeffs_29, &
            & coeffs%coeffs_29s1, coeffs%coeffs_29s2)
   !------#] Diagram 29:
   !------#[ Diagram 66:
         call reconstruct3(numerator_d66, coeffs%coeffs_66, &
            & coeffs%coeffs_66s1)
   !------#] Diagram 66:
   !------#[ Diagram 82:
         call reconstruct3(numerator_d82, coeffs%coeffs_82, &
            & coeffs%coeffs_82s1)
   !------#] Diagram 82:
   !------#[ Diagram 95:
         call reconstruct3(numerator_d95, coeffs%coeffs_95, &
            & coeffs%coeffs_95s1)
   !------#] Diagram 95:
   !------#[ Diagram 157:
         call reconstruct4(numerator_d157, coeffs%coeffs_157)
   !------#] Diagram 157:
end subroutine reconstruct_group2
!---#] subroutine reconstruct_group2:
!---#[ subroutine reconstruct_group3:
subroutine     reconstruct_group3(coeffs)
   use tens_rec
   use dgaad_config
   use dgaad_groups, only: tensrec_info_group3
   use dgaad_d39h0l1, only: numerator_d39 => numerator_golem95
   use dgaad_d65h0l1, only: numerator_d65 => numerator_golem95
   use dgaad_d155h0l1, only: numerator_d155 => numerator_golem95
   implicit none
   type(tensrec_info_group3), intent(out) :: coeffs
   !------#[ Diagram 39:
         call reconstruct4(numerator_d39, coeffs%coeffs_39, &
            & coeffs%coeffs_39s1, coeffs%coeffs_39s2)
   !------#] Diagram 39:
   !------#[ Diagram 65:
         call reconstruct3(numerator_d65, coeffs%coeffs_65, &
            & coeffs%coeffs_65s1)
   !------#] Diagram 65:
   !------#[ Diagram 155:
         call reconstruct4(numerator_d155, coeffs%coeffs_155)
   !------#] Diagram 155:
end subroutine reconstruct_group3
!---#] subroutine reconstruct_group3:
!---#[ subroutine reconstruct_group4:
subroutine     reconstruct_group4(coeffs)
   use tens_rec
   use dgaad_config
   use dgaad_groups, only: tensrec_info_group4
   use dgaad_d23h0l1, only: numerator_d23 => numerator_golem95
   use dgaad_d158h0l1, only: numerator_d158 => numerator_golem95
   implicit none
   type(tensrec_info_group4), intent(out) :: coeffs
   !------#[ Diagram 23:
         call reconstruct3(numerator_d23, coeffs%coeffs_23, &
            & coeffs%coeffs_23s1)
   !------#] Diagram 23:
   !------#[ Diagram 158:
         call reconstruct4(numerator_d158, coeffs%coeffs_158)
   !------#] Diagram 158:
end subroutine reconstruct_group4
!---#] subroutine reconstruct_group4:
!---#[ subroutine reconstruct_group5:
subroutine     reconstruct_group5(coeffs)
   use tens_rec
   use dgaad_config
   use dgaad_groups, only: tensrec_info_group5
   use dgaad_d49h0l1, only: numerator_d49 => numerator_golem95
   use dgaad_d62h0l1, only: numerator_d62 => numerator_golem95
   use dgaad_d156h0l1, only: numerator_d156 => numerator_golem95
   implicit none
   type(tensrec_info_group5), intent(out) :: coeffs
   !------#[ Diagram 49:
         call reconstruct4(numerator_d49, coeffs%coeffs_49, &
            & coeffs%coeffs_49s1, coeffs%coeffs_49s2)
   !------#] Diagram 49:
   !------#[ Diagram 62:
         call reconstruct3(numerator_d62, coeffs%coeffs_62, &
            & coeffs%coeffs_62s1)
   !------#] Diagram 62:
   !------#[ Diagram 156:
         call reconstruct4(numerator_d156, coeffs%coeffs_156)
   !------#] Diagram 156:
end subroutine reconstruct_group5
!---#] subroutine reconstruct_group5:
!---#[ subroutine reconstruct_group6:
subroutine     reconstruct_group6(coeffs)
   use tens_rec
   use dgaad_config
   use dgaad_groups, only: tensrec_info_group6
   use dgaad_d1h0l1, only: numerator_d1 => numerator_golem95
   use dgaad_d21h0l1, only: numerator_d21 => numerator_golem95
   use dgaad_d28h0l1, only: numerator_d28 => numerator_golem95
   use dgaad_d61h0l1, only: numerator_d61 => numerator_golem95
   use dgaad_d154h0l1, only: numerator_d154 => numerator_golem95
   implicit none
   type(tensrec_info_group6), intent(out) :: coeffs
   !------#[ Diagram 1:
         call reconstruct2(numerator_d1, coeffs%coeffs_1, &
            & coeffs%coeffs_1s1)
   !------#] Diagram 1:
   !------#[ Diagram 21:
         call reconstruct3(numerator_d21, coeffs%coeffs_21, &
            & coeffs%coeffs_21s1)
   !------#] Diagram 21:
   !------#[ Diagram 28:
         call reconstruct3(numerator_d28, coeffs%coeffs_28, &
            & coeffs%coeffs_28s1)
   !------#] Diagram 28:
   !------#[ Diagram 61:
         call reconstruct3(numerator_d61, coeffs%coeffs_61, &
            & coeffs%coeffs_61s1)
   !------#] Diagram 61:
   !------#[ Diagram 154:
         call reconstruct4(numerator_d154, coeffs%coeffs_154)
   !------#] Diagram 154:
end subroutine reconstruct_group6
!---#] subroutine reconstruct_group6:
!---#[ subroutine reconstruct_group7:
subroutine     reconstruct_group7(coeffs)
   use tens_rec
   use dgaad_config
   use dgaad_groups, only: tensrec_info_group7
   use dgaad_d2h0l1, only: numerator_d2 => numerator_golem95
   use dgaad_d3h0l1, only: numerator_d3 => numerator_golem95
   use dgaad_d4h0l1, only: numerator_d4 => numerator_golem95
   use dgaad_d10h0l1, only: numerator_d10 => numerator_golem95
   use dgaad_d11h0l1, only: numerator_d11 => numerator_golem95
   use dgaad_d15h0l1, only: numerator_d15 => numerator_golem95
   use dgaad_d17h0l1, only: numerator_d17 => numerator_golem95
   use dgaad_d22h0l1, only: numerator_d22 => numerator_golem95
   use dgaad_d25h0l1, only: numerator_d25 => numerator_golem95
   use dgaad_d59h0l1, only: numerator_d59 => numerator_golem95
   use dgaad_d64h0l1, only: numerator_d64 => numerator_golem95
   use dgaad_d67h0l1, only: numerator_d67 => numerator_golem95
   use dgaad_d80h0l1, only: numerator_d80 => numerator_golem95
   use dgaad_d126h0l1, only: numerator_d126 => numerator_golem95
   use dgaad_d138h0l1, only: numerator_d138 => numerator_golem95
   use dgaad_d153h0l1, only: numerator_d153 => numerator_golem95
   implicit none
   type(tensrec_info_group7), intent(out) :: coeffs
   !------#[ Diagram 2:
         call reconstruct2(numerator_d2, coeffs%coeffs_2, &
            & coeffs%coeffs_2s1)
   !------#] Diagram 2:
   !------#[ Diagram 3:
         call reconstruct2(numerator_d3, coeffs%coeffs_3, &
            & coeffs%coeffs_3s1)
   !------#] Diagram 3:
   !------#[ Diagram 4:
         call reconstruct2(numerator_d4, coeffs%coeffs_4, &
            & coeffs%coeffs_4s1)
   !------#] Diagram 4:
   !------#[ Diagram 10:
         call reconstruct1(numerator_d10, coeffs%coeffs_10)
   !------#] Diagram 10:
   !------#[ Diagram 11:
         call reconstruct1(numerator_d11, coeffs%coeffs_11)
   !------#] Diagram 11:
   !------#[ Diagram 15:
         call reconstruct1(numerator_d15, coeffs%coeffs_15)
   !------#] Diagram 15:
   !------#[ Diagram 17:
         call reconstruct1(numerator_d17, coeffs%coeffs_17)
   !------#] Diagram 17:
   !------#[ Diagram 22:
         call reconstruct3(numerator_d22, coeffs%coeffs_22, &
            & coeffs%coeffs_22s1)
   !------#] Diagram 22:
   !------#[ Diagram 25:
         call reconstruct3(numerator_d25, coeffs%coeffs_25, &
            & coeffs%coeffs_25s1)
   !------#] Diagram 25:
   !------#[ Diagram 59:
         call reconstruct3(numerator_d59, coeffs%coeffs_59, &
            & coeffs%coeffs_59s1)
   !------#] Diagram 59:
   !------#[ Diagram 64:
         call reconstruct3(numerator_d64, coeffs%coeffs_64, &
            & coeffs%coeffs_64s1)
   !------#] Diagram 64:
   !------#[ Diagram 67:
         call reconstruct2(numerator_d67, coeffs%coeffs_67, &
            & coeffs%coeffs_67s1)
   !------#] Diagram 67:
   !------#[ Diagram 80:
         call reconstruct2(numerator_d80, coeffs%coeffs_80, &
            & coeffs%coeffs_80s1)
   !------#] Diagram 80:
   !------#[ Diagram 126:
         call reconstruct2(numerator_d126, coeffs%coeffs_126, &
            & coeffs%coeffs_126s1)
   !------#] Diagram 126:
   !------#[ Diagram 138:
         call reconstruct2(numerator_d138, coeffs%coeffs_138, &
            & coeffs%coeffs_138s1)
   !------#] Diagram 138:
   !------#[ Diagram 153:
         call reconstruct4(numerator_d153, coeffs%coeffs_153)
   !------#] Diagram 153:
end subroutine reconstruct_group7
!---#] subroutine reconstruct_group7:
end module dgaad_golem95h0
