module     dgaad_abbrevd1h8
   use dgaad_config, only: ki
   use dgaad_globalsh8
   implicit none
   private
   complex(ki), dimension(17), public :: abb1
   complex(ki), public :: R2d1
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb1(1)=1.0_ki/(-es34+es12-es45)
      abb1(2)=NC**(-1)
      abb1(3)=es12**(-1)
      abb1(4)=NC-abb1(2)
      abb1(5)=i_*TR*c1*spbk5e3*abb1(3)*abb1(1)
      abb1(6)=abb1(4)*abb1(5)*spae4k4
      abb1(7)=spae3k3*abb1(6)
      abb1(8)=abb1(7)*spbk4k3
      abb1(6)=spae3k5*abb1(6)
      abb1(9)=abb1(6)*spbk5k4
      abb1(8)=abb1(8)-abb1(9)
      abb1(8)=abb1(8)*spbe4k2
      abb1(7)=abb1(7)*spbe4k3
      abb1(6)=abb1(6)*spbk5e4
      abb1(6)=abb1(7)-abb1(6)
      abb1(6)=abb1(6)*spbk4k2
      abb1(6)=abb1(8)-abb1(6)
      abb1(7)=2.0_ki/9.0_ki*spak1k2*abb1(6)
      abb1(8)=-abb1(5)*abb1(4)
      abb1(9)=-spbk5k2*spae3k5*abb1(8)
      abb1(8)=-spbk3k2*spae3k3*abb1(8)
      abb1(8)=abb1(9)+abb1(8)
      abb1(9)=8.0_ki/9.0_ki*spak1k2*abb1(8)
      abb1(4)=-abb1(4)*abb1(5)*spak1e2
      abb1(5)=-spae3k5*abb1(4)
      abb1(10)=-spae4k4*abb1(5)
      abb1(11)=abb1(10)*spbk5e4
      abb1(4)=-spae3k3*abb1(4)
      abb1(12)=-spae4k4*abb1(4)
      abb1(13)=abb1(12)*spbe4k3
      abb1(11)=abb1(11)-abb1(13)
      abb1(13)=abb1(11)*spbk4e2
      abb1(10)=abb1(10)*spbk5k4
      abb1(12)=abb1(12)*spbk4k3
      abb1(10)=abb1(10)-abb1(12)
      abb1(12)=abb1(10)*spbe4e2
      abb1(12)=abb1(13)-abb1(12)
      abb1(12)=2.0_ki/9.0_ki*abb1(12)
      abb1(13)=abb1(5)*spbk5e2
      abb1(14)=abb1(4)*spbk3e2
      abb1(13)=abb1(13)+abb1(14)
      abb1(13)=8.0_ki/9.0_ki*abb1(13)
      abb1(14)=abb1(4)*spbk2e2
      abb1(15)=abb1(14)*spbe4k3
      abb1(16)=abb1(5)*spbk2e2
      abb1(17)=abb1(16)*spbk5e4
      abb1(15)=abb1(15)-abb1(17)
      abb1(17)=1.0_ki/9.0_ki*spak2e4
      abb1(15)=abb1(15)*abb1(17)
      abb1(6)=-spae2k2*abb1(6)
      abb1(10)=spbe4k1*abb1(10)
      abb1(11)=-spbk4k1*abb1(11)
      abb1(6)=abb1(11)+abb1(10)+abb1(6)
      abb1(6)=1.0_ki/9.0_ki*abb1(6)
      abb1(8)=-spae2k2*abb1(8)
      abb1(5)=spbk5k1*abb1(5)
      abb1(4)=spbk3k1*abb1(4)
      abb1(4)=abb1(4)+abb1(5)+abb1(8)
      abb1(4)=4.0_ki/9.0_ki*abb1(4)
      abb1(5)=abb1(17)*spbk4e4
      abb1(8)=-abb1(16)*abb1(5)
      abb1(5)=-abb1(14)*abb1(5)
      abb1(10)=2.0_ki/9.0_ki*abb1(16)
      abb1(11)=2.0_ki/9.0_ki*abb1(14)
      R2d1=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d1
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='1' value='", &
          & R2d1, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd1h8
