module     dgaad_abbrevd63h8
   use dgaad_config, only: ki
   use dgaad_globalsh8
   implicit none
   private
   complex(ki), dimension(36), public :: abb63
   complex(ki), public :: R2d63
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb63(1)=1.0_ki/(-es34+es12-es45)
      abb63(2)=NC**(-1)
      abb63(3)=spak1k4*spbk4e2
      abb63(4)=-spak1k2*spbk2e2
      abb63(3)=abb63(4)+abb63(3)
      abb63(4)=i_*TR*c1*spbk5e3*abb63(2)*abb63(1)
      abb63(5)=abb63(4)*spae3k3
      abb63(6)=abb63(5)*spbe4k3
      abb63(4)=abb63(4)*spae3k5
      abb63(7)=abb63(4)*spbk5e4
      abb63(6)=abb63(6)-abb63(7)
      abb63(7)=-spae2e4*abb63(6)
      abb63(3)=abb63(7)*abb63(3)
      abb63(8)=spae4k4*spbk4e2
      abb63(9)=-abb63(8)*abb63(6)
      abb63(10)=spak1e2*abb63(9)
      abb63(3)=abb63(10)+abb63(3)
      abb63(3)=1.0_ki/9.0_ki*abb63(3)
      abb63(10)=2.0_ki/9.0_ki*abb63(6)
      abb63(11)=-spak1e4*abb63(10)
      abb63(12)=2.0_ki/9.0_ki*spak1k4
      abb63(13)=abb63(4)*spbk4e2
      abb63(14)=-abb63(13)*abb63(12)
      abb63(15)=abb63(4)*spak1e4
      abb63(16)=abb63(15)*spbe4e2
      abb63(17)=2.0_ki/9.0_ki*abb63(16)
      abb63(16)=1.0_ki/9.0_ki*abb63(16)
      abb63(18)=abb63(5)*spbk4e2
      abb63(12)=-abb63(18)*abb63(12)
      abb63(19)=abb63(5)*spak1e4
      abb63(20)=abb63(19)*spbe4e2
      abb63(21)=2.0_ki/9.0_ki*abb63(20)
      abb63(20)=1.0_ki/9.0_ki*abb63(20)
      abb63(22)=abb63(4)*spae2k4
      abb63(23)=abb63(22)*spbk5k4
      abb63(24)=abb63(5)*spae2k4
      abb63(25)=abb63(24)*spbk4k3
      abb63(23)=abb63(23)-abb63(25)
      abb63(25)=spak2e4*spbk2e2
      abb63(8)=abb63(25)+abb63(8)
      abb63(8)=-1.0_ki/9.0_ki*abb63(8)*abb63(23)
      abb63(26)=-spbk5k4*abb63(4)
      abb63(27)=spbk4k3*abb63(5)
      abb63(26)=abb63(26)+abb63(27)
      abb63(27)=2.0_ki/9.0_ki*spae4k4
      abb63(26)=abb63(26)*abb63(27)
      abb63(27)=abb63(5)*spbk3e2
      abb63(28)=abb63(4)*spbk5e2
      abb63(27)=abb63(27)+abb63(28)
      abb63(28)=spae2e4*abb63(27)
      abb63(29)=-2.0_ki/9.0_ki*abb63(28)
      abb63(28)=-1.0_ki/9.0_ki*abb63(28)
      abb63(30)=spbk5k2*abb63(4)
      abb63(31)=spbk3k2*abb63(5)
      abb63(30)=abb63(31)+abb63(30)
      abb63(30)=spae2k2*abb63(30)
      abb63(23)=-2.0_ki*abb63(23)+abb63(30)
      abb63(23)=2.0_ki/9.0_ki*abb63(23)
      abb63(30)=2.0_ki/9.0_ki*abb63(7)
      abb63(7)=1.0_ki/9.0_ki*abb63(7)
      abb63(31)=spbk4e4*spak1e4
      abb63(31)=1.0_ki/9.0_ki*abb63(31)
      abb63(32)=abb63(31)*abb63(22)
      abb63(33)=spbk4e2*abb63(32)
      abb63(34)=2.0_ki/9.0_ki*spak1e2
      abb63(13)=abb63(13)*abb63(34)
      abb63(35)=2.0_ki/9.0_ki*spbk4e4
      abb63(15)=abb63(15)*abb63(35)
      abb63(31)=abb63(31)*abb63(24)
      abb63(36)=spbk4e2*abb63(31)
      abb63(18)=abb63(18)*abb63(34)
      abb63(19)=abb63(19)*abb63(35)
      abb63(32)=-spbk2e2*abb63(32)
      abb63(34)=abb63(34)*spbk2e2
      abb63(35)=-abb63(4)*abb63(34)
      abb63(31)=-spbk2e2*abb63(31)
      abb63(34)=-abb63(5)*abb63(34)
      abb63(4)=4.0_ki/9.0_ki*abb63(4)
      abb63(6)=-abb63(6)*abb63(25)
      abb63(6)=abb63(6)+abb63(9)
      abb63(6)=1.0_ki/9.0_ki*spae2k4*abb63(6)
      abb63(9)=spbk5e2*abb63(22)
      abb63(22)=spbk3e2*abb63(24)
      abb63(9)=abb63(9)+abb63(22)
      abb63(9)=4.0_ki/9.0_ki*abb63(9)
      abb63(10)=-spae4k4*abb63(10)
      abb63(5)=4.0_ki/9.0_ki*abb63(5)
      abb63(22)=-2.0_ki/9.0_ki*spae2k2*abb63(27)
      R2d63=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d63
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='63' value='", &
          & R2d63, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd63h8
