module     dgaad_abbrevd67h8
   use dgaad_config, only: ki
   use dgaad_globalsh8
   implicit none
   private
   complex(ki), dimension(23), public :: abb67
   complex(ki), public :: R2d67
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use dgaad_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use dgaad_kinematics
      use dgaad_model
      use dgaad_color, only: TR
      use dgaad_globalsl1, only: epspow
      implicit none
      abb67(1)=NC**(-1)
      abb67(2)=es12**(-1)
      abb67(3)=1.0_ki/(-es23-es12+es45)
      abb67(4)=es45**(-1)
      abb67(5)=spbk5e2*spbe3k1
      abb67(6)=i_*TR
      abb67(7)=abb67(6)*spak1e2
      abb67(8)=-abb67(5)*abb67(7)
      abb67(9)=spae2k3*spbk3e3
      abb67(10)=abb67(9)*spbk5e2
      abb67(11)=abb67(10)*abb67(6)
      abb67(8)=abb67(8)+abb67(11)
      abb67(11)=spak1e3*abb67(3)
      abb67(12)=NC-abb67(1)
      abb67(8)=abb67(8)*abb67(12)*c1*abb67(11)
      abb67(13)=spbk2e2*abb67(2)
      abb67(14)=abb67(13)*spak2e3
      abb67(15)=abb67(14)*spbk5e3
      abb67(7)=abb67(15)*c1*abb67(12)*abb67(7)
      abb67(7)=abb67(7)+abb67(8)
      abb67(7)=2.0_ki/9.0_ki*abb67(7)
      abb67(8)=NC*spak1e2
      abb67(6)=abb67(6)*abb67(4)*c1
      abb67(16)=abb67(8)*abb67(6)
      abb67(17)=abb67(6)*abb67(1)
      abb67(18)=abb67(17)*spak1e2
      abb67(16)=abb67(18)-abb67(16)
      abb67(13)=spak2k4*spbk5k4*abb67(16)*abb67(13)
      abb67(18)=abb67(6)*NC
      abb67(17)=abb67(18)-abb67(17)
      abb67(18)=spae2k4*spbk5k4
      abb67(19)=abb67(18)*spbk3e2*abb67(17)*abb67(3)
      abb67(20)=-spak1k3*abb67(19)
      abb67(13)=abb67(13)+abb67(20)
      abb67(13)=8.0_ki/9.0_ki*abb67(13)
      abb67(20)=-spak3k4*spbk3e3
      abb67(21)=-spak1k4*spbe3k1
      abb67(20)=abb67(20)+abb67(21)
      abb67(6)=abb67(6)*abb67(11)
      abb67(11)=-abb67(6)*abb67(12)
      abb67(12)=abb67(11)*spbk5k4*abb67(20)
      abb67(20)=abb67(2)*spae3k4*spbk5k4
      abb67(17)=abb67(17)*abb67(20)*spbe3k2
      abb67(21)=-spak1k2*abb67(17)
      abb67(12)=abb67(21)+abb67(12)
      abb67(12)=8.0_ki/9.0_ki*abb67(12)
      abb67(21)=abb67(1)*spak1e2
      abb67(8)=abb67(8)-abb67(21)
      abb67(6)=abb67(6)*abb67(8)
      abb67(8)=abb67(6)*spbe3k1
      abb67(9)=abb67(11)*abb67(9)
      abb67(8)=abb67(9)+abb67(8)
      abb67(9)=spbe4e2*abb67(8)
      abb67(14)=abb67(16)*abb67(14)
      abb67(21)=spbe4e3*abb67(14)
      abb67(9)=abb67(9)+abb67(21)
      abb67(9)=abb67(9)*spae4k4*spbk5k4
      abb67(8)=abb67(8)*spbk4e2
      abb67(14)=abb67(14)*spbk4e3
      abb67(8)=abb67(8)+abb67(14)
      abb67(14)=abb67(8)*spae4k4*spbk5e4
      abb67(21)=-abb67(14)+abb67(9)
      abb67(21)=2.0_ki/9.0_ki*abb67(21)
      abb67(5)=abb67(5)*abb67(6)
      abb67(6)=abb67(10)*abb67(11)
      abb67(10)=abb67(15)*abb67(16)
      abb67(5)=abb67(10)+abb67(6)+abb67(5)
      abb67(6)=-4.0_ki/9.0_ki*abb67(5)
      abb67(10)=abb67(5)*spae4k5*spbk5e4
      abb67(9)=abb67(10)+abb67(9)
      abb67(9)=2.0_ki/9.0_ki*abb67(9)
      abb67(15)=-8.0_ki/9.0_ki*abb67(5)
      abb67(11)=abb67(18)*abb67(11)
      abb67(18)=8.0_ki/9.0_ki*spbe3e2
      abb67(22)=-abb67(11)*abb67(18)
      abb67(16)=abb67(20)*abb67(16)
      abb67(20)=-abb67(16)*abb67(18)
      abb67(23)=-abb67(16)+abb67(11)
      abb67(18)=abb67(23)*abb67(18)
      abb67(10)=abb67(14)+abb67(10)
      abb67(10)=1.0_ki/9.0_ki*abb67(10)
      abb67(5)=-1.0_ki/9.0_ki*spak4k5*spbk4e4*abb67(5)
      abb67(14)=spae3k3*abb67(19)
      abb67(11)=spbe2k1*abb67(11)
      abb67(11)=abb67(14)+abb67(11)
      abb67(11)=4.0_ki/9.0_ki*abb67(11)
      abb67(14)=spbe3k1*abb67(16)
      abb67(16)=spae2k2*abb67(17)
      abb67(14)=abb67(14)+abb67(16)
      abb67(14)=4.0_ki/9.0_ki*abb67(14)
      abb67(8)=2.0_ki/9.0_ki*abb67(8)
      R2d67=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d67
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='67' value='", &
          & R2d67, "'/>"
      end if
   end subroutine
end module dgaad_abbrevd67h8
