module     dgaad_d3h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/dg_aad/helicity8d3h8l1.f90
   ! generator: buildfortran.py
   use dgaad_config, only: ki
   use dgaad_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use dgaad_model
      use dgaad_kinematics
      use dgaad_color
      use dgaad_abbrevd3h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc3(20)
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak3k5
      complex(ki) :: Qspvak3k2
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspe4
      complex(ki) :: Qspk3
      complex(ki) :: Qspk1
      complex(ki) :: QspQ
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspvak4k2
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspe3 = dotproduct(Q,e3)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      Qspvak3k2 = dotproduct(Q,spvak3k2)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspe4 = dotproduct(Q,e4)
      Qspk3 = dotproduct(Q,k3)
      Qspk1 = dotproduct(Q,k1)
      QspQ = dotproduct(Q,Q)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspvak4k2 = dotproduct(Q,spvak4k2)
      acc3(1)=abb3(4)
      acc3(2)=abb3(5)
      acc3(3)=abb3(6)
      acc3(4)=abb3(7)
      acc3(5)=abb3(8)
      acc3(6)=abb3(9)
      acc3(7)=abb3(10)
      acc3(8)=abb3(11)
      acc3(9)=abb3(12)
      acc3(10)=abb3(13)
      acc3(11)=abb3(14)
      acc3(12)=abb3(15)
      acc3(13)=abb3(16)
      acc3(14)=acc3(3)*Qspvak1e3
      acc3(15)=acc3(4)*Qspe3
      acc3(16)=Qspvak3k5*acc3(13)
      acc3(17)=Qspvak3k2*acc3(12)
      acc3(18)=Qspvak1k5*acc3(11)
      acc3(19)=Qspvak1k2*acc3(1)
      acc3(14)=acc3(19)+acc3(18)+acc3(17)+acc3(16)+acc3(15)+acc3(14)
      acc3(14)=Qspe4*acc3(14)
      acc3(15)=-Qspk3+Qspk1
      acc3(16)=acc3(8)*Qspe4
      acc3(16)=acc3(16)-acc3(5)
      acc3(15)=acc3(16)*acc3(15)
      acc3(16)=mu2-QspQ
      acc3(16)=acc3(10)*acc3(16)
      acc3(17)=acc3(2)*Qspvak1e3
      acc3(18)=acc3(9)*Qspe3
      acc3(19)=Qspvak4k5*acc3(7)
      acc3(20)=Qspvak4k2*acc3(6)
      brack=acc3(14)+acc3(15)+acc3(16)+acc3(17)+acc3(18)+acc3(19)+acc3(20)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use dgaad_groups, only: &
!           & sign => diagram3_sign, shift => diagram3_shift
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd3h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d3
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k5+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d3 = 0.0_ki
      d3 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d3, ki), aimag(d3), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use dgaad_globalsl1, only: epspow
      use dgaad_kinematics
      use dgaad_abbrevd3h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d3
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k5+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d3 = 0.0_ki
      d3 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d3, ki), aimag(d3), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module dgaad_d3h8l1
