module     ugaau_abbrevd2h0
   use ugaau_config, only: ki
   use ugaau_globalsh0
   implicit none
   private
   complex(ki), dimension(17), public :: abb2
   complex(ki), public :: R2d2
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb2(1)=NC**(-1)
      abb2(2)=es45**(-1)
      abb2(3)=es12**(-1)
      abb2(4)=NC-abb2(1)
      abb2(5)=i_*TR*c1*spae4k5*abb2(3)*abb2(2)
      abb2(6)=abb2(4)*abb2(5)*spbk3e3
      abb2(7)=spbk4e4*abb2(6)
      abb2(8)=abb2(7)*spak3k4
      abb2(6)=spbk5e4*abb2(6)
      abb2(9)=abb2(6)*spak3k5
      abb2(8)=abb2(8)+abb2(9)
      abb2(8)=abb2(8)*spak2e3
      abb2(7)=abb2(7)*spae3k4
      abb2(6)=abb2(6)*spae3k5
      abb2(6)=abb2(7)+abb2(6)
      abb2(6)=abb2(6)*spak2k3
      abb2(6)=abb2(8)-abb2(6)
      abb2(7)=-8.0_ki/9.0_ki*spbk2k1*abb2(6)
      abb2(8)=-abb2(5)*abb2(4)
      abb2(9)=-spak2k5*spbk5e4*abb2(8)
      abb2(8)=-spak2k4*spbk4e4*abb2(8)
      abb2(8)=abb2(9)+abb2(8)
      abb2(9)=32.0_ki/9.0_ki*spbk2k1*abb2(8)
      abb2(4)=-abb2(4)*abb2(5)*spbe2k1
      abb2(5)=-spbk5e4*abb2(4)
      abb2(10)=-spbk3e3*abb2(5)
      abb2(11)=abb2(10)*spae3k5
      abb2(4)=-spbk4e4*abb2(4)
      abb2(12)=-spbk3e3*abb2(4)
      abb2(13)=abb2(12)*spae3k4
      abb2(11)=abb2(11)+abb2(13)
      abb2(13)=abb2(11)*spae2k3
      abb2(10)=abb2(10)*spak3k5
      abb2(12)=abb2(12)*spak3k4
      abb2(10)=abb2(10)+abb2(12)
      abb2(12)=abb2(10)*spae2e3
      abb2(12)=abb2(13)-abb2(12)
      abb2(12)=8.0_ki/9.0_ki*abb2(12)
      abb2(13)=abb2(5)*spae2k5
      abb2(14)=abb2(4)*spae2k4
      abb2(13)=abb2(13)+abb2(14)
      abb2(13)=32.0_ki/9.0_ki*abb2(13)
      abb2(14)=abb2(4)*spae2k2
      abb2(15)=abb2(14)*spae3k4
      abb2(16)=abb2(5)*spae2k2
      abb2(17)=abb2(16)*spae3k5
      abb2(15)=abb2(15)+abb2(17)
      abb2(17)=4.0_ki/9.0_ki*spbe3k2
      abb2(15)=abb2(15)*abb2(17)
      abb2(6)=spbk2e2*abb2(6)
      abb2(10)=spak1e3*abb2(10)
      abb2(11)=-spak1k3*abb2(11)
      abb2(6)=abb2(11)+abb2(10)+abb2(6)
      abb2(6)=4.0_ki/9.0_ki*abb2(6)
      abb2(8)=-spbk2e2*abb2(8)
      abb2(5)=spak1k5*abb2(5)
      abb2(4)=spak1k4*abb2(4)
      abb2(4)=abb2(4)+abb2(5)+abb2(8)
      abb2(4)=16.0_ki/9.0_ki*abb2(4)
      abb2(5)=abb2(17)*spae3k3
      abb2(8)=-abb2(16)*abb2(5)
      abb2(10)=8.0_ki/9.0_ki*abb2(16)
      abb2(5)=-abb2(14)*abb2(5)
      abb2(11)=8.0_ki/9.0_ki*abb2(14)
      R2d2=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d2
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='2' value='", &
          & R2d2, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd2h0
