module     ugaau_abbrevd67h0
   use ugaau_config, only: ki
   use ugaau_globalsh0
   implicit none
   private
   complex(ki), dimension(23), public :: abb67
   complex(ki), public :: R2d67
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb67(1)=NC**(-1)
      abb67(2)=es12**(-1)
      abb67(3)=1.0_ki/(-es23-es12+es45)
      abb67(4)=es45**(-1)
      abb67(5)=spae2k5*spak1e3
      abb67(6)=i_*TR
      abb67(7)=abb67(6)*spbe2k1
      abb67(8)=-abb67(5)*abb67(7)
      abb67(9)=spbk3e2*spae3k3
      abb67(10)=abb67(9)*spae2k5
      abb67(11)=abb67(10)*abb67(6)
      abb67(8)=abb67(8)+abb67(11)
      abb67(11)=spbe3k1*abb67(3)
      abb67(12)=NC-abb67(1)
      abb67(8)=abb67(8)*abb67(12)*c1*abb67(11)
      abb67(13)=spae2k2*abb67(2)
      abb67(14)=abb67(13)*spbe3k2
      abb67(15)=abb67(14)*spae3k5
      abb67(7)=abb67(15)*c1*abb67(12)*abb67(7)
      abb67(7)=abb67(7)+abb67(8)
      abb67(7)=8.0_ki/9.0_ki*abb67(7)
      abb67(8)=NC*spbe2k1
      abb67(6)=abb67(6)*abb67(4)*c1
      abb67(16)=abb67(8)*abb67(6)
      abb67(17)=abb67(6)*abb67(1)
      abb67(18)=abb67(17)*spbe2k1
      abb67(16)=abb67(18)-abb67(16)
      abb67(13)=spbk4k2*spak4k5*abb67(16)*abb67(13)
      abb67(18)=abb67(6)*NC
      abb67(17)=abb67(18)-abb67(17)
      abb67(18)=spbk4e2*spak4k5
      abb67(19)=abb67(18)*spae2k3*abb67(17)*abb67(3)
      abb67(20)=-spbk3k1*abb67(19)
      abb67(13)=abb67(13)+abb67(20)
      abb67(13)=32.0_ki/9.0_ki*abb67(13)
      abb67(20)=-spbk4k3*spae3k3
      abb67(21)=-spbk4k1*spak1e3
      abb67(20)=abb67(20)+abb67(21)
      abb67(6)=abb67(6)*abb67(11)
      abb67(11)=-abb67(6)*abb67(12)
      abb67(12)=abb67(11)*spak4k5*abb67(20)
      abb67(20)=abb67(2)*spbk4e3*spak4k5
      abb67(17)=abb67(17)*abb67(20)*spak2e3
      abb67(21)=-spbk2k1*abb67(17)
      abb67(12)=abb67(21)+abb67(12)
      abb67(12)=32.0_ki/9.0_ki*abb67(12)
      abb67(21)=abb67(1)*spbe2k1
      abb67(8)=abb67(8)-abb67(21)
      abb67(6)=abb67(6)*abb67(8)
      abb67(8)=abb67(6)*spak1e3
      abb67(9)=abb67(11)*abb67(9)
      abb67(8)=abb67(9)+abb67(8)
      abb67(9)=spae2e4*abb67(8)
      abb67(14)=abb67(16)*abb67(14)
      abb67(21)=spae3e4*abb67(14)
      abb67(9)=abb67(9)+abb67(21)
      abb67(9)=abb67(9)*spbk4e4*spak4k5
      abb67(8)=abb67(8)*spae2k4
      abb67(14)=abb67(14)*spae3k4
      abb67(8)=abb67(8)+abb67(14)
      abb67(14)=abb67(8)*spbk4e4*spae4k5
      abb67(21)=-abb67(14)+abb67(9)
      abb67(21)=8.0_ki/9.0_ki*abb67(21)
      abb67(5)=abb67(5)*abb67(6)
      abb67(6)=abb67(10)*abb67(11)
      abb67(10)=abb67(15)*abb67(16)
      abb67(5)=abb67(10)+abb67(6)+abb67(5)
      abb67(6)=-16.0_ki/9.0_ki*abb67(5)
      abb67(10)=abb67(5)*spbk5e4*spae4k5
      abb67(9)=abb67(10)+abb67(9)
      abb67(9)=8.0_ki/9.0_ki*abb67(9)
      abb67(15)=-32.0_ki/9.0_ki*abb67(5)
      abb67(11)=abb67(18)*abb67(11)
      abb67(18)=32.0_ki/9.0_ki*spae2e3
      abb67(22)=-abb67(11)*abb67(18)
      abb67(16)=abb67(20)*abb67(16)
      abb67(20)=-abb67(16)*abb67(18)
      abb67(23)=-abb67(16)+abb67(11)
      abb67(18)=abb67(23)*abb67(18)
      abb67(10)=abb67(14)+abb67(10)
      abb67(10)=4.0_ki/9.0_ki*abb67(10)
      abb67(5)=-4.0_ki/9.0_ki*spbk5k4*spae4k4*abb67(5)
      abb67(14)=spbk3e3*abb67(19)
      abb67(11)=spak1e2*abb67(11)
      abb67(11)=abb67(14)+abb67(11)
      abb67(11)=16.0_ki/9.0_ki*abb67(11)
      abb67(14)=spak1e3*abb67(16)
      abb67(16)=spbk2e2*abb67(17)
      abb67(14)=abb67(14)+abb67(16)
      abb67(14)=16.0_ki/9.0_ki*abb67(14)
      abb67(8)=8.0_ki/9.0_ki*abb67(8)
      R2d67=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d67
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='67' value='", &
          & R2d67, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd67h0
