module     ugaau_d11h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d11h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd11h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc11(23)
      complex(ki) :: Qspk3
      complex(ki) :: Qspk4
      complex(ki) :: Qspe4
      complex(ki) :: Qspk1
      complex(ki) :: Qspk5
      complex(ki) :: Qspk2
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak2k5
      complex(ki) :: Qspe3
      complex(ki) :: Qspvae3k1
      Qspk3 = dotproduct(Q,k3)
      Qspk4 = dotproduct(Q,k4)
      Qspe4 = dotproduct(Q,e4)
      Qspk1 = dotproduct(Q,k1)
      Qspk5 = dotproduct(Q,k5)
      Qspk2 = dotproduct(Q,k2)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      Qspe3 = dotproduct(Q,e3)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      acc11(1)=abb11(5)
      acc11(2)=abb11(6)
      acc11(3)=abb11(7)
      acc11(4)=abb11(9)
      acc11(5)=abb11(10)
      acc11(6)=abb11(12)
      acc11(7)=abb11(14)
      acc11(8)=abb11(15)
      acc11(9)=abb11(24)
      acc11(10)=abb11(27)
      acc11(11)=abb11(29)
      acc11(12)=abb11(31)
      acc11(13)=acc11(12)*Qspk3
      acc11(14)=acc11(11)*Qspk4
      acc11(15)=acc11(10)*Qspe4
      acc11(16)=acc11(8)*Qspk1
      acc11(17)=acc11(7)*Qspk5
      acc11(18)=acc11(6)*Qspk2
      acc11(19)=acc11(5)*Qspvae4k1
      acc11(20)=acc11(4)*Qspvak5k2
      acc11(21)=acc11(3)*Qspvak2k5
      acc11(22)=acc11(2)*Qspe3
      acc11(23)=acc11(1)*Qspvae3k1
      brack=acc11(9)+acc11(13)+acc11(14)+acc11(15)+acc11(16)+acc11(17)+acc11(18&
      &)+acc11(19)+acc11(20)+acc11(21)+acc11(22)+acc11(23)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram11_sign, shift => diagram11_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd11h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d11
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k5
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d11 = 0.0_ki
      d11 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d11, ki), aimag(d11), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd11h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d11
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k5
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d11 = 0.0_ki
      d11 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d11, ki), aimag(d11), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d11h0l1
