module     ugaau_d1h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d1h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd1h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc1(18)
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspvak3k2
      complex(ki) :: Qspe4
      complex(ki) :: Qspk2
      complex(ki) :: Qspk1
      complex(ki) :: QspQ
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak3k4
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspe2 = dotproduct(Q,e2)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspvak3k2 = dotproduct(Q,spvak3k2)
      Qspe4 = dotproduct(Q,e4)
      Qspk2 = dotproduct(Q,k2)
      Qspk1 = dotproduct(Q,k1)
      QspQ = dotproduct(Q,Q)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak3k4 = dotproduct(Q,spvak3k4)
      acc1(1)=abb1(4)
      acc1(2)=abb1(5)
      acc1(3)=abb1(6)
      acc1(4)=abb1(7)
      acc1(5)=abb1(8)
      acc1(6)=abb1(9)
      acc1(7)=abb1(10)
      acc1(8)=abb1(11)
      acc1(9)=abb1(12)
      acc1(10)=abb1(13)
      acc1(11)=abb1(15)
      acc1(12)=acc1(1)*Qspvae2k1
      acc1(13)=acc1(6)*Qspe2
      acc1(14)=Qspvak5k2*acc1(7)
      acc1(15)=Qspvak3k2*acc1(8)
      acc1(12)=acc1(15)+acc1(14)+acc1(13)+acc1(12)
      acc1(12)=Qspe4*acc1(12)
      acc1(13)=-Qspk2-Qspk1
      acc1(14)=acc1(10)*Qspe4
      acc1(14)=acc1(14)-acc1(9)
      acc1(13)=acc1(14)*acc1(13)
      acc1(14)=-mu2+QspQ
      acc1(14)=acc1(11)*acc1(14)
      acc1(15)=acc1(3)*Qspvae2k1
      acc1(16)=acc1(4)*Qspe2
      acc1(17)=Qspvak5k4*acc1(5)
      acc1(18)=Qspvak3k4*acc1(2)
      brack=acc1(12)+acc1(13)+acc1(14)+acc1(15)+acc1(16)+acc1(17)+acc1(18)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram1_sign, shift => diagram1_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd1h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d1
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3+k5+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d1 = 0.0_ki
      d1 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d1, ki), aimag(d1), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd1h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d1
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3+k5+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d1 = 0.0_ki
      d1 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d1, ki), aimag(d1), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d1h0l1
