module     ugaau_d22h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d22h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd22h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc22(34)
      complex(ki) :: Qspk2
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak5k2
      complex(ki) :: Qspe2
      complex(ki) :: Qspvae2k1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspk3
      complex(ki) :: QspQ
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak5e4
      complex(ki) :: Qspvak5k4
      Qspk2 = dotproduct(Q,k2)
      Qspk1 = dotproduct(Q,k1)
      Qspvak5k2 = dotproduct(Q,spvak5k2)
      Qspe2 = dotproduct(Q,e2)
      Qspvae2k1 = dotproduct(Q,spvae2k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspk3 = dotproduct(Q,k3)
      QspQ = dotproduct(Q,Q)
      Qspe4 = dotproduct(Q,e4)
      Qspvak5e4 = dotproduct(Q,spvak5e4)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      acc22(1)=abb22(3)
      acc22(2)=abb22(4)
      acc22(3)=abb22(5)
      acc22(4)=abb22(6)
      acc22(5)=abb22(7)
      acc22(6)=abb22(8)
      acc22(7)=abb22(9)
      acc22(8)=abb22(10)
      acc22(9)=abb22(11)
      acc22(10)=abb22(12)
      acc22(11)=abb22(14)
      acc22(12)=abb22(15)
      acc22(13)=abb22(16)
      acc22(14)=abb22(17)
      acc22(15)=abb22(18)
      acc22(16)=abb22(23)
      acc22(17)=abb22(24)
      acc22(18)=abb22(25)
      acc22(19)=abb22(26)
      acc22(20)=abb22(27)
      acc22(21)=abb22(28)
      acc22(22)=abb22(29)
      acc22(23)=abb22(30)
      acc22(24)=abb22(32)
      acc22(25)=abb22(33)
      acc22(26)=abb22(37)
      acc22(27)=Qspk2+Qspk1
      acc22(28)=acc22(25)*acc22(27)
      acc22(29)=-acc22(7)*Qspvak5k2
      acc22(30)=Qspe2*acc22(17)
      acc22(31)=Qspvae2k1*acc22(3)
      acc22(28)=acc22(31)+acc22(30)+acc22(8)+acc22(29)+acc22(28)
      acc22(28)=Qspe3*acc22(28)
      acc22(29)=acc22(23)*acc22(27)
      acc22(30)=acc22(26)*Qspvak5e3
      acc22(31)=Qspk3*acc22(20)
      acc22(32)=Qspe2*acc22(14)
      acc22(33)=Qspvae2k1*acc22(12)
      acc22(34)=QspQ*acc22(19)
      acc22(28)=acc22(28)+acc22(34)+acc22(33)+acc22(32)+acc22(30)+acc22(31)+acc&
      &22(29)
      acc22(28)=Qspe4*acc22(28)
      acc22(29)=acc22(10)*acc22(27)
      acc22(30)=acc22(21)*Qspvak5e4
      acc22(31)=Qspe2*acc22(9)
      acc22(32)=Qspvae2k1*acc22(2)
      acc22(29)=acc22(32)+acc22(31)+acc22(30)+acc22(18)+acc22(29)
      acc22(29)=QspQ*acc22(29)
      acc22(30)=-acc22(24)*acc22(27)
      acc22(31)=Qspvak5k4*acc22(1)
      acc22(32)=Qspe2*acc22(16)
      acc22(33)=Qspvae2k1*acc22(15)
      acc22(30)=acc22(33)+acc22(32)+acc22(5)+acc22(31)+acc22(30)
      acc22(30)=Qspe3*acc22(30)
      acc22(27)=acc22(22)*acc22(27)
      acc22(31)=Qspk3*acc22(4)
      acc22(32)=Qspvak5k4*acc22(6)
      acc22(33)=Qspe2*acc22(13)
      acc22(34)=Qspvae2k1*acc22(11)
      brack=acc22(27)+acc22(28)+acc22(29)+acc22(30)+acc22(31)+acc22(32)+acc22(3&
      &3)+acc22(34)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram22_sign, shift => diagram22_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd22h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d22
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k5+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d22 = 0.0_ki
      d22 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d22, ki), aimag(d22), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd22h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d22
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k5+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d22 = 0.0_ki
      d22 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d22, ki), aimag(d22), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d22h0l1
