module     ugaau_d27h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d27h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd27h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc27(35)
      complex(ki) :: Qspk4
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspe4
      complex(ki) :: Qspvae4k1
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak5e2
      complex(ki) :: Qspk2
      complex(ki) :: QspQ
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak5e3
      complex(ki) :: Qspvak5k3
      Qspk4 = dotproduct(Q,k4)
      Qspk1 = dotproduct(Q,k1)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspe4 = dotproduct(Q,e4)
      Qspvae4k1 = dotproduct(Q,spvae4k1)
      Qspe2 = dotproduct(Q,e2)
      Qspvak5e2 = dotproduct(Q,spvak5e2)
      Qspk2 = dotproduct(Q,k2)
      QspQ = dotproduct(Q,Q)
      Qspe3 = dotproduct(Q,e3)
      Qspvak5e3 = dotproduct(Q,spvak5e3)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      acc27(1)=abb27(3)
      acc27(2)=abb27(4)
      acc27(3)=abb27(5)
      acc27(4)=abb27(6)
      acc27(5)=abb27(7)
      acc27(6)=abb27(8)
      acc27(7)=abb27(9)
      acc27(8)=abb27(10)
      acc27(9)=abb27(11)
      acc27(10)=abb27(12)
      acc27(11)=abb27(13)
      acc27(12)=abb27(14)
      acc27(13)=abb27(15)
      acc27(14)=abb27(16)
      acc27(15)=abb27(17)
      acc27(16)=abb27(18)
      acc27(17)=abb27(20)
      acc27(18)=abb27(26)
      acc27(19)=abb27(27)
      acc27(20)=abb27(28)
      acc27(21)=abb27(29)
      acc27(22)=abb27(30)
      acc27(23)=abb27(31)
      acc27(24)=abb27(32)
      acc27(25)=abb27(33)
      acc27(26)=abb27(34)
      acc27(27)=abb27(36)
      acc27(28)=Qspk4-Qspk1
      acc27(29)=acc27(24)*acc27(28)
      acc27(30)=acc27(15)*Qspvak5k1
      acc27(31)=acc27(8)*Qspvak5k4
      acc27(32)=Qspe4*acc27(19)
      acc27(33)=Qspvae4k1*acc27(2)
      acc27(29)=acc27(33)+acc27(32)+acc27(31)+acc27(18)+acc27(30)+acc27(29)
      acc27(29)=Qspe2*acc27(29)
      acc27(30)=-acc27(22)*acc27(28)
      acc27(31)=acc27(16)*Qspvak5e2
      acc27(32)=Qspk2*acc27(27)
      acc27(33)=Qspe4*acc27(10)
      acc27(34)=Qspvae4k1*acc27(9)
      acc27(35)=QspQ*acc27(4)
      acc27(29)=acc27(29)+acc27(35)+acc27(34)+acc27(33)+acc27(31)+acc27(32)+acc&
      &27(30)
      acc27(29)=Qspe3*acc27(29)
      acc27(30)=-acc27(21)*acc27(28)
      acc27(31)=acc27(26)*Qspvak5e3
      acc27(32)=Qspe4*acc27(3)
      acc27(33)=Qspvae4k1*acc27(6)
      acc27(30)=acc27(33)+acc27(32)+acc27(31)+acc27(14)+acc27(30)
      acc27(30)=QspQ*acc27(30)
      acc27(31)=-acc27(23)*acc27(28)
      acc27(32)=Qspvak5k3*acc27(12)
      acc27(33)=Qspe4*acc27(13)
      acc27(34)=Qspvae4k1*acc27(1)
      acc27(31)=acc27(34)+acc27(33)+acc27(17)+acc27(32)+acc27(31)
      acc27(31)=Qspe2*acc27(31)
      acc27(28)=-acc27(20)*acc27(28)
      acc27(32)=Qspk2*acc27(25)
      acc27(33)=Qspvak5k3*acc27(11)
      acc27(34)=Qspe4*acc27(7)
      acc27(35)=Qspvae4k1*acc27(5)
      brack=acc27(28)+acc27(29)+acc27(30)+acc27(31)+acc27(32)+acc27(33)+acc27(3&
      &4)+acc27(35)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram27_sign, shift => diagram27_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd27h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d27
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(1)  =cmplx(real(-Q_ext(4),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d27 = 0.0_ki
      d27 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d27, ki), aimag(d27), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd27h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d27
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(:)  =cmplx(real(-Q_ext(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d27 = 0.0_ki
      d27 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d27, ki), aimag(d27), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d27h0l1
