module     ugaau_d3h0l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity0d3h0l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd3h0
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc3(21)
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak2k3
      complex(ki) :: Qspvak5k1
      complex(ki) :: Qspvak2k1
      complex(ki) :: Qspe3
      complex(ki) :: Qspvae3k1
      complex(ki) :: Qspk3
      complex(ki) :: Qspk1
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak5k4
      complex(ki) :: Qspvak2k4
      complex(ki) :: QspQ
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak2k3 = dotproduct(Q,spvak2k3)
      Qspvak5k1 = dotproduct(Q,spvak5k1)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      Qspe3 = dotproduct(Q,e3)
      Qspvae3k1 = dotproduct(Q,spvae3k1)
      Qspk3 = dotproduct(Q,k3)
      Qspk1 = dotproduct(Q,k1)
      Qspe4 = dotproduct(Q,e4)
      Qspvak5k4 = dotproduct(Q,spvak5k4)
      Qspvak2k4 = dotproduct(Q,spvak2k4)
      QspQ = dotproduct(Q,Q)
      acc3(1)=abb3(4)
      acc3(2)=abb3(5)
      acc3(3)=abb3(6)
      acc3(4)=abb3(7)
      acc3(5)=abb3(8)
      acc3(6)=abb3(9)
      acc3(7)=abb3(10)
      acc3(8)=abb3(11)
      acc3(9)=abb3(12)
      acc3(10)=abb3(13)
      acc3(11)=abb3(14)
      acc3(12)=abb3(15)
      acc3(13)=abb3(16)
      acc3(14)=acc3(13)*Qspvak5k3
      acc3(15)=acc3(12)*Qspvak2k3
      acc3(16)=acc3(11)*Qspvak5k1
      acc3(17)=acc3(1)*Qspvak2k1
      acc3(18)=Qspe3*acc3(4)
      acc3(19)=Qspvae3k1*acc3(3)
      acc3(20)=Qspk3-Qspk1
      acc3(21)=-acc3(8)*acc3(20)
      acc3(14)=acc3(21)+acc3(19)+acc3(18)+acc3(17)+acc3(16)+acc3(14)+acc3(15)
      acc3(14)=Qspe4*acc3(14)
      acc3(15)=acc3(7)*Qspvak5k4
      acc3(16)=acc3(6)*Qspvak2k4
      acc3(17)=Qspe3*acc3(9)
      acc3(18)=Qspvae3k1*acc3(2)
      acc3(19)=mu2-QspQ
      acc3(19)=acc3(10)*acc3(19)
      acc3(20)=acc3(5)*acc3(20)
      brack=acc3(14)+acc3(15)+acc3(16)+acc3(17)+acc3(18)+acc3(19)+acc3(20)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram3_sign, shift => diagram3_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd3h0
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d3
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k5+k4
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d3 = 0.0_ki
      d3 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d3, ki), aimag(d3), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd3h0
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d3
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k5+k4
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d3 = 0.0_ki
      d3 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d3, ki), aimag(d3), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d3h0l1
