module     ugaau_abbrevd15h8
   use ugaau_config, only: ki
   use ugaau_globalsh8
   implicit none
   private
   complex(ki), dimension(26), public :: abb15
   complex(ki), public :: R2d15
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb15(1)=1.0_ki/(-es23-es12+es45)
      abb15(2)=NC**(-1)
      abb15(3)=es45**(-1)
      abb15(4)=1.0_ki/(es34-es51-es12)
      abb15(5)=NC-abb15(2)
      abb15(6)=abb15(1)**2*i_*TR
      abb15(7)=-abb15(6)*abb15(5)
      abb15(8)=spak1e3*c1
      abb15(9)=-abb15(7)*abb15(8)*spbk5e4
      abb15(10)=spbk4e2*spae4k4
      abb15(11)=abb15(9)*abb15(10)
      abb15(8)=abb15(6)*abb15(8)*spbk5e2
      abb15(12)=-spbk5e4*abb15(5)
      abb15(13)=abb15(8)*abb15(12)
      abb15(14)=abb15(13)*spae4k5
      abb15(11)=abb15(11)-abb15(14)
      abb15(11)=spae2k3*abb15(3)*abb15(11)
      abb15(14)=spbk3e3*abb15(11)
      abb15(8)=abb15(8)*abb15(4)
      abb15(15)=-abb15(8)*abb15(5)
      abb15(16)=spae2k2*spbe4k2
      abb15(17)=abb15(15)*abb15(16)
      abb15(8)=-abb15(8)*abb15(12)
      abb15(12)=abb15(8)*spae2k5
      abb15(12)=abb15(17)-abb15(12)
      abb15(12)=abb15(12)*spak3e4
      abb15(17)=-spbk3e3*abb15(12)
      abb15(14)=abb15(14)-abb15(17)
      abb15(18)=abb15(9)*spbe3k1
      abb15(19)=spak1e2*abb15(3)
      abb15(20)=abb15(19)*abb15(10)
      abb15(21)=abb15(18)*abb15(20)
      abb15(16)=abb15(16)*spak1e4
      abb15(15)=abb15(16)*abb15(15)
      abb15(22)=spae2k5*spak1e4
      abb15(8)=abb15(22)*abb15(8)
      abb15(8)=abb15(15)-abb15(8)
      abb15(15)=-spbe3k1*abb15(8)
      abb15(23)=abb15(13)*spbe3k1
      abb15(19)=abb15(19)*spae4k5
      abb15(24)=abb15(23)*abb15(19)
      abb15(21)=-abb15(24)+abb15(21)+abb15(15)
      abb15(24)=abb15(14)-abb15(21)
      abb15(25)=es12+es23
      abb15(24)=-abb15(24)*abb15(25)
      abb15(15)=abb15(17)+abb15(15)
      abb15(15)=-es45*abb15(15)
      abb15(13)=abb15(13)*spbk3e3
      abb15(17)=-spae4k5*abb15(13)
      abb15(9)=abb15(9)*spbk3e3
      abb15(26)=abb15(10)*abb15(9)
      abb15(17)=abb15(17)+abb15(26)
      abb15(17)=spae2k3*abb15(17)
      abb15(26)=spae4k5*spak1e2
      abb15(23)=abb15(23)*abb15(26)
      abb15(10)=abb15(10)*spak1e2
      abb15(18)=-abb15(18)*abb15(10)
      abb15(15)=abb15(15)+abb15(17)+abb15(23)+abb15(18)+abb15(24)
      abb15(15)=4.0_ki/9.0_ki*abb15(15)
      abb15(17)=spbk5e2*c1
      abb15(7)=abb15(16)*abb15(7)*abb15(17)*abb15(4)
      abb15(6)=abb15(6)*spbk5e4
      abb15(16)=abb15(5)*abb15(6)*abb15(17)
      abb15(17)=-abb15(22)*abb15(4)*abb15(16)
      abb15(7)=abb15(7)+abb15(17)
      abb15(17)=-abb15(16)*abb15(19)
      abb15(5)=-abb15(5)*abb15(6)*c1
      abb15(6)=abb15(5)*abb15(20)
      abb15(6)=abb15(17)+abb15(6)+abb15(7)
      abb15(17)=-abb15(6)*abb15(25)
      abb15(7)=es45*abb15(7)
      abb15(16)=-abb15(16)*abb15(26)
      abb15(5)=abb15(5)*abb15(10)
      abb15(5)=abb15(7)+abb15(16)+abb15(5)+abb15(17)
      abb15(5)=16.0_ki/9.0_ki*abb15(5)
      abb15(7)=-2.0_ki*abb15(21)+abb15(14)
      abb15(7)=8.0_ki/9.0_ki*abb15(7)
      abb15(10)=abb15(21)-2.0_ki*abb15(14)
      abb15(10)=8.0_ki/9.0_ki*abb15(10)
      abb15(6)=spae3k3*abb15(6)
      abb15(11)=abb15(11)+abb15(12)
      abb15(6)=abb15(6)+abb15(11)
      abb15(6)=8.0_ki/9.0_ki*spbk3k1*abb15(6)
      abb15(8)=spbk3e3*abb15(8)
      abb15(9)=-abb15(20)*abb15(9)
      abb15(12)=abb15(19)*abb15(13)
      abb15(8)=abb15(9)+abb15(12)+abb15(8)
      abb15(8)=4.0_ki/9.0_ki*abb15(8)
      abb15(9)=-4.0_ki/9.0_ki*spbe3k1*abb15(11)
      R2d15=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d15
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='15' value='", &
          & R2d15, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd15h8
