module     ugaau_abbrevd65h8
   use ugaau_config, only: ki
   use ugaau_globalsh8
   implicit none
   private
   complex(ki), dimension(38), public :: abb65
   complex(ki), public :: R2d65
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb65(1)=NC**(-1)
      abb65(2)=es45**(-1)
      abb65(3)=-spak1k2*spbe3k2
      abb65(4)=-spak1k3*spbk3e3
      abb65(3)=abb65(4)+abb65(3)
      abb65(4)=i_*TR*c1*spbk5e4*abb65(2)*abb65(1)
      abb65(5)=abb65(4)*spae4k4
      abb65(6)=abb65(5)*spbk4e2
      abb65(4)=abb65(4)*spae4k5
      abb65(7)=abb65(4)*spbk5e2
      abb65(6)=abb65(6)+abb65(7)
      abb65(7)=spae2e3*abb65(6)
      abb65(3)=abb65(7)*abb65(3)
      abb65(8)=spae2k2*spbe3k2
      abb65(9)=abb65(8)*abb65(6)
      abb65(10)=spak1e3*abb65(9)
      abb65(3)=abb65(10)+abb65(3)
      abb65(3)=4.0_ki/9.0_ki*abb65(3)
      abb65(10)=8.0_ki/9.0_ki*abb65(6)
      abb65(11)=spak1e2*abb65(10)
      abb65(12)=8.0_ki/9.0_ki*spak1k2
      abb65(13)=abb65(4)*spbe3k2
      abb65(14)=-abb65(13)*abb65(12)
      abb65(15)=abb65(4)*spak1e2
      abb65(16)=abb65(15)*spbe3e2
      abb65(17)=8.0_ki/9.0_ki*abb65(16)
      abb65(16)=-4.0_ki/9.0_ki*abb65(16)
      abb65(18)=abb65(5)*spbe3k2
      abb65(12)=-abb65(18)*abb65(12)
      abb65(19)=abb65(5)*spak1e2
      abb65(20)=abb65(19)*spbe3e2
      abb65(21)=8.0_ki/9.0_ki*abb65(20)
      abb65(20)=-4.0_ki/9.0_ki*abb65(20)
      abb65(22)=abb65(4)*spak2e3
      abb65(23)=abb65(22)*spbk5k2
      abb65(24)=abb65(5)*spak2e3
      abb65(25)=abb65(24)*spbk4k2
      abb65(23)=abb65(23)+abb65(25)
      abb65(25)=-spbk5k3*abb65(4)
      abb65(26)=-spbk4k3*abb65(5)
      abb65(25)=abb65(26)+abb65(25)
      abb65(25)=spae3k3*abb65(25)
      abb65(25)=-2.0_ki*abb65(23)+abb65(25)
      abb65(25)=8.0_ki/9.0_ki*abb65(25)
      abb65(26)=8.0_ki/9.0_ki*abb65(7)
      abb65(7)=-4.0_ki/9.0_ki*abb65(7)
      abb65(27)=spae2k3*spbk3e3
      abb65(8)=abb65(27)+abb65(8)
      abb65(8)=-4.0_ki/9.0_ki*abb65(8)*abb65(23)
      abb65(23)=spbk5k2*abb65(4)
      abb65(28)=spbk4k2*abb65(5)
      abb65(23)=abb65(23)+abb65(28)
      abb65(28)=8.0_ki/9.0_ki*spae2k2
      abb65(23)=abb65(23)*abb65(28)
      abb65(28)=abb65(5)*spbk4e3
      abb65(29)=abb65(4)*spbk5e3
      abb65(28)=abb65(28)+abb65(29)
      abb65(29)=spae2e3*abb65(28)
      abb65(30)=-8.0_ki/9.0_ki*abb65(29)
      abb65(29)=4.0_ki/9.0_ki*abb65(29)
      abb65(31)=spbk2e2*spak1e2
      abb65(31)=4.0_ki/9.0_ki*abb65(31)
      abb65(32)=abb65(31)*abb65(22)
      abb65(33)=spbk3e3*abb65(32)
      abb65(34)=8.0_ki/9.0_ki*spak1e3
      abb65(35)=abb65(34)*spbk3e3
      abb65(36)=abb65(4)*abb65(35)
      abb65(31)=abb65(31)*abb65(24)
      abb65(37)=spbk3e3*abb65(31)
      abb65(35)=abb65(5)*abb65(35)
      abb65(32)=spbe3k2*abb65(32)
      abb65(38)=8.0_ki/9.0_ki*spbk2e2
      abb65(15)=-abb65(15)*abb65(38)
      abb65(13)=abb65(13)*abb65(34)
      abb65(31)=spbe3k2*abb65(31)
      abb65(19)=-abb65(19)*abb65(38)
      abb65(18)=abb65(18)*abb65(34)
      abb65(4)=16.0_ki/9.0_ki*abb65(4)
      abb65(5)=16.0_ki/9.0_ki*abb65(5)
      abb65(28)=8.0_ki/9.0_ki*spae3k3*abb65(28)
      abb65(6)=abb65(6)*abb65(27)
      abb65(6)=abb65(6)+abb65(9)
      abb65(6)=4.0_ki/9.0_ki*spak2e3*abb65(6)
      abb65(9)=-spae2k2*abb65(10)
      abb65(10)=spbk5e3*abb65(22)
      abb65(22)=spbk4e3*abb65(24)
      abb65(10)=abb65(10)+abb65(22)
      abb65(10)=16.0_ki/9.0_ki*abb65(10)
      R2d65=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d65
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='65' value='", &
          & R2d65, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd65h8
