module     ugaau_abbrevd7h8
   use ugaau_config, only: ki
   use ugaau_globalsh8
   implicit none
   private
   complex(ki), dimension(33), public :: abb7
   complex(ki), public :: R2d7
   public :: init_abbrev
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
contains
   subroutine     init_abbrev()
      use ugaau_config, only: deltaOS, &
     &    logfile, debug_nlo_diagrams
      use ugaau_kinematics
      use ugaau_model
      use ugaau_color, only: TR
      use ugaau_globalsl1, only: epspow
      implicit none
      abb7(1)=1.0_ki/(es23-es51-es45)
      abb7(2)=1.0_ki/(-es34+es12-es45)
      abb7(3)=NC**(-1)
      abb7(4)=spbk4e4*spae2k4
      abb7(5)=i_*TR*c1*spbk5e3*abb7(2)*abb7(1)
      abb7(6)=abb7(5)*NC*spak1e4
      abb7(7)=abb7(6)*spae3k5
      abb7(8)=abb7(4)*abb7(7)
      abb7(9)=abb7(7)*spak1e2
      abb7(10)=-spbe4k1*abb7(9)
      abb7(10)=abb7(8)+abb7(10)
      abb7(10)=spbk5k2*abb7(10)
      abb7(6)=abb7(6)*spae3k3
      abb7(11)=abb7(4)*abb7(6)
      abb7(12)=abb7(6)*spak1e2
      abb7(13)=-spbe4k1*abb7(12)
      abb7(13)=abb7(11)+abb7(13)
      abb7(13)=spbk3k2*abb7(13)
      abb7(10)=abb7(10)+abb7(13)
      abb7(10)=spbk4e2*abb7(10)
      abb7(13)=abb7(6)*spbk3e2
      abb7(14)=abb7(7)*spbk5e2
      abb7(13)=abb7(13)+abb7(14)
      abb7(14)=spak1e2*abb7(13)
      abb7(15)=spbk2k1*spbk4e4*abb7(14)
      abb7(10)=abb7(10)+2.0_ki*abb7(15)
      abb7(10)=spak2k4*abb7(10)
      abb7(8)=-spbk5k2*abb7(8)
      abb7(11)=-spbk3k2*abb7(11)
      abb7(8)=abb7(8)+abb7(11)
      abb7(8)=spbe2k1*abb7(8)
      abb7(11)=abb7(13)*spae2k4
      abb7(15)=2.0_ki*spbk4k2
      abb7(16)=spbe4k1*abb7(11)*abb7(15)
      abb7(8)=abb7(16)+abb7(8)
      abb7(8)=spak1k2*abb7(8)
      abb7(13)=abb7(4)*abb7(13)
      abb7(16)=2.0_ki*abb7(13)
      abb7(17)=es51-es23
      abb7(18)=-es34+abb7(17)
      abb7(16)=abb7(16)*abb7(18)
      abb7(14)=abb7(14)*spbe4k1
      abb7(18)=es12*abb7(14)
      abb7(8)=-2.0_ki*abb7(18)+abb7(8)+abb7(16)+abb7(10)
      abb7(8)=2.0_ki/9.0_ki*abb7(8)
      abb7(10)=abb7(5)*spae3k5
      abb7(16)=abb7(10)*abb7(3)
      abb7(18)=abb7(10)*NC
      abb7(19)=abb7(18)+2.0_ki*abb7(16)
      abb7(20)=spbk5k2*spae2k2
      abb7(19)=abb7(19)*abb7(20)
      abb7(5)=abb7(5)*spae3k3
      abb7(21)=abb7(5)*abb7(3)
      abb7(22)=abb7(5)*NC
      abb7(23)=abb7(22)+2.0_ki*abb7(21)
      abb7(24)=spbk3k2*spae2k2
      abb7(23)=abb7(23)*abb7(24)
      abb7(25)=abb7(18)*spbk5k1
      abb7(26)=abb7(22)*spbk3k1
      abb7(25)=abb7(25)+abb7(26)
      abb7(25)=abb7(25)*spak1e2
      abb7(26)=spbk4k3*spae2k4
      abb7(27)=abb7(26)*abb7(22)
      abb7(28)=spbk5k4*spae2k4
      abb7(29)=abb7(28)*abb7(18)
      abb7(19)=abb7(19)+abb7(23)+abb7(25)-abb7(27)+abb7(29)
      abb7(19)=abb7(19)*spbk4e2
      abb7(23)=abb7(21)-abb7(22)
      abb7(25)=spbk3e2*spae2k2
      abb7(23)=abb7(23)*abb7(25)
      abb7(27)=abb7(16)-abb7(18)
      abb7(29)=spbk5e2*spae2k2
      abb7(27)=abb7(27)*abb7(29)
      abb7(23)=abb7(23)+abb7(27)
      abb7(15)=abb7(23)*abb7(15)
      abb7(15)=abb7(19)-abb7(15)
      abb7(19)=-spak1k4*abb7(15)
      abb7(23)=spbk3e2*spak1e2
      abb7(27)=abb7(23)*abb7(22)
      abb7(30)=spbk5e2*spak1e2
      abb7(31)=abb7(30)*abb7(18)
      abb7(27)=abb7(27)+abb7(31)
      abb7(17)=es45+abb7(17)
      abb7(17)=abb7(27)*abb7(17)
      abb7(17)=abb7(17)+abb7(19)
      abb7(17)=4.0_ki/9.0_ki*abb7(17)
      abb7(19)=-spak2k4*spbk4e4
      abb7(31)=spak1k2*spbe4k1
      abb7(19)=abb7(31)+abb7(19)
      abb7(31)=abb7(6)*spbk3k2
      abb7(32)=abb7(7)*spbk5k2
      abb7(31)=abb7(31)+abb7(32)
      abb7(19)=abb7(31)*abb7(19)
      abb7(31)=spbk4k3*spbe4k1
      abb7(32)=-spbk3k1*spbk4e4
      abb7(31)=abb7(32)+abb7(31)
      abb7(31)=abb7(6)*abb7(31)
      abb7(32)=-spbk5k4*spbe4k1
      abb7(33)=-spbk5k1*spbk4e4
      abb7(32)=abb7(33)+abb7(32)
      abb7(32)=abb7(7)*abb7(32)
      abb7(31)=abb7(32)+abb7(31)
      abb7(31)=spak1k4*abb7(31)
      abb7(19)=abb7(31)+abb7(19)
      abb7(19)=4.0_ki/9.0_ki*abb7(19)
      abb7(21)=abb7(21)+abb7(22)
      abb7(21)=abb7(21)*spbk4k3
      abb7(16)=abb7(16)+abb7(18)
      abb7(16)=abb7(16)*spbk5k4
      abb7(16)=abb7(21)-abb7(16)
      abb7(18)=-32.0_ki/9.0_ki*spak1k4*abb7(16)
      abb7(21)=abb7(3)*spak1e4
      abb7(10)=abb7(21)*abb7(10)
      abb7(22)=abb7(7)+2.0_ki*abb7(10)
      abb7(20)=abb7(22)*abb7(20)
      abb7(5)=abb7(21)*abb7(5)
      abb7(21)=abb7(6)+2.0_ki*abb7(5)
      abb7(21)=abb7(21)*abb7(24)
      abb7(22)=abb7(26)*abb7(6)
      abb7(24)=abb7(28)*abb7(7)
      abb7(20)=-abb7(22)+abb7(24)+abb7(20)+abb7(21)
      abb7(9)=abb7(9)*spbk5k1
      abb7(12)=abb7(12)*spbk3k1
      abb7(9)=abb7(12)+abb7(20)+abb7(9)
      abb7(9)=abb7(9)*spbe4e2
      abb7(12)=abb7(5)-abb7(6)
      abb7(21)=abb7(25)*abb7(12)
      abb7(22)=abb7(10)-abb7(7)
      abb7(24)=abb7(29)*abb7(22)
      abb7(21)=abb7(21)+abb7(24)
      abb7(21)=2.0_ki*abb7(21)
      abb7(24)=abb7(21)*spbe4k2
      abb7(13)=abb7(14)-abb7(13)
      abb7(9)=abb7(9)-abb7(24)-2.0_ki*abb7(13)
      abb7(9)=4.0_ki/9.0_ki*abb7(9)
      abb7(6)=abb7(5)+abb7(6)
      abb7(14)=abb7(6)*spbe4k3
      abb7(7)=abb7(10)+abb7(7)
      abb7(24)=abb7(7)*spbk5e4
      abb7(14)=abb7(14)-abb7(24)
      abb7(14)=32.0_ki/9.0_ki*abb7(14)
      abb7(13)=-8.0_ki/9.0_ki*abb7(13)
      abb7(24)=abb7(12)*spbk3e2
      abb7(25)=abb7(22)*spbk5e2
      abb7(24)=-abb7(24)-abb7(25)
      abb7(24)=abb7(4)*abb7(24)
      abb7(12)=abb7(12)*abb7(23)
      abb7(22)=abb7(22)*abb7(30)
      abb7(12)=abb7(12)+abb7(22)
      abb7(12)=abb7(12)*spbe4k1
      abb7(12)=abb7(12)+abb7(24)
      abb7(12)=4.0_ki/9.0_ki*abb7(12)
      abb7(15)=spae4k4*abb7(15)
      abb7(20)=-spbe2k1*abb7(20)
      abb7(21)=spbk2k1*abb7(21)
      abb7(22)=-spae4k4*abb7(27)
      abb7(11)=abb7(22)+abb7(11)
      abb7(11)=spbk4k1*abb7(11)
      abb7(11)=abb7(11)+abb7(21)+abb7(20)+abb7(15)
      abb7(11)=2.0_ki/9.0_ki*abb7(11)
      abb7(15)=spae4k4*abb7(16)
      abb7(16)=-spbk5k1*abb7(7)
      abb7(20)=-spbk3k1*abb7(6)
      abb7(15)=abb7(20)+abb7(16)+abb7(15)
      abb7(15)=16.0_ki/9.0_ki*abb7(15)
      abb7(7)=8.0_ki/9.0_ki*abb7(7)
      abb7(16)=spbk4e4*abb7(7)
      abb7(6)=8.0_ki/9.0_ki*abb7(6)
      abb7(20)=spbk4e4*abb7(6)
      abb7(21)=spbe4k1*spak1e2
      abb7(4)=abb7(21)-abb7(4)
      abb7(21)=4.0_ki/9.0_ki*spbk2e2
      abb7(4)=abb7(4)*abb7(21)
      abb7(10)=abb7(10)*abb7(4)
      abb7(4)=abb7(5)*abb7(4)
      abb7(5)=spbe4k1*abb7(7)
      abb7(6)=spbe4k1*abb7(6)
      R2d7=0.0_ki*(0.0_ki)
      rat2 = rat2 + R2d7
      if (debug_nlo_diagrams) then
          write (logfile,*) "<result name='r2' index='7' value='", &
          & R2d7, "'/>"
      end if
   end subroutine
end module ugaau_abbrevd7h8
