module     ugaau_d125h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d125h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd125h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc125(13)
      complex(ki) :: Qspk4
      complex(ki) :: Qspvak1e4
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspe4
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak1k4
      complex(ki) :: QspQ
      Qspk4 = dotproduct(Q,k4)
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspe4 = dotproduct(Q,e4)
      Qspk1 = dotproduct(Q,k1)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      QspQ = dotproduct(Q,Q)
      acc125(1)=abb125(5)
      acc125(2)=abb125(6)
      acc125(3)=abb125(9)
      acc125(4)=abb125(11)
      acc125(5)=abb125(12)
      acc125(6)=abb125(17)
      acc125(7)=abb125(21)
      acc125(8)=acc125(6)*Qspk4
      acc125(9)=acc125(5)*Qspvak1e4
      acc125(10)=acc125(2)*Qspvak4k1
      acc125(11)=Qspe4*acc125(7)*Qspk1
      acc125(12)=Qspe4*acc125(1)
      acc125(12)=acc125(4)+acc125(12)
      acc125(12)=Qspvak1k4*acc125(12)
      acc125(13)=mu2-QspQ
      acc125(13)=acc125(3)*acc125(13)
      brack=acc125(8)+acc125(9)+acc125(10)+acc125(11)+acc125(12)+acc125(13)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram125_sign, shift => diagram125_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd125h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d125
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k3-k4
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d125 = 0.0_ki
      d125 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d125, ki), aimag(d125), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd125h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d125
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k3-k4
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d125 = 0.0_ki
      d125 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d125, ki), aimag(d125), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d125h8l1
