module     ugaau_d138h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d138h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd138h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc138(17)
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak1k2
      complex(ki) :: Qspe2
      complex(ki) :: Qspk2
      complex(ki) :: Qspvak1e2
      complex(ki) :: Qspvak2k1
      complex(ki) :: QspQ
      Qspk1 = dotproduct(Q,k1)
      Qspvak1k2 = dotproduct(Q,spvak1k2)
      Qspe2 = dotproduct(Q,e2)
      Qspk2 = dotproduct(Q,k2)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      Qspvak2k1 = dotproduct(Q,spvak2k1)
      QspQ = dotproduct(Q,Q)
      acc138(1)=abb138(5)
      acc138(2)=abb138(8)
      acc138(3)=abb138(9)
      acc138(4)=abb138(10)
      acc138(5)=abb138(11)
      acc138(6)=abb138(12)
      acc138(7)=abb138(14)
      acc138(8)=abb138(16)
      acc138(9)=abb138(17)
      acc138(10)=abb138(18)
      acc138(11)=Qspk1*acc138(8)
      acc138(12)=Qspvak1k2*acc138(1)
      acc138(11)=acc138(12)+acc138(9)+acc138(11)
      acc138(11)=Qspe2*acc138(11)
      acc138(12)=acc138(7)*Qspk2
      acc138(13)=acc138(6)*Qspvak1e2
      acc138(14)=acc138(3)*Qspvak2k1
      acc138(15)=Qspk1*acc138(4)
      acc138(16)=Qspvak1k2*acc138(5)
      acc138(17)=-mu2+QspQ
      acc138(17)=acc138(2)*acc138(17)
      brack=acc138(10)+acc138(11)+acc138(12)+acc138(13)+acc138(14)+acc138(15)+a&
      &cc138(16)+acc138(17)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram138_sign, shift => diagram138_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd138h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d138
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k2
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d138 = 0.0_ki
      d138 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d138, ki), aimag(d138), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd138h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d138
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k2
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d138 = 0.0_ki
      d138 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d138, ki), aimag(d138), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d138h8l1
