module     ugaau_d16h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d16h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd16h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc16(13)
      complex(ki) :: Qspvak4k1
      complex(ki) :: Qspk4
      complex(ki) :: Qspe4
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspvak1e4
      Qspvak4k1 = dotproduct(Q,spvak4k1)
      Qspk4 = dotproduct(Q,k4)
      Qspe4 = dotproduct(Q,e4)
      Qspk1 = dotproduct(Q,k1)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      acc16(1)=abb16(5)
      acc16(2)=abb16(6)
      acc16(3)=abb16(7)
      acc16(4)=abb16(8)
      acc16(5)=abb16(9)
      acc16(6)=abb16(10)
      acc16(7)=abb16(11)
      acc16(8)=acc16(7)*Qspvak4k1
      acc16(9)=acc16(6)*Qspk4
      acc16(10)=acc16(4)*Qspe4
      acc16(11)=acc16(3)*Qspk1
      acc16(12)=acc16(2)*Qspvak1k4
      acc16(13)=acc16(1)*Qspvak1e4
      brack=acc16(5)+acc16(8)+acc16(9)+acc16(10)+acc16(11)+acc16(12)+acc16(13)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram16_sign, shift => diagram16_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd16h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d16
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k2-k5
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d16 = 0.0_ki
      d16 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d16, ki), aimag(d16), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd16h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d16
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k2-k5
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d16 = 0.0_ki
      d16 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d16, ki), aimag(d16), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d16h8l1
