module     ugaau_d26h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d26h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd26h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc26(35)
      complex(ki) :: Qspk4
      complex(ki) :: Qspk1
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspe4
      complex(ki) :: Qspvak1e4
      complex(ki) :: Qspe3
      complex(ki) :: Qspvae3k5
      complex(ki) :: Qspk3
      complex(ki) :: QspQ
      complex(ki) :: Qspe2
      complex(ki) :: Qspvae2k5
      complex(ki) :: Qspvak2k5
      Qspk4 = dotproduct(Q,k4)
      Qspk1 = dotproduct(Q,k1)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspe4 = dotproduct(Q,e4)
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      Qspe3 = dotproduct(Q,e3)
      Qspvae3k5 = dotproduct(Q,spvae3k5)
      Qspk3 = dotproduct(Q,k3)
      QspQ = dotproduct(Q,Q)
      Qspe2 = dotproduct(Q,e2)
      Qspvae2k5 = dotproduct(Q,spvae2k5)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      acc26(1)=abb26(3)
      acc26(2)=abb26(4)
      acc26(3)=abb26(5)
      acc26(4)=abb26(6)
      acc26(5)=abb26(7)
      acc26(6)=abb26(8)
      acc26(7)=abb26(9)
      acc26(8)=abb26(10)
      acc26(9)=abb26(11)
      acc26(10)=abb26(12)
      acc26(11)=abb26(13)
      acc26(12)=abb26(14)
      acc26(13)=abb26(15)
      acc26(14)=abb26(16)
      acc26(15)=abb26(17)
      acc26(16)=abb26(18)
      acc26(17)=abb26(20)
      acc26(18)=abb26(26)
      acc26(19)=abb26(27)
      acc26(20)=abb26(28)
      acc26(21)=abb26(29)
      acc26(22)=abb26(30)
      acc26(23)=abb26(31)
      acc26(24)=abb26(32)
      acc26(25)=abb26(33)
      acc26(26)=abb26(34)
      acc26(27)=abb26(36)
      acc26(28)=Qspk4-Qspk1
      acc26(29)=acc26(24)*acc26(28)
      acc26(30)=acc26(16)*Qspvak1k5
      acc26(31)=acc26(8)*Qspvak4k5
      acc26(32)=Qspe4*acc26(19)
      acc26(33)=Qspvak1e4*acc26(10)
      acc26(29)=acc26(33)+acc26(32)+acc26(31)+acc26(18)+acc26(30)+acc26(29)
      acc26(29)=Qspe3*acc26(29)
      acc26(30)=acc26(23)*acc26(28)
      acc26(31)=acc26(12)*Qspvae3k5
      acc26(32)=Qspk3*acc26(27)
      acc26(33)=Qspe4*acc26(2)
      acc26(34)=Qspvak1e4*acc26(1)
      acc26(35)=QspQ*acc26(4)
      acc26(29)=acc26(29)+acc26(35)+acc26(34)+acc26(33)+acc26(31)+acc26(32)+acc&
      &26(30)
      acc26(29)=Qspe2*acc26(29)
      acc26(30)=acc26(21)*acc26(28)
      acc26(31)=acc26(26)*Qspvae2k5
      acc26(32)=Qspe4*acc26(3)
      acc26(33)=Qspvak1e4*acc26(6)
      acc26(30)=acc26(33)+acc26(32)+acc26(31)+acc26(9)+acc26(30)
      acc26(30)=QspQ*acc26(30)
      acc26(31)=acc26(22)*acc26(28)
      acc26(32)=Qspvak2k5*acc26(13)
      acc26(33)=Qspe4*acc26(17)
      acc26(34)=Qspvak1e4*acc26(15)
      acc26(31)=acc26(34)+acc26(33)+acc26(14)+acc26(32)+acc26(31)
      acc26(31)=Qspe3*acc26(31)
      acc26(28)=-acc26(20)*acc26(28)
      acc26(32)=Qspk3*acc26(25)
      acc26(33)=Qspvak2k5*acc26(11)
      acc26(34)=Qspe4*acc26(7)
      acc26(35)=Qspvak1e4*acc26(5)
      brack=acc26(28)+acc26(29)+acc26(30)+acc26(31)+acc26(32)+acc26(33)+acc26(3&
      &4)+acc26(35)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram26_sign, shift => diagram26_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd26h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d26
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(1)  =cmplx(real(+Q_ext(4),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d26 = 0.0_ki
      d26 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d26, ki), aimag(d26), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd26h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d26
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      Q(:)  =cmplx(real(+Q_ext(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d26 = 0.0_ki
      d26 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d26, ki), aimag(d26), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d26h8l1
