module     ugaau_d4h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d4h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd4h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc4(24)
      complex(ki) :: Qspvak3k4
      complex(ki) :: Qspvak3k5
      complex(ki) :: Qspvak1k4
      complex(ki) :: Qspvak1k5
      complex(ki) :: Qspe3
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspk3
      complex(ki) :: Qspk1
      complex(ki) :: Qspe2
      complex(ki) :: Qspvak2k5
      complex(ki) :: Qspk2
      complex(ki) :: Qspvak2k4
      complex(ki) :: QspQ
      Qspvak3k4 = dotproduct(Q,spvak3k4)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      Qspvak1k4 = dotproduct(Q,spvak1k4)
      Qspvak1k5 = dotproduct(Q,spvak1k5)
      Qspe3 = dotproduct(Q,e3)
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspk3 = dotproduct(Q,k3)
      Qspk1 = dotproduct(Q,k1)
      Qspe2 = dotproduct(Q,e2)
      Qspvak2k5 = dotproduct(Q,spvak2k5)
      Qspk2 = dotproduct(Q,k2)
      Qspvak2k4 = dotproduct(Q,spvak2k4)
      QspQ = dotproduct(Q,Q)
      acc4(1)=abb4(4)
      acc4(2)=abb4(5)
      acc4(3)=abb4(6)
      acc4(4)=abb4(7)
      acc4(5)=abb4(8)
      acc4(6)=abb4(9)
      acc4(7)=abb4(10)
      acc4(8)=abb4(11)
      acc4(9)=abb4(12)
      acc4(10)=abb4(13)
      acc4(11)=abb4(14)
      acc4(12)=abb4(15)
      acc4(13)=abb4(16)
      acc4(14)=abb4(17)
      acc4(15)=abb4(19)
      acc4(16)=abb4(20)
      acc4(17)=acc4(14)*Qspvak3k4
      acc4(18)=acc4(11)*Qspvak3k5
      acc4(19)=acc4(4)*Qspvak1k4
      acc4(20)=acc4(3)*Qspvak1k5
      acc4(21)=Qspe3*acc4(15)
      acc4(22)=Qspvak1e3*acc4(10)
      acc4(23)=Qspk3-Qspk1
      acc4(24)=-acc4(12)*acc4(23)
      acc4(17)=acc4(24)+acc4(22)+acc4(21)+acc4(20)+acc4(19)+acc4(18)+acc4(16)+a&
      &cc4(17)
      acc4(17)=Qspe2*acc4(17)
      acc4(18)=acc4(8)*Qspvak2k5
      acc4(19)=acc4(7)*Qspk2
      acc4(20)=acc4(2)*Qspvak2k4
      acc4(21)=Qspe3*acc4(1)
      acc4(22)=Qspvak1e3*acc4(6)
      acc4(24)=mu2-QspQ
      acc4(24)=acc4(13)*acc4(24)
      acc4(23)=acc4(9)*acc4(23)
      brack=acc4(5)+acc4(17)+acc4(18)+acc4(19)+acc4(20)+acc4(21)+acc4(22)+acc4(&
      &23)+acc4(24)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram4_sign, shift => diagram4_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd4h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d4
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k2
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d4 = 0.0_ki
      d4 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d4, ki), aimag(d4), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd4h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d4
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k2
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d4 = 0.0_ki
      d4 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d4, ki), aimag(d4), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d4h8l1
