module     ugaau_d67h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d67h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd67h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc67(25)
      complex(ki) :: Qspk5
      complex(ki) :: Qspk4
      complex(ki) :: Qspvak1e3
      complex(ki) :: Qspvak1e2
      complex(ki) :: Qspvak4k5
      complex(ki) :: Qspe3
      complex(ki) :: Qspe2
      complex(ki) :: Qspk3
      complex(ki) :: Qspk2
      complex(ki) :: Qspk1
      complex(ki) :: Qspe4
      complex(ki) :: QspQ
      complex(ki) :: Qspvae4k5
      Qspk5 = dotproduct(Q,k5)
      Qspk4 = dotproduct(Q,k4)
      Qspvak1e3 = dotproduct(Q,spvak1e3)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      Qspvak4k5 = dotproduct(Q,spvak4k5)
      Qspe3 = dotproduct(Q,e3)
      Qspe2 = dotproduct(Q,e2)
      Qspk3 = dotproduct(Q,k3)
      Qspk2 = dotproduct(Q,k2)
      Qspk1 = dotproduct(Q,k1)
      Qspe4 = dotproduct(Q,e4)
      QspQ = dotproduct(Q,Q)
      Qspvae4k5 = dotproduct(Q,spvae4k5)
      acc67(1)=abb67(5)
      acc67(2)=abb67(6)
      acc67(3)=abb67(7)
      acc67(4)=abb67(8)
      acc67(5)=abb67(9)
      acc67(6)=abb67(10)
      acc67(7)=abb67(11)
      acc67(8)=abb67(12)
      acc67(9)=abb67(13)
      acc67(10)=abb67(14)
      acc67(11)=abb67(15)
      acc67(12)=abb67(18)
      acc67(13)=abb67(20)
      acc67(14)=abb67(21)
      acc67(15)=abb67(22)
      acc67(16)=acc67(2)*Qspk5
      acc67(17)=acc67(11)*Qspk4
      acc67(18)=Qspvak1e3*acc67(7)
      acc67(19)=Qspvak1e2*acc67(10)
      acc67(20)=Qspvak4k5*acc67(4)
      acc67(21)=Qspe3*acc67(9)
      acc67(22)=Qspe2*acc67(8)
      acc67(23)=Qspk3*acc67(15)
      acc67(24)=Qspk2*acc67(13)
      acc67(25)=Qspk1*acc67(12)
      acc67(16)=acc67(25)+acc67(24)+acc67(23)+acc67(22)+acc67(21)+acc67(20)+acc&
      &67(19)+acc67(18)+acc67(17)+acc67(16)+acc67(3)
      acc67(16)=Qspe4*acc67(16)
      acc67(17)=-mu2+QspQ
      acc67(17)=acc67(6)*acc67(17)
      acc67(18)=acc67(5)*Qspk4
      acc67(19)=acc67(14)*Qspk5
      acc67(20)=Qspvae4k5*acc67(1)
      brack=acc67(16)+acc67(17)+acc67(18)+acc67(19)+acc67(20)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram67_sign, shift => diagram67_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd67h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d67
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = -k5
      Q(1)  =cmplx(real(-Q_ext(4)  -qshift(0),  ki_sam),aimag(-Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(-Q_ext(1:3)-qshift(1:3),ki_sam),aimag(-Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d67 = 0.0_ki
      d67 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d67, ki), aimag(d67), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd67h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d67
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = -k5
      Q(:)  =cmplx(real(-Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d67 = 0.0_ki
      d67 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d67, ki), aimag(d67), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d67h8l1
