module     ugaau_d9h8l1
   ! file: /.th/pcl340/scratch/gosam/greiner/ug_aau/helicity8d9h8l1.f90
   ! generator: buildfortran.py
   use ugaau_config, only: ki
   use ugaau_util, only: cond
   implicit none
   private
   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ function brack_1:
   pure function brack_1(Q,mu2) result(brack)
      use ugaau_model
      use ugaau_kinematics
      use ugaau_color
      use ugaau_abbrevd9h8
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      complex(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: acc9(23)
      complex(ki) :: Qspvak1e4
      complex(ki) :: Qspvak1e2
      complex(ki) :: Qspvak5k3
      complex(ki) :: Qspvak3k5
      complex(ki) :: Qspe4
      complex(ki) :: Qspe2
      complex(ki) :: Qspk5
      complex(ki) :: Qspk4
      complex(ki) :: Qspk3
      complex(ki) :: Qspk2
      complex(ki) :: Qspk1
      Qspvak1e4 = dotproduct(Q,spvak1e4)
      Qspvak1e2 = dotproduct(Q,spvak1e2)
      Qspvak5k3 = dotproduct(Q,spvak5k3)
      Qspvak3k5 = dotproduct(Q,spvak3k5)
      Qspe4 = dotproduct(Q,e4)
      Qspe2 = dotproduct(Q,e2)
      Qspk5 = dotproduct(Q,k5)
      Qspk4 = dotproduct(Q,k4)
      Qspk3 = dotproduct(Q,k3)
      Qspk2 = dotproduct(Q,k2)
      Qspk1 = dotproduct(Q,k1)
      acc9(1)=abb9(5)
      acc9(2)=abb9(6)
      acc9(3)=abb9(7)
      acc9(4)=abb9(8)
      acc9(5)=abb9(9)
      acc9(6)=abb9(10)
      acc9(7)=abb9(14)
      acc9(8)=abb9(19)
      acc9(9)=abb9(22)
      acc9(10)=abb9(24)
      acc9(11)=abb9(25)
      acc9(12)=abb9(28)
      acc9(13)=Qspvak1e4*acc9(4)
      acc9(14)=Qspvak1e2*acc9(1)
      acc9(15)=Qspvak5k3*acc9(2)
      acc9(16)=Qspvak3k5*acc9(6)
      acc9(17)=Qspe4*acc9(5)
      acc9(18)=Qspe2*acc9(3)
      acc9(19)=Qspk5*acc9(10)
      acc9(20)=Qspk4*acc9(12)
      acc9(21)=Qspk3*acc9(9)
      acc9(22)=Qspk2*acc9(8)
      acc9(23)=Qspk1*acc9(11)
      brack=acc9(7)+acc9(13)+acc9(14)+acc9(15)+acc9(16)+acc9(17)+acc9(18)+acc9(&
      &19)+acc9(20)+acc9(21)+acc9(22)+acc9(23)
   end  function brack_1
!---#] function brack_1:
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use ugaau_groups, only: &
!           & sign => diagram9_sign, shift => diagram9_shift
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd9h8
      implicit none
      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d9
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(0:3) :: qshift
      qshift = k3+k5
      Q(1)  =cmplx(real(+Q_ext(4)  -qshift(0),  ki_sam),aimag(+Q_ext(4)),  ki)
      Q(2:4)=cmplx(real(+Q_ext(1:3)-qshift(1:3),ki_sam),aimag(+Q_ext(1:3)),ki)
      mu2    = cmplx(real(mu2_ext, ki), aimag(mu2_ext), ki)
      d9 = 0.0_ki
      d9 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d9, ki), aimag(d9), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use ugaau_globalsl1, only: epspow
      use ugaau_kinematics
      use ugaau_abbrevd9h8
      implicit none
      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d9
      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      complex(ki) :: mu2
      real(ki), dimension(4) :: qshift
      qshift = k3+k5
      Q(:)  =cmplx(real(+Q_ext(:)  -qshift(:),  ki_gol), 0.0_ki_gol, ki)
      mu2  = cmplx(real(mu2_ext, ki), 0.0_ki, ki)
      d9 = 0.0_ki
      d9 = (cond(epspow.eq.0,brack_1,Q,mu2))
      numerator = cmplx(real(d9, ki), aimag(d9), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module ugaau_d9h8l1
